2001-06-01  Peter Stephenson  <pws@csr.com>

	* Andrej: can't find the number: improved 14644.

	* 14660: Etc/zsh-development-guide: can't use autoconf 2.50 yet.

2001-06-01  Oliver Kiddle  <opk@zsh.org>

	* 14658: Base/Utility/_arguments, Base/Utility/_values: correctly
	handle argument to -O option

2001-06-01  Peter Stephenson  <pws@csr.com>

	* 14651: Doc/Zsh/builtins.yo: add fix for 14597 in one other place.

	* 14646: LICENCE, Etc/FEATURES, Etc/MACHINES: `final' tweaks for
	4.0.1.

	* 14644: configure.in: only undefine M4 macros if they are
	defined, since new autoconf complains.  Undefining the macros
	in question is probably only a historical curiosity.

2001-06-01  Clint Adams  <clint@zsh.org>

	* 14635: Completion/Unix/Command/_gdb: presume
	'*core' glob for coredump files.

2001-06-01  Sven Wischnowsky  <wischnow@zsh.org>

	* 14630: Src/Zle/computil.c: fix for exclusion of normal
	arguments

2001-06-01  Andrej Borsenkow  <bor@zsh.org>

	* unposted: Etc/MACHINES: Cygwin belongs now to Red Hat. Mention
	the release where everything appears to work for the first time.

2001-06-01  Tanaka Akira  <akr@zsh.org>

	* 14628: Completion/Unix/Command/_ruby: new completion function.

2001-05-31  Sven Wischnowsky  <wischnow@zsh.org>

	* 14607: Completion/Base/Utility/_arguments, Src/Zle/computil.c:
	fix tag-order problem with _arguments (completion after an
	option that gets an argument in the same word); and a fix for
	completion after -ab, where -a gets an argument in the next
	word and -b gets one in the same word

2001-05-31  Oliver Kiddle  <opk@zsh.org>

	* unposted: Doc/Makefile.in, Doc/Zsh/compsys.yo: correct alphabetical
	ordering of lists of styles, tags, completion functions and modules

2001-05-31  Peter Stephenson  <pws@csr.com>

	* as per 14577 from Bart: README, INSTALL: we don't support
	--enable-omit-modules any more; a few more changes since 3.0.

2001-05-31  Sven Wischnowsky  <wischnow@zsh.org>

	* 14605: Src/params.c, Src/Modules/parameter.c,
	Src/Zle/complete.c, Src/Zle/computil.c, Src/Zle/zleparameter.c:
	fix two memory leaks (at least I hope they are fixed) and some
	out-of-bound array accesses, plus some defensive programming
	for heap allocated param structs

	* 14602: Completion/Base/Utility/_values,
	Functions/Misc/nslookup: better prompt matching in nslookup;
	fix separator handling in _multi_parts

	* 14599: Completion/Base/Utility/_multi_parts: always use
	supplied matchers

2001-05-31  Bart Schaefer  <schaefer@zsh.org>

	* 14597: Doc/Zsh/builtins.yo: Back out 12724; instead, insert a
	space on a line between paragraphs to prevent yodl from treating
	it as paragraph break.  Still a hack, but a better hack.

2001-05-30  Peter Stephenson  <pws@csr.com>

	* 14573: INSTALL, README, Doc/Zsh/builtins.yo, Test/README,
	Util/helpfiles:  documentation changes for 4.0.1 for clarity,
	plus avoid buggy nroff wrap in read builtin.

2001-05-30  Bart Schaefer  <schaefer@zsh.org>

	* 14516: Use the same ncurses compilation test in gettermcap() as
	was already used in echotc().  This needs more work, hence the
	delay in getting it committed.

2001-05-30  Oliver Kiddle  <opk@zsh.org>

	* 14567: Completion/Unix/Command/_pine,
	Completion/Zsh/Command/.distfiles, Completion/Zsh/Command/_echotc,
	Completion/Zsh/Command/_echoti: new echoti completion, update
	echotc completion and update _pine to reflect pine 4.33

	* 14563: Etc/MACHINES: IRIX 5.3 fails & other updates

2001-05-30  Andrej Borsenkow  <bor@zsh.org>

	* 14566: Test/C02cond.ztst: more testing for unimplemented
	features.

	* 14557: INSTALL: remove 3.1 version number

2001-05-30  Sven Wischnowsky  <wischnow@zsh.org>

	* 14558: Completion/Base/Widget/_correct_word,
	Completion/Base/Widget/_expand_word: some cleanup

2001-05-30  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* unposted: Zsh/Doc/metafaq.yo: make line spacing consistent.

2001-05-29  Clint Adams  <clint@zsh.org>

	* 14553: Src/Zle/zle_hist.c: fix thinko

	* 14552: Src/Zle/zle_hist.c: repeat last vi history search
	if search string is empty.

2001-05-29  Oliver Kiddle  <opk@zsh.org>

	* unposted: Completion/compdump, Completion/BSD/Command/_cvsup,
	Completion/Base/Completer/_approximate,
	Completion/Base/Completer/_menu, Completion/Base/Core/_tags,
	Completion/Base/Utility/_multi_parts,
	Completion/Base/Utility/_regex_arguments,
	Completion/Base/Utility/_sep_parts, Completion/Redhat/Command/_rpm,
	Completion/Unix/Command/_apm, Completion/Unix/Command/_cvs,
	Completion/Unix/Command/_enscript,
	Completion/Unix/Command/_imagemagick, Completion/Unix/Command/_java,
	Completion/Unix/Command/_ls, Completion/Unix/Command/_mount,
	Completion/Unix/Command/_pbm, Completion/Unix/Command/_perl,
	Completion/Unix/Command/_prcs, Completion/Unix/Command/_ssh,
	Completion/Unix/Command/_telnet, Completion/Unix/Command/_wget,
	Completion/Unix/Type/_path_files, Completion/Zsh/Command/_bindkey,
	Completion/Zsh/Command/_hash, Completion/Zsh/Command/_which,
	Doc/Zsh/compsys.yo, Doc/Zsh/expn.yo, Doc/Zsh/func.yo,
	Doc/Zsh/mod_computil.yo, Doc/Zsh/params.yo, Functions/Misc/checkmail,
	Functions/Misc/zrecompile, Functions/Misc/zstyle+: spelling corrections

2001-05-29  Bart Schaefer  <schaefer@zsh.org>

	* 14545: INSTALL: Mention "make check" and its usage.

2001-05-29  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 14539: Completion/Debian/Command/_update-alternatives:
	Add support for rpm update-alternatives.

2001-05-29  Clint Adams  <clint@zsh.org>

	* 14541: %# with capabilities should prompt-expand to #
	iff (euid=0 or the Effective set is non-empty).

	* 14538: cleaner _perl_config_vars from Matt Zimmerman.

	* 14536: Completion/Debian/Command/_update-alternatives:
	loop for multiple --slaves thanks to Sven.

	* 14533: Completion/Debian/Command/_dpkg,
	Completion/Debian/Command/_update-alternatives:
	use "= ->" for states expecting positional
	parameters.

2001-05-29  Sven Wischnowsky  <wischnow@zsh.org>

	* 14530: Completion/compinit,
	Completion/Base/Completer/_expand_alias,
	Completion/Base/Core/_main_complete,
	Completion/Base/Widget/_bash_completions,
	Completion/Base/Widget/_complete_debug,
	Completion/Base/Widget/_complete_help,
	Completion/Base/Widget/_correct_word,
	Completion/Base/Widget/_expand_word,
	Completion/Base/Widget/_history_complete_word,
	Completion/Base/Widget/_next_tags: use `eval $_comp_setup' in
	all entry points of the completion system to not only set up
	the options, but also redirect stdin and ignore trap handlers
	for ZERR

	* 14524: Src/jobs.c: print at least a warning when disowning a
	stopped job

2001-05-28  Clint Adams  <schizo@debian.org>

	* 14517: Src/Builtins/rlimits.awk: fix glibc2.2.3
	handling.

	* 14513: Completion/Debian/Command/.distfiles,
	Completion/Debian/Command/_update_alternatives:
	completion for update-alternatives

	* 14512: Completion/Debian/Command/_dpkg: tweak --compare-versions
	behavior.

2001-05-28  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Src/Modules/zprof.c: Silence bogus compiler warnings
	about variables used when unitialized.

	* Andrej: 14501 (as tweaked by 14510): Fix device and FIFO tests
	for Cygwin and other platforms where they're not implemented or
	the testing user has insufficient permissions.

2001-05-28  Clint Adams  <clint@zsh.org>

	* 14509: Completion/Base/Core/_setup, Doc/Zsh/compsys.yo,
	Doc/Zsh/mod_complist.yo: clobber both ZLS_COLORS and ZLS_COLOURS
	during compinit, and slightly clarify this behavior in the
	documentation.

2001-05-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 14507: Src/Zle/compresult.c: fix for cursor positioning with
	that -y option of compctl (display strings)

	* 14504: Src/Modules/zprof.c: make the zprof wrapper function
	be more careful, avoiding almost all of the code when the
	module is being unloaded

	* 14503: Src/exec.c: another attempt at fixing the job problem
	from 14327; make execpline() reset list_pipe_job to zero if it
	would be set for a job started in the background

2001-05-27  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Etc/MACHINES: Mention failure of gcc 2.7.1 on HPUX,
	and need for --disable-lfs on Solaris 2.6.

2001-05-27  Clint Adams  <clint@zsh.org>

  	* 14492: Functions/Prompts/.distfiles,
	Functions/Prompts/prompt_clint_setup:
	additional prompt theme.

2001-05-26  Wayne Davison  <wayned@users.sourceforge.net>

	* 14488: Src/Zle/zle_hist.c: fixed accept-and-infer-next-history
	when called repeatedly.  Also made the infer actions and
	accept-line-and-down-history not get tripped up by transitory
	changes to the history data.

2001-05-26  Andrej Borsenkow  <bor@zsh.org>

	* 14489: Test/C02cond.ztst: workaround for (probably) find
	bug on ReliantUNIX made visible by 14484.

2001-05-25  Bart Schaefer  <schaefer@zsh.org>

	* 14484: Test/C02cond.ztst: Print a warning and skip the -b test
	if no block devices can be found (test only ! -b in that case).

2001-05-25  Clint Adams  <schizo@debian.org>

	* 14479: Completion/Debian/Command/_apt: add --reinstall.

2001-05-24  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* from Bart: Etc/FAQ.yo: changes for 4.0.1, already installed
	at http://sunsite.dk/zsh/FAQ/.

2001-05-23  Bart Schaefer  <schaefer@zsh.org>

	* 14461: Test/V01zmodload.ztst: Change the unloading test to be
	sure that modules are not unloaded until their dependencies have
	been unloaded.

2001-05-23  Oliver Kiddle  <opk@zsh.org>

	* unposted: Src/signals.c, Src/utils.c: add missing mod_exports

2001-05-22  Peter Stephenson  <pws@csr.com>

	* 14430: Test/ztst.zsh: Be less cavalier about exiting on failure
	so as to perform cleanup.

2001-05-21  Clint Adams  <clint@zsh.org>

	* 14419: Src/Builtins/rlimits.awk: handle glibc 2.2.3
	rlimits enum.

2001-05-21  Oliver Kiddle  <opk@zsh.org>

	* 14416: Completion/Base/Core/_tags: include + options for tag order

2001-05-21  Bart Schaefer  <schaefer@zsh.org>

	* 14411: Test/C02cond.ztst: Move chmod from 14408 into the %clean
	section so the right exit status is tested in the unmodish test.

2001-05-21  Clint Adams  <clint@zsh.org>

	* unposted: Completion/Unix/Type/_diff_options: quote $@
	in calls to _arguments.

2001-05-21  Oliver Kiddle  <opk@zsh.org>

	* 14409: Completion/Zsh/Command/_set: make use of _arguments in _set

2001-05-21  Peter Stephenson  <pws@csr.com>

	* unposted: Config/version.mk: 4.0.1-pre-5.
	
	* 14408: Test/C02cond.ztst: do chmod +w to work around rm -f
	problem in Cygwin.

	* unposted: Test/.distfiles: add Test/E01options.ztst.

2001-05-20  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 14396: Src/params.c, Test/D04paramater.ztst, Doc/Zsh/params.yo:
	Fix bug that though path/PATH etc. were unset as a pair, they
	didn't get recreated as a pair despite remaining special.  Add
	tests for this and fix in 14388.  Add documentation for special
	ties like path and PATH.

2001-05-20  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Test/ztst.zsh: Handle line wrapping in ZTST_hashmark.

2001-05-20  Andrej Borsenkow  <bor@zsh.org>

	* 14401: Makefile.in, configure.in, Config/config.mk,
	Config/installfns.sh, Doc/Makefile.in, Src/Makefile.in,
	Src/mkmakemod.sh: do not assume scripts are directly executable
	(they are not always on Cygwin) - use `sh script' instead

2001-05-20  Wayne Davison  <wayned@users.sourceforge.net>

	* last half of 14390: Src/params.c: Added some boundary checks
	to the array-assignment code.

2001-05-19  Wayne Davison  <wayned@users.sourceforge.net>

	* 14389: Src/hashtable.c, Src/hist.c: Don't call addhistnode()
	or removehashnode() on a HIST_TMPSTORE entry.  Don't merge a
	HIST_TMPSTORE entry with a previous "duplicate" line.

2001-05-18  Bart Schaefer  <schaefer@zsh.org>

	* 14388: Src/params.c, Src/subst.c: Correctly handle re-set of
	of integer-typed special parameters such as SHLVL, after unset.

	* 14385: Test/V01zmodload.ztst, Test/ztst.zsh: Fix typo in a
	comment; print a warning when unable to test zsh/example; make
	sure the file descriptor for that warning (and others in other
	test files) is available even if ZTST_verbose has an unexpected
	value.

2001-05-18  Peter Stephenson  <pws@csr.com>

	* not posted: Test/ztst.zsh, Test/E01options.ztst: added some more
	options; made ztst.zsh more robust about ksharrays being set by
	a test.

	* 14382: Src/module.c: zmodload -uf wouldn't work even if the
	math function hadn't been loaded yet.

2001-05-18  Sven Wischnowsky  <wischnow@zsh.org>

	* 14381: Src/subst.c: try to make ${(e)..} work for complicated
	parameter expansions in the value; this means: keep Qstring
	tokens unchanged if they are inside double quotes and
	tokenizing patterns in parameter expansions

2001-05-18  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Test/.distfiles, Test/V01zmodload.ztst: Add the basic
	tests of zmodload functionality.

2001-05-18  Clint Adams  <clint@zsh.org>

	* 14378: Completion/Unix/Type/_tex: also work for
	pdflatex, jadetex, and pdfjadetex.

2001-05-17  Tanaka Akira  <akr@zsh.org>

	* 14377: Completion/Unix/Command/_cvs: support new .cvspass format
	introduced by cvs-1.11.1.

2001-05-17  Peter Stephenson  <pws@csr.com>

	* 14376: Completion/Unix/Command/_lp: type with compset.

2001-05-17  Bart Schaefer  <schaefer@zsh.org>

	* 14375: Src/Zle/zle_main.c: Permit signals to be handled during
	read from the terminal in zleread().  (This changes only nested
	calls from widgets such as incremental search; signals were never
	queued for top-level reads.)

2001-05-16  Clint Adams  <clint@zsh.org>

	* 14361, 14362: Completion/Unix/Command/_modutils: use
	state for modprobe so that modprobe -r will
	complete multiple loaded modules.  Also
	handle more of modprobe's options.

2001-05-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 14359: Src/Zle/zle_tricky.c: more fixage for expansion: just
	convert the command line to the original when expansion
	shouldn't or couldn't do something sensible on the line

2001-05-15  Wayne Davison  <wayned@users.sourceforge.net>

	* 14357: Src/hashtable.c, Src/hist.c, Src/zsh.h, Doc/Zsh/options.yo:
	Added a "delayed drop" for ignored history entries.

2001-05-15  Oliver Kiddle  <opk@zsh.org>

	* 14355: Completion/Unix/Command/_modutils: fix bug where /sbin/lsmod
	was redirected in instead of being run

2001-05-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 14350: Completion/Base/Completer/_expand, Src/Zle/zle_tricky.c:
	don't remove single and double quotes that are inside parameter
	expansions; hopefully better handling of brace expansions in
	_expand

2001-05-15  Peter Stephenson  <pws@csr.com>

	* 14348: Src/builtin.c: some idiot forgot to make GLOBAL_EXPORT
	work with typeset -g.

2001-05-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 14346: Src/parse.c: calculate the length of the region to map
	(for mapped zwc files) correctly, including the
	offset-page-boundary-adjustment

2001-05-15  Clint Adams  <clint@zsh.org>

	* 14341: Completion/Unix/Command/.distfiles,
	Completion/Unix/Command/_modutils:
	complete loaded Linux kernel modules for
	rmmod or modprobe -r.

2001-05-14  Peter Stephenson  <pws@csr.com>

	* 14330: Completion/Base/Widget/_most_recent_file: handle filenames
	which need quoted characters better.

2001-05-14  Sven Wischnowsky  <wischnow@zsh.org>

	* 14327: Src/exec.c: set list_pipe_job only for real pipelines

2001-05-11  Peter Stephenson  <pws@csr.com>

	* 14314: Src/Modules/stat.c: writing const variable under cygwin.

	* 14313: Test/E01options.ztst, Test/ztst.zsh: new options tests.

2001-05-10  Wayne Davison  <wayned@users.sourceforge.net>

	* 14304: Src/hist.c: Fixed an obscure local-history bug that could
	make the "history" command output something that was slightly wrong.

2001-05-10  Andrej Borsenkow  <bor@zsh.org>

	* users/3872: Src/Modules/zftp.c: rename inet_* to avoid clash
	with Solaris 7 headers.

2001-05-10  Tanaka Akira  <akr@zsh.org>

	* 14295: Completion/Unix/Command/_cvs: support new cvs subcommands
	`rannotate' and `rlog' introduced by cvs-1.11.1.

2001-05-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 14293: Src/Zle/computil.c: barf if a empty string is given as
	one of the separators for _values

2001-05-09  Bart Schaefer  <schaefer@zsh.org>

	* unposted: configure.in: Clean up 14275+14290 a bit at Andrej's
	urging so as not to violate quite so many autoconf usage rules.

	* 14290: configure.in: Use a different cache variable for the
	Solaris-curses.h-mistake-fix from 14275.

2001-05-09  Oliver Kiddle  <opk@zsh.org>

	* 14266, 14283: Etc/FEATURES, StartupFiles/zshrc: update; in
	particular to use new style completion in example startup file.

	* 14282: Completion/Unix/Command/_chown: complete only files
	that can be chowned.

	* 14281: Completion/Base/Completer/_expand: insert redirection
	operators when expanding after a redirection operator.

2001-05-09  Peter Stephenson  <pws@csr.com>

	* unposted: Config/version.mk: 4.0.1-pre-4.

	* 14280: Doc/Zsh/options.yo: make clearer that GLOB_SUBST doesn't
	affect braces and commas.

	* unposted: back off 14140, since logically it implies tokenizing
	braces from parameters, which opens a whole new kettle of worms.

2001-05-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 14279: Doc/Zsh/compsys.yo: add description of how to add a
	auto-removable suffix when using a ->state action with _values

2001-05-08  Bart Schaefer  <schaefer@zsh.org>

	* 14275: configure.in, acconfig.h: Fix 14270 so that it works
	after config.cache has been loaded.

2001-05-08  Peter Stephenson  <pws@csr.com>

	* 14270: configure.in, acconfig.h: use TRY_COMPILE to check for
	curses.h because SunOS 5.8 produces warnings which cause
	HAVE_CURSES_H not to be defined.

2001-05-08  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Completion/Zsh/Context/_subscript: Remove unnecessary
	`*' from a pattern.

2001-05-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 14257: Completion/Base/Utility/_values, Doc/Zsh/compsys.yo,
	Src/Zle/computil.c: add -S option to specify separator between
	values and their arguments; make _values add the
	value-separator as a suffix for most types of actions

2001-05-08  Oliver Kiddle  <opk@zsh.org>

	* 14256: Completion/Zsh/Context/_subscript: fix minor mistake

	* 14255: Completion/X/Command/_vnc: fix guard for display numbers

2001-05-08  Peter Stephenson  <pws@csr.com>

	* Andrej: 14248: Src/Modules/zpty.c, Test/comptest: don't use
	O_NOCTTY in one case for zpty on cygwin, remove incorrect flag for
	no blocking with zpty in comptest.

2001-05-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 14252: Completion/Base/Core/_description, Doc/Zsh/compsys.yo:
	empty description means: don't add a -X option

	* 14251: Src/Zle/complist.c, Src/Zle/zle_tricky.c: print
	space/backspace when reaching the last column while printing
	descriptions and the like to avoid a cursor positioning bug
	depending on the kind of terminal (autowrap)

2001-05-07  Sven Wischnowsky  <wischnow@zsh.org>

	* 14240: Completion/Unix/Type/_files: double all backslashes
	before colons in the original pattern

2001-05-06  Bart Schaefer  <schaefer@zsh.org>

	* 14235: Completion/Zsh/Context/_subscript: Improve handling of
	b/n/s subscript flags.

	* 14234: Src/Zle/computil.c: Prevent "no multi-letter values"
	error on values of '\:' and '' in compvalues().

2001-05-05  Bart Schaefer  <schaefer@zsh.org>

	* 14230: Completion/Zsh/Context/_subscript: Fix flag descriptions.

2001-05-04  Oliver Kiddle  <opk@zsh.org>

	* 14227: Completion/Zsh/Context/_subscript: Complete subscript flags.

2001-05-04  Bart Schaefer  <schaefer@zsh.org>

	* 14224: Completion/Unix/Commmand/_cvs: Complete path prefixes for
	subcommands where file completion must reference CVS/Entries.

2001-05-04  Oliver Kiddle  <opk@zsh.org>

	* 14219: Completion/Zsh/Command/_bindkey: update for bindkey
	changes in 14046

2001-05-03  Bart Schaefer  <schaefer@zsh.org>

	* 14217: Completion/Unix/Type/_files: Fix processing of the -F
	option so that it doesn't stomp on other options.

2001-05-03  Oliver Kiddle  <opk@zsh.org>

	* 14216: Completion/Unix/Command/.distfiles,
	Completion/Unix/Command/_loadkeys, Completion/Unix/Command/_lp,
	Completion/Unix/Command/_pbm, Completion/Unix/Command/_w3m: minor
	completion changes

2001-05-03  Sven Wischnowsky  <wischnow@zsh.org>

	* 14214: Src/Zle/computil.c: ignore errors when removing quotes

2001-05-02  Bart Schaefer  <schaefer@zsh.org>

	* 14206: configure.in: Fix bug introduced by 14177; also, only
	check for curses headers when linking against the curses library.

2001-05-02  Clint Adams  <clint@zsh.org>

	* 14208: Completion/Unix/Command/_loadkeys: support Solaris
	loadkeys.

	* 14201: Completion/Unix/Command/_loadkeys: completion for
	loadkeys.

2001-05-02  Peter Stephenson  <pws@csr.com>

	* 14140: Src/glob.c:  v='A,B'; print X{$~v}Y  now prints XAY XBY.

2001-05-02  Sven Wischnowsky  <wischnow@zsh.org>

	* 14198: Src/Zle/computil.c: remove quotes when looking at
	arguments in comparguments

	* 14197: Completion/Base/Completer/_expand: missing star in
	suffix-style test pattern

2001-05-01  Peter Stephenson  <pws@csr.com>

	* 14181: Src/params.c: follow-up to 14151: use BDIGBUFSIZE in
	two other places.

2001-05-01  Bart Schaefer  <schaefer@zsh.org>

	* 14177: configure.in: Add --with-curses-terminfo to force search
	order for tgetent and search for tigetstr.  Reorder some other
	options and reword their help messages.

2001-04-30  Bart Schaefer  <schaefer@zsh.org>

	* 14169: configure.in: Improve some AC_TRY_LINK tests so that they
	can't accidentally succeed because of a compiler that optimizes
	away unreferenced variables.

2001-04-30  Sven Wischnowsky  <wischnow@zsh.org>

	* 14160: Completion/Base/Completer/_expand: fixlet for the test
	for the suffix style; if word contains only a tilde, don't try
	to expand it

2001-04-30  Andrej Borsenkow  <bor@zsh.org>

	* Bart: 14144 (modified): Src/Modules/stat.c: The S_IXUSR,
	S_IXGRP, S_IXOTH are made external variables in Cygwin 1.3.1 and
	cannot be used as static array initializer anymore.

2001-04-29  Bart Schaefer  <schaefer@zsh.org>

	* users/3837: Completion/compinit: Add `NO_kshglob' to
	$_comp_options.

2001-04-28  Bart Schaefer  <schaefer@zsh.org>

	* 14151: Src/params.c, Src/subst.c, Src/system.h: BDIGBUFSIZE is
	the space needed to print a number converted to binary.

2001-04-27  Sven Wischnowsky  <wischnow@zsh.org>

	* 14133: Completion/Base/Completer/_expand,
	Completion/Unix/Type/_path_files, Doc/Zsh/compsys.yo: try to
	improve testing for suffix style in _expand; make _path_files
	fail to complete words like ...<pat>..<param-subst>...

2001-04-26  Bart Schaefer  <schaefer@zsh.org>

	* 14129: Completion/Base/Completer/_approximate: Use a trap to
	unfunction the `compadd' function so that it can be correctly
	removed in the event that the competion system is interrupted by
	a keyboard signal.

2001-04-26  Clint Adams  <clint@zsh.org>

	* 14125: Src/Modules/termcap.c, Src/Modules/terminfo.c:
	remove static incleanup flag since it is not used.

	* 14123: acconfig.h, configure.in, Src/Modules/termcap.c:
	don't include curses.h in termcap.c if term.h doesn't need it.

2001-04-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 14117: Completion/Base/Utility/_arguments, Doc/Zsh/compsys.yo:
	tweak to make single-letter options only be completed after an
	option with an argument if the -W option is given

2001-04-26  Bart Schaefer  <schaefer@zsh.org>

	* 14108: Src/Modules/termcap.c: Don't define USES_TERM* if the
	corresponding HAVE_TERM* constants are not defined.

2001-04-26  Oliver Kiddle  <opk@zsh.org>

	* 14112: Completion/Base/Utility/.distfiles,
	Completion/Unix/Command/_pine, Completion/X/Command/.distfiles,
	Completion/X/Command/_vnc: new _vnc and use of new _guard in _pine

2001-04-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 14107: Completion/compaudit, Completion/compinstall,
	Doc/Zsh/compsys.yo: handle sub-sub-directories of $_compdir as
	in the CVS-layout

	* 14105: Completion/Base/Utility/_arguments,
	Completion/Base/Utility/_guard,
	Completion/X/Utility/_x_arguments,
	Completion/X/Utility/_xt_arguments, Doc/Zsh/compsys.yo,
	Src/Zle/computil.c: rename -W option to -w, add new -W option
	which makes _arguments complete options even after options that
	get their argument in the same word; new _guard function for
	conditionally displaying messages

	* 14092: Completion/Base/Completer/_expand: make keep-prefix
	keep everything up to the first component with a parameter
	expansion, not only if that is at the beginning of the string

2001-04-25  Sven Wischnowsky  <wischnow@zsh.org>

	* 14089: Src/Zle/computil.c: fix a sizeof() to strlen(). ahem.

2001-04-23  Bart Schaefer  <schaefer@brasslantern.com>

	* 14081: configure.in, Src/termcap.c, Src/terminfo.c: Fix linking
	yet again in the wake of 14077.  Disables echoti and the terminfo
	parameter on systems that have the old termcap, because otherwise
	the main zsh may be unnecessarily linked with curses even when the
	zsh/terminfo module is not in use.

	* 14080: Src/glob.c, Src/params.c, Src/subst.c, Src/zsh.h,
	Test/D06subscript.ztst: Optimize subscript parsing slightly by
	passing down an indication of whether the expression is in double
	quotes; fail noisily rather than silently on certain illegal
	associative array assignments; still more subscripting tests.

2001-04-23  Clint Adams  <schizo@debian.org>

	* 14078: Doc/Zsh/mod_termcap.yo, Doc/Zsh/mod_terminfo.yo:
	Document $termcap, change reference to termcap/terminfo
	'strings' to 'values'.

2001-04-23  Andrej Borsenkow  <bor@zsh.org>

	* 14077 : acconfig.h, aczsh.m4, configure.in, Config/defs.mk.in,
	Src/Makefile.in, Src/mkmakemod.sh, Src/zsh.mdd, Src/Modules/cap.mdd,
	Src/Modules/termcap.mdd, Src/Modules/terminfo.mdd,
	Src/Modules/zftp.mdd: revert Clint's build patches. They break
	build on ReliantUNIX and need some more consideration.

2001-04-23  Bart Schaefer  <schaefer@zsh.org>

	* 14070: Src/lex.c, Src/params.c, Test/D06subscript.ztst: Fix
	problem with parsing \" in subscripts during parameter expansion
	in double-quotes.

2001-04-22  Bart Schaefer  <schaefer@zsh.org>

	* 14066: Doc/Zsh/expn.yo, Doc/Zsh/params.yo, Src/params.c,
	Test/D06subscript.ztst: Document subscript usage; fix minor bug in
	(kK) subscript flags, and add a test for it.

2001-04-22  Clint Adams  <schizo@debian.org>

	* 14065: Src/params.c, Src/Modules/termcap.c,
	Src/Modules/terminfo.c: handle numeric capabilities
	properly within the termcap/terminfo parameters.

2001-04-21  Bart Schaefer  <schaefer@zsh.org>

	* 14062: Src/Modules/termcap.c: Avoid including both old-style
	termcap.h and ncurses term.h at the same time (see 13965).

	* 14060: Src/builtin.c, Src/lex.c, Src/params.c,
	Test/D06subscript.ztst: Fix problem with ${array[ix]=value}
	introduced by 14008; fix long-standing problems with
	`noglob typeset array[ix]=value' and `typeset 12foo=bar';
	fix parsing problem with ((\[ ...)) introduced by 14051.

2001-04-20  Clint Adams  <schizo@debian.org>

	* 14055: Src/Modules/termcap.c: include termio.h if available.
	This prevents Solaris 8 from choking on term.h.

	* 14053: Src/Modules/termcap.c, Src/Modules/termcap.mdd:
	add ${termcap} special parameter in the style of ${terminfo}.

2001-04-19  Bart Schaefer  <schaefer@zsh.org>

	* 14008, 14051: Src/lex.c, Src/math.c, Src/params.c,
	Test/D06subscript.ztst: Improve parsing of subscripts so that
	many forms that failed before, work now, particularly for assoc
	array keys; create a test suite.

	* 14008: Src/hist.c: Don't getsparam("HISTFILE") until it is
	actually needed, because other parameter expansions reset the
	history mechanism for subscript parsing.

	* 14008: Src/builtin.c: Keep track of the new Param created when
	typeset_single() calls setsparam() in some circumstances; drop a
	redundant isident() test.

2001-04-19  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 14046: Doc/Zle/zle.yo, Src/Zle/zle_keymap.c: bindkey -rp removes
	bindings with given prefix; minor bugfix for length of prefix with
	bindkey -p.  Also, don't bind cursor keystrings if they are just
	a single key.

2001-04-19  Clint Adams  <schizo@debian.org>

	* unposted: configure.in: make sure all the libraries are
	in for the function check.

	* 14041: configure.in, Config/defs.mk.in, Src/Makefile.in,
	Src/Modules/cap.mdd, Src/Modules/termcap.mdd,
	Src/Modules/terminfo.mdd, Src/Modules/zftp.mdd:
	only link modules against needed libraries.

	* 14039: configure.in, Config/defs.mk.in, Src/zsh.mdd,
	Src/Modules/cap.mdd, Src/Modules/termcap.mdd,
	Src/Modules/terminfo.mdd, Src/Modules/zftp.mdd:
	simulate old linking behavior.

	* 14033: acconfig.h, aczsh.m4, configure.in, Config/defs.mk.in,
	Src/Makefile.in, Src/mkmakemod.sh, Src/zsh.mdd,
	Src/Modules/cap.mdd, Src/Modules/termcap.mdd,
	Src/Modules/terminfo.mdd: only link modules and main binary
	against needed libraries.

2001-04-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 14028: Src/Zle/complete.mdd: use the right path patterns for
	completion functions

2001-04-19  Clint Adams  <schizo@debian.org>

	* 14018: Src/mkmakemod.sh: honor STRIPFLAGS when installing
	modules.

2001-04-18  Bart Schaefer  <schaefer@zsh.org>

	* 14004 (plus typo fix per Sven 14009): Improve completion in the
	tail of paths with a leading tilde-component, particularly with
	respect to nameddirs.

2001-04-17  Sven Wischnowsky  <wischnow@zsh.org>

	* 13999: Src/Zle/computil.c: only use the exclusion lists of
	options that are not currently being completed, but keep
	options from being completed more than once

	* 13997: Completion/Zsh/Type/_directory_stack: remove
	SUFFIX-handling, it's in _tilde and only needed there

2001-04-14  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Etc/zsh-development-guide: The entire section on hook
	functions was repeated twice; delete one copy.

2001-04-13  Oliver Kiddle  <opk@zsh.org>

	* 13982: Completion/Base/Utility/_multi_parts,
	Completion/Unix/Command/.distfiles, Completion/Unix/Command/_elm,
	Completion/Unix/Command/_mail, Completion/Unix/Command/_mutt,
	Completion/Unix/Command/_ncftp, Completion/Unix/Command/_pine:
	add completion for common MUAs and a couple of minor fixes

2001-04-13  Wayne Davison  <wayned@users.sourceforge.net>

	* 13981: Src/Modules/zftp.c: Don't define gethostbyname2()
	as static, since it can clash with the system header files
	on a system that provides the prototype but not the object.

2001-04-13  Bart Schaefer  <schaefer@zsh.org>

	* 13973: Completion/Unix/Type/_path_files: Parameter expansions
	are checked before tilde-expansions so that the former are handled
	properly when they appear in the same word as the latter.

	* 13972: Src/prototypes.h, Src/system.h, Src/Modules/termcap.c,
	Src/Modules/terminfo.c: Resolve assorted header file collisions,
	mostly for benefit of Solaris 2.6.

2001-04-12  Bart Schaefer  <schaefer@zsh.org>

	* 13965: Src/system.h, Src/prototypes.h, Src/Modules/terminfo.c:
	Use <term.h> for termcap protos when it is found but <termcap.h>
	is not; don't include <curses.h> unless it will be used.

2001-04-12  Clint Adams  <schizo@debian.org>

	* 13961: Src/prototypes.h: entertain the possibility that
	tputs is defined in term.h.

2001-04-12  Oliver Kiddle  <opk@zsh.org>

	* 13958: Completion/Zsh/Type/_directory_stack: a hopefully correct
	fix to avoid appending a / when called from _cd

	* unposted: Completion/Zsh/Command/.distfiles: missed change for 13947

2001-04-12  Clint Adams  <schizo@debian.org>

	* 13955: acconfig.h, configure.in, Src/Modules/terminfo.c:
	s/codes/names/.

	* 13953: acconfig.h, configure.in, Src/Modules/terminfo.c:
	have configure check for the existence of boolcodes,
	numcodes, and strcodes symbols, and presume that they
	are terminfo capability code inventories.

	* 13951: Src/Modules/terminfo.c: make scanterminfo do something
	so that ${(k)terminfo} and ${(kv)terminfo} work.

2001-04-11  Bart Schaefer  <schaefer@zsh.org>

	* 13949: Completion/Zsh/Type/_directory_stack: Don't append a slash
	when completing after [-+]*.
	
	* unposted: Functions/Misc/getjobs: Update comment to reflect
	change in preexec call signature from 13942.

	* unposted (see 13946): Functions/Prompts/prompt_bart_setup: Strip
	%[BSUbsu] from $PS1 when computing the width of the first line.

2001-04-11  Oliver Kiddle  <opk@zsh.org>

	* 13947: Completion/Zsh/Command/_fc, Completion/Zsh/Type/_aliases,
	Completion/Zsh/Type/_jobs_fg, Completion/Zsh/Command/_alias,
	Completion/Zsh/Command/_jobs_builtin: new _alias and _jobs_builtin

2001-04-11  Wayne Davison  <wayned@users.sourceforge.net>

	* 13942: Src/init.c, Doc/Zsh/func.yo: Fixed a bug in the
	calling of "preexec" to prevent the passing of the wrong
	history info as arg #1.  Added 2 extra args with expanded
	command info.  Documented the new calling syntax.

2001-04-11  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 13944: Src/Modules/mapfile.c (from Bart): dupstring the
	parameter name to avoid static buffer re-use problem.

2001-04-10  Wayne Davison  <wayned@users.sourceforge.net>

	* unposted: Src/hist.c: Slightly enhanced should_ignore_line()
	by using getjobtext() instead of getpermtext().

2001-04-09  Wayne Davison  <wayned@users.sourceforge.net>

	* 13934, 13936: Src/Modules/terminfo.c: silence some compiler
	warnings when HAVE_TIGETSTR is not defined.

2001-04-09  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Src/modules/terminfo.c: Unset the terminfo parameter
	on autoload when terminfo is not available, to suppress a warning
	about autoload failure.

	* 13931: Src/Modules/termcap.mdd, Src/Modules/terminfo.mdd: Fix
	`load' directives broken by 13922.

	* 13922: Src/Modules/termcap.c, Src/Modules/termcap.mdd,
	Src/Modules/terminfo.c, Src/Modules/terminfo.mdd: Loading these
	modules should work even if the corresponding library is not
	available; in that case echotc or echoti uses bin_notavail.

2001-04-09  Peter Stephenson  <pws@csr.com>

	* unposted: Config/version.mk: 4.0.1-pre-3.

2001-04-06  Bart Schaefer  <schaefer@zsh.org>

	* 13919: Completion/compinit: Clarify the prompt presented when
	 the completion system detects insecure files/directories.

2001-04-06  Sven Wischnowsky  <wischnow@zsh.org>

	* 13917: Src/params.c: test for unset in pipestatussetfn()

	* 13916: Src/params.c: like 13907, but for backward searches

2001-04-05 Felix Rosencrantz  <f_rosencrantz@yahoo.com>

	* workers/13914: Completion/Unix/Command/_java: Added call to
	_normal after class to run is specified for java, and added
	completion for files to extract for "jar -x".

2001-04-05  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Functions/Prompts/prompt_bart_setup: Better handling
	of long command strings, more efficient padding computation.

	* users/3795: Functions/Misc/getjobs: Insert history entries
	with the original job texts for jobs resumed with fg/bg/etc.

	* users/3401: Functions/Misc/promptnl: Finally added this
	function, with extensive additional comments on usage, etc.

2001-04-05  Clint Adams  <schizo@debian.org>

	* 13909: Completion/Base/.distfiles, Completion/X/.distfiles,
	Test/.distfiles: remove stray files with tildes.

2001-04-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 13908: Completion/Base/Utility/_arguments: complete only
	those single letter options with the right prefix character

	* 13907: Src/params.c: fix for forward subscripting of strings
	as second part of subscript ($a[x,(r)..])

2001-04-04  Sven Wischnowsky  <wischnow@zsh.org>

	* 13902: Completion/Base/Utility/_arguments,
	Completion/X/Utility/_x_arguments,
	Completion/X/Utility/_xt_arguments, Doc/Zsh/compsys.yo: add -W
	option to _arguments, which allows to complete options after
	options that take an argument in the next word

2000-04-03  Clint Adams  <schizo@debian.org>

	* 13899: Completion/Unix/Command/_apm: add $OSTYPE checking.

2001-04-03  Oliver Kiddle  <opk@zsh.org>

	* 13898, Bart: 13827: Completion/Zsh/Command/_ttyctl,
	Completion/Zsh/Command/_ulimit,	Completion/Zsh/Command/_vared:
	new completion functions
	
2001-04-03  Sven Wischnowsky  <wischnow@zsh.org>

	* 13892: Src/Zle/compmatch.c, Test/comptest, Test/ztst.zsh:
	two more places where fpaths to completion functions were used;
	follow-up on 13868, fix the fix

2001-04-02  Clint Adams  <schizo@debian.org>

	* 13889: Completion/Linux/_apm, Completion/Linux/.distfiles,
	Completion/Unix/Command/_apm, Completion/Unix/Command/.distfiles:
	Add OpenBSD 2.7 apm options.  Move to Unix/Command.

2001-04-02  Bart Schaefer  <schaefer@zsh.org>

	* 13887: Config/installfns.sh: Skip CVS subdirectories.

2001-04-02  Clint Adams  <schizo@debian.org>

	* 13884: Completion/Linux/_apm: Add FreeBSD 4.1 apm options.

2001-04-02  Sven Wischnowsky  <wischnow@zsh.org>

	* Config/installfns.sh, Src/zsh.mdd: more cleanup after
	function moving

	* unposted, kind of: moving functions and scripts around, renaming
	them, accidentally deleted them and re-installing them, etc.

	* 13868: Src/Zle/compmatch.c, Src/Zle/computil.c: make
	`_arguments -S' still complete long options after `--<TAB>';
	fix for cursor positioning with partial word match specs

2001-04-02  Clint Adams  <schizo@debian.org>

 	* 13866: Completion/Debian/_apt: complete a release
	name after apt-get install <pkgname>/.

	* 13864: Completion/Debian/_apt: complete a
	"release" name after apt-get -t.

2001-04-01  Oliver Kiddle  <opk@zsh.org>

	* 13863: Completion/Builtins/_bindkey, Completion/Builtins/_compdef,
	Completion/Builtins/_disable, Completion/Builtins/_emulate,
	Completion/Builtins/_enable, Completion/Builtins/_fc,
	Completion/Builtins/_hash, Completion/Builtins/_print,
	Completion/Builtins/_read, Completion/Builtins/_unhash,
	Completion/Builtins/_vars_eq, Completion/Builtins/_which,
	Completion/Builtins/_zcompile, Completion/Builtins/_zle,
	Completion/Builtins/_zpty, Completion/Builtins/_zstyle,
	Completion/User/_bison, Completion/User/_bzip2, Completion/User/_dirs,
	Completion/User/_fetchmail, Completion/User/_gzip,
	Doc/Zsh/builtins.yo, Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo,
	Doc/Zsh/expn.yo: various doc fixes and minor changes to completion
	functions, including use of -A "-*" and -S options to _arguments.

2001-04-01  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 13861: Completion/Linux/_apm: Completion for apm command (linux only).

2001-03-30  Clint Adams  <schizo@debian.org>

	* 13860: Completion/Debian/_deb_packages: caching layer support.

2001-03-30  Peter Stephenson  <pws@csr.com>

	* 13851: Src/signals.c, Src/exec.c: don't exec final command in
	in list if any traps are set, since we don't know whether we will
	need to handle them when that command exits.

2001-03-30  Bart Schaefer  <schaefer@zsh.org>

	* 13846: Test/ztst.zsh: When "make check" is run with output to a
	tty, print a hash mark approximately once per second during tests
	to provide a "progress bar".

	* 13845: Doc/Zsh/options.yo, Src/options.c: Refuse `setopt noexec'
	in interactive shells, except at startup with `zsh -n'.

2001-03-29  Peter Stephenson  <pws@csr.com>

	* 13838: Src/prompt.c: don't assume we can change the string
	returned by getsparam("HOST").

	* 13837: Src/builtin.c: disallow changing of parameter type
	for autoloadable parameter (bug 219459 on Sourceforge).

2001-03-29  Sven Wischnowsky  <wischnow@zsh.org>

	* 13833: Completion/Core/_expand: fix comparison of expansions
	with expanded prefix (missing quoting)

	* 13830: Completion/Core/_multi_parts: next try to get rid of
	empty strings being added as possible completion by
	_multi_parts

2001-03-28  Bart Schaefer  <schaefer@zsh.org>

	* 12724: Doc/Zsh/builtins.yo: Nobody has come up with a better fix
	for the misformatted manual page than this hack, so I've finally
	committed it.

2001-03-28  Peter Stephenson  <pws@csr.com>

	* 13818: Doc/Zsh/zle.yo, Src/Zle/zle_keymap,c. Src/Zle/zle_main.c
	[zle_main hunk got omitted from posted patch, oops]: Add
	`bindkey -p' to list bindings with a given prefix.

	* unposted: Doc/Zsh/zle.yo, Doc/Zsh/mod_zle.yo: move ZLE builtin
	documentation from mod_zle.yo to zle.yo.

2001-03-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 13815: Completion/Commands/_history_complete_word,
	Doc/Zsh/compsys.yo: more cleanup; simplify the stop
	and liststyles; try to make it obey whatever _main_complete
	says should be done (menu-wise)

	* 13814: Completion/User/_urls, Doc/Zsh/compsys.yo: replace
	`path' with more general `urls' style

	* 13813: Completion/Core/_multi_parts: make sure _multi_parts
	doesn't add the empty string as a possible completion

2001-03-28  Peter Stephenson  <pws@csr.com>

	* unposted: Completion/Commands/_complete_tag: mysterious extra
	blank line somehow crept in at critical point.

2001-03-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 13809: Completion/Base/_arguments: don't add options as
	completions if a `->state' action was used and we are
	directly after the option (in the same word)

2001-03-27  Sven Wischnowsky  <wischnow@zsh.org>

	* 13790: Completion/Base/_arguments, Completion/X/_x_arguments,
	Completion/X/_xt_arguments, Doc/Zsh/compsys.yo: make
	_arguments return 300 only if given the -R option

	* 13789: Completion/Base/_tilde, Completion/Builtins/_popd:
	comment out looking up the prefix-needed style when
	completing directory stack entries; make _tilde use _popd,
	finally

	* 3752: Completion/Commands/_history_complete_word,
	Src/Zle/compresult.c: try to make _h_c_w smarter at the
	beginning and end of the list; avoid list-beeping if the old
	completion list is re-used

2001-03-26  Clint Adams  <schizo@debian.org>

	* 13783 from Michal Politowski: Completion/Builtins/_pids:
	handle pids that don't have a preceding space in ps output.

	* 13779 from Michal Politowski: Completion/Commands/_complete_tag:
	typo fixes?

	* 13777: Src/Builtins/rlimits.awk: add maxfilelocks
	for glibc 2.2.

2001-03-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 13770: Src/Zle/computil.c: handle colons in xor lists

	* 13768: Completion/Core/_main_complete,
	Completion/Core/_setup: unset ZLS_COLORS if list-colors not
	set

	* 13767: Src/Zle/zle_utils.c: avoid adding empty strings to
	the kill ring

	* 13763: Completion/Builtins/_pids, Doc/Zsh/compsys.yo: _pids
	shouldn't start menu completion if the current word starts
	with a hyphen; typo fix in compsys.yo

2001-03-25  Bart Schaefer  <schaefer@zsh.org>

	* 13757: StartupFiles/zlogin, StartupFiles/zshenv,
	StartupFiles/zshrc:  Strongly discourage use of these files as
	/etc/z* drop-ins.

2001-03-25  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 13751: Completion/User/_cpio: added.

	* 13745: Test/ztst.zsh: set LC_COLLATE to C if already set to
	something.

	* 13743: Completion/User/_mailboxes: handle @folder in MH.

2001-03-24  Bart Schaefer  <schaefer@zsh.org>

	* 13746: Test/13parameter.ztst: Add tests for fixes from 13492.

	* 13744: Test/01grammar.ztst, Test/10prompt.ztst,
	Test/13parameter.ztst, Test/ztst.zsh: Delete or correct comments
	that refer to (non-)bugs or other confusion; enable another test;
	print the name of each test as it begins as well as when it ends.

	* 13740: Completion/User/_mailboxes: Fixes for mh (based on PWS's
	patch in 13737): handle sub-folders; handle +folder abbreviations;
	add commented-out lines that might eventually handle @folder, too.

2001-03-23  Bart Schaefer  <schaefer@zsh.org>

	* 13736: Test/01grammar.ztst: Enable more tests as they seem to
	work now; add regression test for the fix from 13706.

2001-03-23  Sven Wischnowsky  <wischnow@zsh.org>

	* 13733: Completion/Builtins/_pids: don't auto-start menu
	* completion after a `%' when completing pids or jobs

	* 13730: Completion/Core/_approximate: probably no reason to
	put the (#a?) flag after an initial tilde in _approximate
	anymore

	* 13727: Completion/User/_init_d, Completion/User/_make,
	Doc/Zsh/compsys.yo: add commands and call-command styles;
	mention some of the more expensive things about completion
	setup in the docs

	* 13725: Completion/Core/_all_labels,
	Completion/Core/_next_label: test if the colon is quoted

	* 13724: Completion/Core/_path_files: fixlet, complicated
	match specs could result in incorrect words being used as
	possible path expansions

2001-03-22  Peter Stephenson  <pws@csr.com>

	* 13676: Completion/User/_mh: some tweaks for nmh.

2001-03-22  Sven Wischnowsky  <wischnow@zsh.org>

	* 13706: Src/exec.c: skip redirections in execpline2() when
	looking for the command code

2001-03-21  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Functions/Prompts/prompt_bart_setup: Use the (S)
	flag on a parameter expansion to improve parsing of the PS1
	string when computing its visible length.

2001-03-20  Sven Wischnowsky  <wischnow@zsh.org>

	* 13674: Completion/User/_telnet: use -l as default for telnet's
 	without -\? option
	
	* 13673: Src/Modules/zprof.c: fix misaligned percent output of
 	zprof
	
2001-03-18  Clint Adams  <schizo@debian.org>

	* 13664: Completion/User/_init_d: handle rcS.d, force-restart,
	force-reload.  Also, remove Completion/SysV.

2001-03-18  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* From Zvi Har'El: unposted: Doc/Zsh/metafaq.yo: shorter
	address for Israeli mirror.

2001-03-18  Clint Adams  <schizo@debian.org>

	* 13662: Completion/Debian/_apt: new build-dep command
	in apt-get.

	* 13661: Completion/SysV/.distfiles,
	Completion/SysV/_sysv_initscripts: complete arguments
	for SysV initscripts.

2001-03-17  Bart Schaefer  <schaefer@zsh.org>

	* unposted (but see 13646 and users/3563): Doc/Zsh/contrib.yo,
	Functions/Misc/.distfiles, Functions/Misc/zkdb: Function to read
	keyboard sequences and save them in an associative array for later
	reference (much improved from posted version, which was broken).

2001-03-15  Peter Stephenson  <pws@csr.com>

	* users/3671: Completion/User/_java: complete in middle of
	-classpath etc., not just at end.
	
2001-03-15  Sven Wischnowsky  <wischnow@zsh.org>

	* user/3674: Src/Zle/complist.c: fix default colour for directories
	
2001-03-14  Peter Stephenson  <pws@csr.com>

	* 13633: Src/Zle/zle_keymap.c: lastest in saga: don't use
	termcap suggestion for keymap if it is a single key already bound
	by default (user bindings will take precedence anyway).

2001-03-13  Bart Schaefer  <schaefer@zsh.org>

	* Zvi Har'El: 13619: Completion/User/_rcs: Add the D qualifier
	when matching file names in the RCS subdirectory.

	* 13613, 13620: Completion/User/_ncftp, Completion/User/_lftp:
	Unify completion for ncftp and lftp in _ncftp (removed _lftp).

2001-03-13  Peter Stephenson  <pws@csr.com>

	* 13611, 13615: Doc/Zsh/zle.yo, Src/init.c, Src/zsh.h,
	Src/Zle/zle_keymap.c: Use termcap to find cursor sequences to
	bind; default to VT100.  If ^[[? or ^[O? is being bound, bind
	the other one too.  Also bind cursor keys in viins keymap.

2001-03-12  Oliver Kiddle  <opk@zsh.org>

	* 13610: INSTALL, README, Completion/Core/compinit,
	Completion/Core/compinstall, Doc/Zsh/builtins.yo, Doc/Zsh/compsys.yo
	Doc/Zsh/compwid.yo, Doc/Zsh/contrib.yo, Doc/Zsh/expn.yo,
	Doc/Zsh/options.yo, Doc/Zsh/zftpsys.yo, Etc/CONTRIBUTORS: spelling
	corrections and improve to wording

	* unposted: Completion/Commands/_complete_help: fix to declare tmp
	as a local variable

2001-03-12  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 13605: Completion/User/_tar, Completion/User/_tar_archive: New tar
	options -j.

2001-03-12  Oliver Kiddle  <opk@zsh.org>

	* unposted: Completion/User/_zip, Completion/User/_hosts: handle
	filenames containing spaces in zip archives and don't complete lftp
	from _hosts

2001-03-12  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 13601: Completion/User/_lftp: Add completion for lftp

2001-03-11  Oliver Kiddle  <opk@zsh.org>

	* 13600: Completion/Base/_subscript, Completion/Core/_files,
	Completion/Core/_tags,  Completion/User/.distfiles,
	Completion/User/_dir_list, Completion/User/_fetchmail,
	Completion/User/_hosts, Completion/User/_iconv, Completion/User/_mutt,
	Completion/User/_ncftp, Completion/User/_tar, Completion/User/_urls,
	Completion/User/_webbrowser, Completion/User/_wget,
	Completion/User/_xargs, Completion/User/_zip, Functions/Misc/mere:
	various new, improved, fixed or updated functions

2001-03-11  Bart Schaefer  <schaefer@zsh.org>

	* 13599: Completion/User/_sh: Use _normal completion following
	the name of a shell script.

	* 13598: Completion/Core/_expand: Handle quoted whitespace in
	glob expansions.

	* 13562: Functions/Zle/edit-command-line: Better handling of
	multi-line buffers, at the expense of an extra feep.

2001-03-08  Peter Stephenson  <pws@csr.com>

	* unposted: Config/version.mk: 4.0.1-pre-2.

	* unposted: Functions/Zle/.distfiles, Completion/Core/.distfiles,
	Completion/Base/.distfiles, Completion/User/.distfiles: dist more
	files.

2001-03-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 13591: Completion/User/_init_d: try to find out the sub commands
 	to complete in _init_d
	
2001-03-07 Felix Rosencrantz  <f_rosencrantz@yahoo.com>

	* 13590: Test/54compmatch.ztst: Added another test case
	that covers the bug mentioned in workers/13563.  The case
	is based on a bug mentioned in workers/13320.

2001-03-07  Sven Wischnowsky  <wischnow@zsh.org>

	* 13589: Src/mem.c, Src/parse.c, Src/zsh.h: two optimisations; use
 	a binary tree to avoid duplicate strings in ecstrcode(); keep a
 	pointer to newly allocated heaps to avoid having to search for a
 	heap with free space in most cases
	
2001-03-07  Andrej Borsenkow  <bor@zsh.org>

	* unposted: configure.in, aczsh.m4: support building with
	GCC on ReliantUNIX; use AC_TRY_COMMAND for better diagnostic

2001-03-06  Oliver Kiddle  <opk@zsh.org>

	* unposted: Completion/User/.distfiles, Completion/User/_webbrowser:
	include _w3m and don't complete w3m with _webbrowser

2001-03-06  Clint Adams  <schizo@debian.org>

	* unposted: Completion/User/_w3m: complete for w3m.

2001-03-06  Bart Schaefer  <schaefer@zsh.org>

	* 13583: Test/54compmatch.ztst: Tweak doc strings for accuracy.

2001-03-06  Sven Wischnowsky  <wischnow@zsh.org>

	* 13576: Src/lex.c, Src/parse.c: make the parser use real memory
 	for the ecbuf to avoid having hrealloc() throw away lots of memory
	
	* 13575: Src/Zle/compmatch.c: another fix for completion matching,
 	CLF_MISS in the wrong cline struct
	
2001-03-06  Andrej Borsenkow  <bor@zsh.org>

	* 13544, 13568 (Peter): Completion/Core/_ignored,
	Completion/Core/_main_complete, Completion/Core/_prefix,
	Completion/Core/compinstall, Doc/Zsh/compsys.yo: allow
	matchers in matcher-list to augment as well as replace
	previous matcher list

	* unposted: Etc/CONTRIBUTORS: use zsh.org mail address (courtesy
	of Geoff) for me :-)

2001-03-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 13566: Completion/Builtins/_aliases, Completion/Core/_expand_alias,
 	Doc/Zsh/compsys.yo: new _expand_aliases to, well, expand aliases
	
	* 13565: Src/Zle/compmatch.c, Src/Zle/compresult.c,
 	Test/54compmatch.ztst: fix for matching control, try harder to
 	merge separately completed parts to avoid losing user-typed
 	characters
	
2001-03-04  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Unposted: Etc/FAQ.yo: latest version.

	* Unposted: Etc/NEWS, Etc/CONTRIBUTORS: changes aimed at 4.0.1
	release.

2001-02-28  Bart Schaefer  <schaefer@zsh.org>

	* users/3649: Completion/Commands/_bash_completions,
	Completion/Commands/_complete_debug,
	Completion/Commands/_complete_help,
	Completion/Commands/_correct_word,
	Completion/Commands/_expand_word,
	Completion/Commands/_history_complete_word,
	Completion/Commands/_next_tags: Same as 13555 below, but for all
	the other places where $_comp_options was referenced.

2001-02-28  Oliver Kiddle  <opk@zsh.org>

	* 13555: Completion/Core/_main_complete: handle ksh_arrays on the
	setopt line to fix problem from users/3648

2001-02-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 13554: Completion/Core/compinit, Doc/Zsh/options.yo, Src/lex.c,
 	Src/options.c, Src/zsh.h, Src/Zle/compcore.c, Src/Zle/compctl.c,
 	Src/Zle/zle_tricky.c: add `aliases' option to be able to disable
 	alias expansion
	
2001-02-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 13536: Completion/Base/_sub_commands, Completion/Core/_normal,
 	Completion/User/_apachectl, Completion/User/_init_d: some small
 	functions for completing sub-commands (generic function, init
 	scripts, apachectl)
	
	* 13534: Completion/Builtins/_fc, Completion/Builtins/_hash,
 	Completion/Builtins/_source, Completion/Builtins/_which,
 	Completion/Builtins/_zftp, Completion/User/_man,
 	Completion/User/_nedit: change $words[1] to $service in some more
 	places
	
	* 13530: Src/hist.c: properly restore noaliases in bufferwords()
	
2001-02-22  Peter Stephenson  <pws@csr.com>

	* 13520: Completion/Builtin/_vars_eq: use $service to decide
	on service; shorten description to avoid dreaded 80-character
	redisplay bug.

2001-02-20  Sven Wischnowsky  <wischnow@zsh.org>

	* 13509: Src/jobs.c: more (|un)queue_signals(), this time for the
 	job control builtins
	
2001-02-19  Peter Stephenson  <pws@csr.com>

	* Alexandre: 13280: Doc/Zsh/expn.yo, Src/hist.c, Src/string.c,
	  Src/system.h:  More sh-like and path-like handling of colon
	  modifiers.

2001-02-17  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* unposted: Doc/Zsh/metafaq.yo: site name change from Geoff.

	* 13497: Src/pattern.c: `?##' didn't work.

2001-02-16  Bart Schaefer  <schaefer@zsh.org>

	* 13495: Follow-up to 13492 to un-break "${(A)=foo=$@}".

2001-02-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 13494: Completion/Core/compinit: make `compdef foo=bar' use the
 	service defined for `bar' if there is any
	
2001-02-16  Bart Schaefer  <schaefer@zsh.org>

	* 13492: Src/subst.c: Partial fix for ${1+"$@"} expanding to
	an array (still doesn't handle shwordsplit properly); fix so
	"${(A)foo=$@}" does *not* expand to an array, even though an
	array is assigned to $foo.

2001-02-14  Clint Adams  <schizo@debian.org>

	* unposted: Src/params.c: remove unused variable declaration.

	* 13478: Src/builtins.c: don't call dyncat with a NULL argument.

2001-02-14  Peter Stephenson  <pws@csr.com>

	* 13473: Makefile.in, Doc/Zsh/options.yo: small changes suggested
	in zsh-users/3524 for CSH_NULL_GLOB description and 13245 for
	cleaning config.modules.

2001-02-14  Clint Adams  <schizo@debian.org>

	* 13323: Functions/Zle/edit-command-line: handle
	multi-line buffers.

2001-02-13  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 13431: aczsh.m4,configure.in,Src/Modules/termcap.c,
	Src/Modules/termcap.mdd,Src/Modules/terminfo.c,
	Src/Modules/terminfo.mdd,Src/mkmakemod.sh: hopefully better
	check for shared libraries. Link in termcap/terminfo statically
	if shared libtermcap/libcurses unavailable

2001-02-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 13462: Src/Modules/zpty.c: try to make the -t option of zpty
 	smarter
	
	* 13459: Completion/Core/_path_files: wehn using glob_complete,
 	don't treat everything starting with a tilde as a pattern
	
2001-02-12  Bart Schaefer  <schaefer@zsh.org>

	* 13457: Completion/Core/compinit: Add `glob' to $_comp_options.

2001-02-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 13450: Completion/Core/_multi_parts: two small fixes to
 	_multi_parts; one more place where a caller-supplied -S can be
 	used and fix for the code deciding which prefix to use
	
2001-02-08  Oliver Kiddle  <opk@zsh.org>

	* 13448: Completion/User/.distfiles, Completion/User/_tin,
	Completion/User/_netscape, Completion/User/_newsgroups:
	add newsgroup completion

	* 13445: Completion/User/_gzip: fix to work for zcat again

2001-02-07  Bart Schaefer  <schaefer@zsh.org>

	* 13442: Test/Makefile.in, Test/comptest: Run zsh with +Z to
	prevent ZLE modules from being loaded before $module_path is
	changed to point at the test installation.

	* 13439: Test/Makefile.in: "make test" cleans up after killed
	tests.

2001-02-02  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* unposted: Src/mkmakemod.sh: patterns in 13412 were wrong.

2001-02-02  Sven Wischnowsky  <wischnow@zsh.org>

	* Peter: 13427: Completion/Core/_expand: fix for handling quoting
 	for filenames with weird characters

2001-02-01  Oliver Kiddle  <opk@zsh.org>

	* 13422: README, Completion/User/_urls, Doc/Zsh/manual.yo,
	Doc/Zsh/metafaq.yo, Etc/CONTRIBUTORS: refer to just sunsite.dk
	instead of sunsite.auc.dk

	* 13420: Completion/User/_tin: new completion function for tin

2001-01-31  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 13412: Src/mkmakemod.sh: avoid duplicate subdirectories in
	recursive build

2001-01-29  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* unposted: ChangeLog: typo in previous commit message

2001-01-28 Felix Rosencrantz  <f_rosencrantz@yahoo.com>

	* 13395: Test/54compmatch.ztst, Test/comptest: Added code to
	test compstate[insert_positions], value of insert_positions are
	now reported

2001-01-26  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 13389: Src/builtin.c: on Cygwin convert path to posix form in
	cd_do_chdir() to avoid dealing with drives letters

2001-01-25  Sven Wischnowsky  <wischnow@zsh.org>

	* 13388: Src/Zle/compmatch.c: fix for mergin two CLF_MID entries
 	in cline lists (with two equal prefixes it thought there were
 	characters missing)
	
	* 13384: Src/signals.c: make signal queueing variables be exported
 	to modules
	
2001-01-19  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 13370 (modified): Src/params.c: do not modify environment when
	importing it - some library functions may access it. When importing
	colon arrays, replenv() tried to free unallocated memory. Remove
	replenv() as it is now redundant.

	* 13380: configure.in: replace AC_CHECK_LIB(...,tgetent) with
	AC_SEARCH_LIBS(tgetent,...) to allow user to override default
	library selection

2001-01-18  Sven Wischnowsky  <wischnow@zsh.org>

	* 13374: Src/Zle/compcore.c, Src/Zle/compctl.c, Src/Zle/complist.c,
 	Src/Zle/compresult.c, Src/Zle/zle_main.c, Src/Zle/zle_tricky.c:
 	temporarily allow recursive completion when called from menu
 	selection

2001-01-18  Peter Stephenson  <pws@csr.com>

	* 13302: Functions/Zftp/zftp_progress: division by zero

2001-01-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 13365: Src/builtin.c, Src/exec.c, Src/glob.c, Src/hashtable.c,
 	Src/hist.c, Src/init.c, Src/input.c, Src/jobs.c, Src/math.c,
 	Src/mem.c, Src/module.c, Src/params.c, Src/parse.c, Src/prompt.c,
 	Src/signals.c, Src/signals.h, Src/subst.c, Src/utils.c,
 	Src/watch.c, Src/Modules/zftp.c, Src/Modules/zpty.c,
 	Src/Modules/zutil.c, Src/Zle/compcore.c, Src/Zle/complist.c,
 	Src/Zle/computil.c, Src/Zle/zle_main.c, Src/Zle/zle_tricky.c:
 	remove 13108 (trap queues); replace with signal queueing to ensure
 	that user signal handlers are only executed when it is safe to run
 	them
	
	* 13364: Src/Zle/compctl.c: fix for ol' compctl when completing
 	hash keys
	
2001-01-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 13349: Src/Zle/compmatch.c, Src/Zle/compresult.c: two more fixes
 	for completion matching and reporting interesting positions
	
	* Ulrik Haugen: 13344, 13347: Completion/User/_grep,
	Completion/User/_ls, Completion/User/_use_lo: add completion for
	ls and ([ef]|)grep
	
	* 13346: Completion/Bsd/_bsd_pkg, Completion/Bsd/_kld,
 	Completion/Core/_compalso, Completion/Core/_complete,
 	Completion/Core/_normal, Completion/Core/compdump,
 	Completion/Core/compinit, Completion/Debian/_apt,
 	Completion/Debian/_bug, Completion/Debian/_dpkg,
 	Completion/User/_bzip2, Completion/User/_chown,
 	Completion/User/_compress, Completion/User/_dvi,
 	Completion/User/_gzip, Completion/User/_imagemagick,
 	Completion/User/_ispell, Completion/User/_java,
 	Completion/User/_lp, Completion/User/_make,
 	Completion/User/_mount, Completion/User/_mysql_utils,
 	Completion/User/_pack, Completion/User/_pbm,
 	Completion/User/_psutils, Completion/User/_rcs,
 	Completion/User/_rlogin, Completion/User/_ssh,
 	Completion/User/_tiff, Completion/User/_yp, Completion/X/_xutils,
 	Doc/Zsh/compsys.yo: add `services', allowing easier re-use of
 	(parts of) completion functions (see also: 12977)
	
2001-01-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 13343: Src/Zle/compmatch.c, Src/Zle/compresult.c: fix for 13339
 	(report each position only once) and fixlet for matching: a case
 	where missing characters weren't remembered
	
2001-01-11  Sven Wischnowsky  <wischnow@zsh.org>

	* 13339: Doc/Zsh/compwid.yo, Doc/Zsh/contrib.yo,
 	Functions/Zle/cycle-completion-positions, Src/Zle/comp.h,
 	Src/Zle/complete.c, Src/Zle/compresult.c: add
 	unambiguous_positions and insert_positions keys to $compstate; use
 	them in the new cycle-completion-positions shell function widget

2001-01-10  Geoff Wing  <gcw@zsh.org>

	* unposted: Etc/MACHINES: format leading spaces to tabs

2001-01-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 13336: Src/Zle/compmatch.c, Src/Zle/compresult.c,
 	Test/54compmatch.ztst: fix cursor positioning with partial-word
 	match specs using `**'
	
2001-01-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 13331: Src/Zle/compcore.c, Src/Zle/compresult.c: fix for
 	listpacked for matches as long as screen is wide (minus added
 	spaces); more security when freeing matches: make sure current
 	menu match pointer isn't used afterwards
	
2001-01-07  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 13327: Etc/MACHINES: builds out of the box on SCO UnixWare
	2.1.3, reported by Josip Rodin <joy@cibalia.gkvk.hr>.

2000-12-27  Clint Adams  <schizo@debian.org>

	* 13315: Completion/User/_killall: strip parentheses and
	path heads.

	* 13314: Completion/User/_killall: ignore commands that begin
	with hyphens (login shells).

2000-12-26  Clint Adams  <schizo@debian.org>

	* 13312: Completion/User/_killall: get longer command names
	from procps.

2000-12-23  Clint Adams  <schizo@debian.org>

	* unposted: configure.in: thinko in jobtable size determination.

	* Chip Salzenberg: 13310: Completion/Debian/_apt:
	correct typo for apt-cache completion.

2000-12-17  Bart Schaefer  <schaefer@zsh.org>

	* Zefram: 13290: Src/Zle/zle_bindings.c, Src/Zle/zle_keymap.c:
	Back out 13285.

2000-12-17  Clint Adams  <schizo@debian.org>

	* 13288: Src/Modules/zftp.c: cast pointers when calling
	ztrapread and ztrapwrite.

	* 13287: Completion/Debian/_dpkg: complete multiple
	arguments for -i.

2000-12-16  Clint Adams  <schizo@debian.org>

	* unposted: Completion/User/.distfiles: add _mere

	* 13285: Src/Zle/zle_bindings.c, Src/Zle/zle_keymap.c:
	use vi-up-line-or-history and vi-down-line-or-history in
	the vicmd keymap (rather than their emacsy counterparts).

2000-12-15  Tanaka Akira  <akr@zsh.org>

	* 13281: Functions/Misc/mere: new implementation.
	Completion/User/_mere: new completion function for mere.

2000-12-13  Clint Adams  <schizo@debian.org>

	* 13250: Completion/User/.distfiles, Completion/User/_dict:
	completion for dict.

2000-12-06  Peter Stephenson  <pws@csr.com>

	* unposted: Src/jobs.c: rename waitjob() to zwaitjob() to avoid
	clash with IRIX system function.

2000-12-06  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 13243: Makefile.in: we do not use Makefile in Completion and
	Functions any more.

2000-12-05  Clint Adams  <schizo@debian.org>

	* 13242: Src/Modules/terminfo.c: better error-checking
	for non-existent capabilities referenced by $terminfo.

2000-12-05  Peter Stephenson  <pws@csr.com>

	* unposted: Config/version.mk: 3.1.9-dev-8.

	* 13233, 13234: Src/Modules/terminfo.mdd, Src/Modules/terminfo.c:
	fix name for configure variable; don't crash on Solaris if
	capability not found.

	* Joel Smith <jsmith@caldera.com>: 13230: Src/exec.c, Src/glob.c,
	Src/lex.c, Src/parse.c, Src/text.c, Src/zsh.h: avoid name clashes
	with Linux kernel.

2000-12-04  Bart Schaefer  <schaefer@zsh.org>

	* 13229: Doc/Makefile.in: Include mod_term*.yo in MODDOCSRC.

2000-12-04  Clint Adams  <schizo@debian.org>

	* 13227: configure.in, Src/Modules/terminfo.c,
	Src/Modules/terminfo.mdd: do not build terminfo
	module if tigetstr() is not found in the same library
	as tgetent(), indentation fix, use tputs() in echoti
	builtin for outputting string capabilities, use
	setupterm() for module boot.

2000-12-04  Peter Stephenson  <pws@csr.com>

	* 13226: configure.in, Config/defs.mk, Config/installfns.sh,
	Config/uninstallfns.sh, Src/zsh.mdd: fix --enable-function-subdirs
	for config.modules system; make Completion get its own functions
	subdirectory; tidy up other related bits.	

	* 13220: Doc/Zsh/params.yo: mention problems with $# e.g. `$#-'
	in arithmetic.

2000-12-03  Clint Adams  <schizo@debian.org>

	* 13216: Doc/Zsh/.distfiles, Doc/Zsh/builtins.yo,
	Doc/Zsh/mod_termcap.yo, Doc/Zsh/mod_terminfo.yo,
	Src/Modules/.distfiles: documentation for 13215.

	* 13215: Src/builtin.c, Src/Modules/termcap.c,
	Src/Modules/termcap.mdd, Src/Modules/terminfo.c,
	Src/Modules/terminfo.mdd: move echotc builtin to termcap
	module, add echoti builtin and terminfo parameter in
	terminfo module.

2000-11-30  Peter Stephenson  <pws@csr.com>

	* 13209: Makefile.in, configure.in, Config/funcinst.mk,
	Config/installfns.sh, Config/uninstallfns.sh, Src/zsh.mdd,
	Src/Modules/zftp.mdd, Src/Zle/complete.mdd, Src/Zle/zle.mdd:
	function installation information is now in config.modules.

2000-11-27  Bart Schaefer  <schaefer@zsh.org>

	* 13203: Completion/Builtins/_zstyle: Add missing quote.

2000-11-27  Sven Wischnowsky  <wischnow@zsh.org>

	* 13199: .cvsignore, Completion/User/_gprof: pattern-fix in
 	_gprof; add config.modules to .cvsignore
	
2000-11-27  Peter Stephenson  <pws@csr.com>

	* 13197: configure.in: fix problems with use of link parameter,
	directories for reading old config.modules file, and inconsistent
	values for auto parameter.

	* 13196: Etc/zsh-development-guide: Use of `either' keyword for
	`link' module parameter.

2000-11-26  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 13194: INSTALL, configure.in, Config/defs.mk.in,
	Etc/zsh-development-guide, Src/.distfiles, Src/Makefile.in,
	Src/Makemod.in.in, Src/mkbltnmlst.sh, Src/mkmakemod.sh,
	Src/zsh.mdd, Src/Builtins/rlimits.mdd, Src/Builtins/sched.mdd,
	Src/Modules/cap.mdd, Src/Modules/clone.mdd,
	Src/Modules/example.mdd, Src/Modules/files.mdd,
	Src/Modules/mapfile.mdd, Src/Modules/mathfunc.mdd,
	Src/Modules/parameter.mdd, Src/Modules/stat.mdd,
	Src/Modules/zftp.mdd, Src/Modules/zprof.mdd, Src/Modules/zpty.mdd,
	Src/Modules/zutil.mdd, Src/Zle/compctl.mdd, Src/Zle/complete.mdd,
	Src/Zle/complist.mdd, Src/Zle/computil.mdd, Src/Zle/deltochar.mdd,
	Src/Zle/zle.mdd, Src/Zle/zleparameter.mdd: New module
	configuration system using file config.modules set up by
	configure.

2000-11-25  Bart Schaefer  <schaefer@zsh.org>

	* 13192: Completion/Core/compinit, Src/params.c: Turn off
	ALL_EXPORT during completion; don't export arrays or hashes, even
	with ALL_EXPORT.

2000-11-22  Tanaka Akira  <akr@zsh.org>

	* 13181: Completion/Debian/_apt: add an action for _alternative.

2000-11-20  Bart Schaefer  <schaefer@zsh.org>

	* E. Jay Birkenbilt: 13171, 13172: Completion/User/_rlogin,
	Completion/User/_ssh: Don't autoremove a trailing `:' after
	completing a host name, but do autoremove a trailing `@' after
	completing a user name.

2000-11-15  Bart Schaefer  <schaefer@zsh.org>

	* 13167: Completion/User/_perl_modules: Avoid cd entirely.

2000-11-14  Bart Schaefer  <schaefer@zsh.org>

	* 13165 plus unposted: Completion/User/_perl_modules: `builtin cd'
	is better than chdir; make sure the variable name used for the cache
	has a leading underscore, but strip that off to get the name under
	which the cache is stored and retrieved; cache separately for each
	command basename (e.g., perl5.00405 v. perl5.00503), not just each
	full path name.
	
	* Paul Johnson: 13164: Completion/User/_perl_modules: If a full
	path was given for the command after which perl modules are being
	completed, look up and cache the modules under the full name; use
	chdir instead of cd in case of a function wrapper for cd.

2000-11-14  Sven Wischnowsky  <wischnow@zsh.org>

	* 13163: Src/Modules/zpty.c: don't be sure that read-ahead doesn't
 	contains nuls
	
2000-11-13  Peter Stephenson  <pws@csr.com>

	* unposted: config.sub, config.status: updated from GNU sources,
	incorporating existing changes for NetBSD.

2000-11-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 13156: Src/Modules/zpty.c: use unmetafy() to allow writing
 	special characters into a pty
	
2000-11-12  Clint Adams  <schizo@debian.org>

	* unposted: Completion/Debian/_bug: fix thinkos, add new options
	for reportbug.

	* unposted: Completion/Debian/_bug: complete files for --include=,
	completion for querybts.

2000-11-11  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 13109, 13111: Doc/Zsh/mod_zle.yo, Src/Zle/zle_main.c,
	Src/Zle/zle_thingy.c, Src/signals.c: `zle -I' allows trap code
	to clear up display when output occurs in a trap.

	* Sven: 13108: Src/Modules/zftp.c, Src/Modules/zpty.c,
	Src/Zle/zle_main.c, Src/builtin.c, Src/exec.c, Src/init.c,
	Src/input.c, Src/jobs.c, Src/signals.c, Src/signals.h,
	Src/utils.c, Src/zsh.h: Execute user traps synchronously if it is
	unsafe to execute it directly from the signal handler.

2000-11-09  Clint Adams  <schizo@debian.org>

	* 13125: Completion/User/_mailboxes: evaluate the mailboxes
	directives in muttrc, in case of backticks.

2000-11-08  Bart Schaefer  <schaefer@zsh.org>
	* 13140: Src/utils.c: Believe the non-error not-ready return value
	from select(), in read_poll().
	
2000-11-08  Sven Wischnowsky  <wischnow@zsh.org>

	* unposted: Src/Modules/zpty.c: use possible read character from
	read_poll() in loop in ptyread()

	* 13128: Completion/Builtins/_zstyle, Completion/Core/_match,
 	Completion/Core/_path_files, Doc/Zsh/compsys.yo: aloow value
 	`pattern' for insert-unambiguous style to preserve patterns in the
 	original string; add list-suffixes style to make file completion
 	list path suffixes if possible; slightly improved completion of
 	pathnames with multiple pattern-components

2000-11-06  Bart Schaefer  <schaefer@zsh.org>

	* 13127: Completion/User/_rcs: Test of $compstate[nmatches] was a
	no-op, removed it.

2000-11-05  Bart Schaefer  <schaefer@zsh.org>

	* 13124: Functions/Misc/nslookup: Use "command nslookup" as it's
	now possible to call the nslookup function recursively from zpty.

	* unposted: Src/Modules/zpty.c: Cloned shell is non-interactive
	for purposes of calling zexit(), so it doesn't print job status,
	save history, etc.

	* 13123: Doc/Zsh/mod_zpty.yo, Src/utils.c, Src/Modules/zpty.c:
	Change `zpty' to act as a combination of `clone' and `eval', to
	remove the limitation that only external commands can be run on
	the pty.  Also fix typos in utils.c.

	* 13120: Doc/Zsh/mod_zpty.yo, Functions/Misc/nslookup,
	Src/utils.c, Src/Modules/zpty.c: Merge Sven's uncommitted patch
	from 13061 with 13116.  WARNING: This reverses the meaning of
	`zpty -b'; the default is now blocking, -b selects non-blocking.
	Fix nslookup accordingly.  Clean up read_poll() somewhat.
	Document that `zpty -w' and `zpty -r' can stream to/from the pty.

2000-11-04  Bart Schaefer  <schaefer@zsh.org>

	* 13118: Completion/Core/compinit: Add `bareglobqual' to the
	standard setopts for the completion system.

	* 13116: Src/Modules/zpty.c: More informative error output; better
	streaming behavior of `zpty -r'; prevent hang on `zpty -t' when
	the command was started with `zpty -b'.

2000-11-02  Sven Wischnowsky  <wischnow@zsh.org>

	* users/3503: Doc/Zsh/mod_parameter.yo, Src/jobs.c,
	Src/Modules/parameter.c: show current/previous job in $jobstates

2000-11-01  Sven Wischnowsky  <wischnow@zsh.org>

	* 13107: Functions/Misc/zed: don't reset just-edited trap function
 	to old value

2000-10-30  Sven Wischnowsky  <wischnow@zsh.org>

	* 13095: Src/Modules/parameter.c: make assignament to $nameddirs
 	behave like hash -d

2000-10-25  Sven Wischnowsky  <wischnow@zsh.org>

	* users/3472: Completion/User/_rcs: use return value of _files,
	don't use ${PRE,SUF}FIX for globbing, complete all files as a
	default for "co"

	* 13084: Src/Zle/complist.c: re-display list for cleanup only if
 	we were in menu selection

	* 13082: Src/Zle/complist.c, Src/Zle/compresult.c: add a counter
 	for invalidatelist() to allow finding out if there is a new list

2000-10-24  Sven Wischnowsky  <wischnow@zsh.org>

	* 13071: Src/Zle/complist.c, Src/Zle/compresult.c: avoid printing
 	file type characters in completion lists for matches ending in a
 	slash

2000-10-23  Sven Wischnowsky  <wischnow@zsh.org>

	* 13037: Completion/Core/_path_files, Doc/Zsh/compsys.yo: change
 	some tags used in filename completion: no tag for file-sort,
 	fake-files and ignore-parents, paths for accept-exact

2000-10-21  Bart Schaefer  <schaefer@zsh.org>

	* 13057: Src/Zle/zle_main.c: `vared -h' should not imply `vared -e';
	use of -e should override the setting of the IGNOREEOF option.
	(The -e flag was added by zsh-workers/9396, for 3.1.6-dev-16.)

2000-10-20  Bart Schaefer  <schaefer@zsh.org>

	* 13055: Src/hist.c, Src/Zle/zle_main.c: Fix `vared -h' for non-
	interactive shells (scripts).

2000-10-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 13036: Completion/Commands/_bash_completions,
 	Completion/Commands/_complete_debug,
 	Completion/Commands/_complete_help,
 	Completion/Commands/_correct_word,
 	Completion/Commands/_expand_word,
 	Completion/Commands/_history_complete_word,
 	Completion/Commands/_next_tags, Completion/Core/_main_complete,
 	Completion/Core/compinit: simplify setting standard completion
 	system options using $_comp_options

	* 13035: Doc/Zsh/mod_zpty.yo, Functions/Misc/nslookup, Src/utils.c,
 	Src/Modules/zpty.c, Test/comptest: make non-blocking IO on ptys
 	work again; add -t option to test if command is still alive

2000-10-19  Wayne Davison  <wayned@users.sourceforge.net>

	* 13034: Src/hist.c: Don't call histreduceblanks() if the line
	didn't parse right.

2000-10-17  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Functions/Misc/zmv: Small typo in example in comment.

2000-10-17  Sven Wischnowsky  <wischnow@zsh.org>

	* 13005: Src/Zle/computil.c: make _arguments ignore unspecified
 	non-option arguments to the right of the cursor

2000-10-17  Peter Stephenson  <pws@csr.com>

	* Config/version.mk, Functions/Zle/.distfiles,
	Completion/Core/.distfiles: 3.1.9-dev-7

	* Functions/Misc/zmv: in verbose mode, report if something was
	skipped because it didn't change.

2000-10-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 13003: Test/54compmatch.ztst: add tests for the stuff in 12995

2000-10-13  Bart Schaefer  <schaefer@zsh.org>

	* 13000: Doc/Zsh/jobs.yo: Document tty restoration when a stopped
	job is resumed with fg.  This was previously documented only under
	the STTY parameter, but it applies to all stopped jobs.

2000-10-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 12995: Src/Zle/compmatch.c: two completion matching fixes; wrong
 	(path) prefix matching (removed path components) and reverse order
 	of sub-strings in match-strings

2000-10-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 12974: Completion/Core/_tags, Completion/Core/_sort_tags,
	Doc/Zsh/compsys.yo: remove possibility for func() entries in
	tag-order style, can be done using zstyle -e

	* 12954, 12973: Completion/Builtins/_zstyle,
	Completion/Core/_path_files, Doc/Zsh/compsys.yo: rename fake style
	to fake-files

2000-10-11  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12958: Cosmo <cosmo@informix.com>: aczsh.m4: fix for NCR compiler

2000-10-11  Sven Wischnowsky  <wischnow@zsh.org>

	* 12960: Completion/Builtins/_zstyle, Completion/Commands/_expand_word,
 	Completion/Core/_all_matches, Completion/Core/_expand,
 	Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo, Src/Zle/comp.h,
 	Src/Zle/compcore.c, Src/Zle/complete.c, Src/Zle/complist.c,
 	Src/Zle/compresult.c:add _all_matcher completer and supporting
 	C-code for adding a special match representing all other matches;
 	remove completions style from _expand(|_word)

	* 12959: Src/Zle/compcore.c, Src/Zle/complist.c: make user defined
 	completion widgets leave menu selection without accepting the
 	currently selected match

2000-10-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 12948: Completion/Core/_expand: follow-up to 12942, only a
 	missing redirection

	* 12946: Completion/Base/_math, Completion/Base/_subscript,
 	Completion/Builtins/_vars, Completion/Builtins/_zstyle,
 	Completion/Core/_parameters, Doc/Zsh/compsys.yo: add
 	fake-parameters style to allow completing parameters which are not
 	yet set

	* 12942,12945: Completion/Core/_expand: temporarily remove global
 	aliases to avoid error message inside the evals

	* 12941: Src/Zle/compmatch.c: follow-up to 12930, make it first
 	try exact character matches, but enable it to go back to try match
 	specs if it fails after accepting such character matches

2000-10-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 12930: Src/Zle/compmatch.c: prefer exact character matches over
 	match specs (so that `nom' can match `nomatch' in _options)

2000-10-06  Sven Wischnowsky  <wischnow@zsh.org>

	* 12919: Completion/User/_tiff, Completion/X/_xv: search for *.tif
 	files, too

	* 12917: Completion/Bsd/_bsd_pkg, Completion/Bsd/_kld,
 	Completion/Builtins/_autoload, Completion/Builtins/_cd,
 	Completion/Builtins/_compdef, Completion/Builtins/_popd,
 	Completion/Core/_expand, Completion/Core/_path_files,
 	Completion/Linux/_rpm, Completion/User/_gcc, Completion/User/_gdb,
 	Completion/User/_mailboxes, Completion/User/_man,
 	Completion/User/_perl_modules, Completion/User/_printers,
 	Completion/User/_zdump: more option setting cleanup; remove some
 	unnecessary setopts, remove N qualifiers

2000-10-05  Bart Schaefer  <schaefer@zsh.org>

	* 12912: Completion/Commands/_bash_completions,
	Completion/Commands/_complete_debug,
	Completion/Commands/_complete_help,
	Completion/Commands/_correct_word,
	Completion/Commands/_expand_word,
	Completion/Commands/_history_complete_word,
	Completion/Commands/_next_tags, Completion/Core/_main_complete:
	Other places where `unsetopt cshnullglob' is needed.

2000-10-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 12901: Doc/Zsh/compwid.yo, Doc/Zsh/manual.yo: cleanup for 12896

	* 12899: Completion/Core/_main_complete: unset cshnullglob

	* 12898: Src/parse.c: don't return invalid Eprog after parse error

	* 12897: Src/Zle/computil.c: comparguments: don't use
 	rest-argument-specification if it was inactivated

	* 12896: Doc/Zsh/arith.yo, Doc/Zsh/builtins.yo, Doc/Zsh/compctl.yo,
 	Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo, Doc/Zsh/expn.yo,
 	Doc/Zsh/func.yo, Doc/Zsh/mod_complist.yo: cleanup

	* 12892: Completion/Core/_files, Completion/Core/_path_files,
 	Doc/Zsh/compsys.yo, Doc/Zsh/expn.yo: complete after automounted
 	directories (a rather ugly hack); remove old code in _files (comma
 	separated patterns); improve docs for fake style and for comma
 	separated qualifier lists

2000-10-04  Tanaka Akira  <akr@zsh.org>

	* 12886: Completion/User/_cvs: make _cvs_vendor_branches to handle
	remote-access style.

2000-10-04  Sven Wischnowsky  <wischnow@zsh.org>

	* 12885: Src/Zle/zle_tricky.c: don't stop parsing too early when
 	completing inside a command substitution

	* 12884: Src/Zle/compcore.c: don't forget a displayed list when
 	starting menu completion

2000-10-04  Tanaka Akira  <akr@zsh.org>

	* 12872: Completion/User/_cvs: Fix modules completion when a cvsroot
	specified in a command line begins with tilde.  Generate subcommand
	list from `cvs --help-commands' and `cvs --help-synonyms'.  Complete
	remote modules. Complete vendor branch for a second argument of
	`cvs import'.  Use _call.

2000-10-02  Bart Schaefer  <schaefer@zsh.org>

	* 12869: Src/builtin.c, Src/exec.c, Src/glob.c, Src/signals.c,
	Src/utils.c: Change several zerr() to zwarn(), either because
	errflag was immediately cleared after calling zerr(), or to make
	builtin commands fail normally (with nonzero exit status) rather
	than aborting all the way back to top level.

2000-10-01  Clint Adams  <schizo@debian.org>

	* unposted: Src/Zle/compresult.c: remove unused variable declaration.

2000-09-27  Clint Adams  <schizo@debian.org>

	* 12863: Src/string.c, Src/Zle/compresult.c: remove ztrdupstring(),
	fold guts back into ztat(), change memory allocation to VARARR.

2000-09-25  Bart Schaefer  <schaefer@zsh.org>

	* 12862: Src/exec.c: Fix STTY parameter to match documentation.
	(Plus unposted addition at the end of execcmd() to clear STTYval.)

2000-09-22  Clint Adams  <schizo@debian.org>

	* 12860: Src/jobs.c: don't check length against PATH_MAX or
	truncate.

	* 12859: Src/string.c, Src/Zle/compresult.c:
	dynamically allocate buffer in ztat, remove
	duplication loop to ztrdupstrip().

2000-09-20  Bart Schaefer  <schaefer@zsh.org>

	* 12851, 12852: Completion/Commands/_expand_word,
	Completion/Core/_expand, Doc/Zsh/compsys.yo: Change the way the
	completers are selected for _expand_word; clarify and update doc.

2000-09-20  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12848: Doc/Zsh/zle.yo: Alphabetize list of parameters

	* 12842 with corrections of Bart: Doc/Zsh/contrib.yo: Clarify
	digest file usage.

2000-09-19  Clint Adams  <schizo@debian.org>

	* 12847: Src/builtin.c: dynamically allocate z and buf in
	bin_whence().

	* 12846: Src/.distfiles, Src/mem.c, Src/string.c, Src/utils.c,
	Src/zsh.mdd: Move dupstring(), ztrdup(), tricat(), zhtricat(),
	dyncat(), dupstrpfx(), ztrduppfx(), and appstr() to string.c.

	* 12845: Src/Modules/files.c: dynamically allocate pbuf in domove().

2000-09-18  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12835: Doc/Zsh/compwid.yo: Alphabetize list of special parameters

2000-09-18  Clint Adams  <schizo@debian.org>

	* 12836: Src/Modules/files.c: use ztrdup()/appstr() in lieu of
	statically-allocated buffer in bin_ln.

2000-09-18  Bart Schaefer  <schaefer@zsh.org>

	* 12833: Back out the zasprintf changes from 12814, they're not
	being used any more and they break common builds like SunOS.

2000-09-17  Bart Schaefer  <schaefer@zsh.org>

	* 12829: Src/glob.c, Src/init.c, Src/utils.c: Move dyncat() and
	tricat() to utils.c; rewrite 12814, 12818, 12827 and 12828 for
	less allocation-intensive behavior.

2000-09-18  Clint Adams  <schizo@debian.org>

	* 12828: Src/utils.c: dynamically allocate 'dir' in mailstat.

	* 12827: Src/utils.c: dynamically allocate 'file' in mailstat.

2000-09-17  Clint Adams  <schizo@debian.org>

	* unposted: Src/system.h, Src/utils.c: define mailstat()
	as a macro if MAILDIR_SUPPORT is undefined.

	* 12823: Src/builtin.c, Src/utils.c: use zsh heap instead of
	permanent heap.

	* 12821: Src/builtin.c: bin_dot is now independent of PATH_MAX.

2000-09-16  Bart Schaefer  <schaefer@zsh.org>

	* 12817: Doc/Zsh/builtins.yo, Src/builtin.c: Give meaning to
	"typeset +m" and "typeset +g -m".

2000-09-16  Clint Adams  <schizo@debian.org>

	* 12818: Src/init.c: call tricat() instead of zasprintf()
	as inspired by Bart.

	* 12814: configure.in, Src/compat.c, Src/init.c, Src/system.h:
	implement zasprintf and use it in lieu of sprintf with a
	static buffer in sourcehome().

2000-09-15  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Doc/Zsh/contrib.yo: Missing hunk from 12765 (replace
	another use of "wordcode").

2000-09-14  Bart Schaefer  <schaefer@zsh.org>

	* 12804: Src/builtin.c: "typeset -m" implies "-g".

	* unposted: Completion/Commands/_complete_debug: Changed my mind
	about the edit to 12800.

2000-09-13  Bart Schaefer  <schaefer@zsh.org>

	* 12800: E. Jay Berkenbilt: Completion/Commands/_complete_debug:
	Quote the file name pushed onto the history, in case the command
	word has strange characters in it.  (Slighty edited.)

2000-09-11  Bart Schaefer  <schaefer@zsh.org>

	* 12793: Completion/Builtins/_zle, Doc/Zsh/compwid.yo,
	Doc/Zsh/mod_zle.yo: Convert _zle to use _arguments; fix typos.

2000-09-08  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12779: Src/system.h: Comment out #define _XPG_IV for sinix.
	It was not correct to set it here, and is not needed with
	currently supported versions. If anybody happens to run really
	outdated SINIX, we should add check for gettimeofday prototype
	instead.

2000-09-07  Bart Schaefer  <schaefer@zsh.org>

	* 12773: Doc/Zsh/contrib.yo, Functions/Zle/smart-insert-last-word:
	Add the smart-insert-last-word function from zsh-users/3272.
	Change "completion style" to "widget style" in a few places.

2000-09-07  Sven Wischnowsky  <wischnow@zsh.org>

	* 12769: Completion/Builtins/_cd: more sensible value

	* 12768: as suggested by Andrej (12767): Completion/Bsd/_bsd_pkg,
	Completion/Bsd/_kld, Completion/User/_gcc, Completion/User/_gdb,
 	Completion/User/_mailboxes, Completion/User/_zdump: stick some
 	`N's into glob patterns

2000-09-06  Bart Schaefer  <schaefer@zsh.org>

	* 12765,12766: Doc/Zsh/builtins.yo, Doc/Zsh/contrib.yo: Eliminate
	use of "wordcode".

2000-09-06  Peter Stephenson  <pws@csr.com>

	* 12762: Akinori MUSHA: configure.in, Completion/Bsd/_kld:
	changes for new FreeBSD releases.

2000-09-06  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12761: Doc/ztexi.yo: `` was converted into " by makeinfo;
	use `@:` instead. In line, use `{}` for tex, this looks better
	in printed output.

	* unposted: aczsh.m4, conifgure.in:  Remove patch from 12686
	that was accidentally commited

2000-09-05  Bart Schaefer  <schaefer@zsh.org>

	* 12745: Doc/Zsh/contrib.yo: Add a cross-reference; include some
	comments about using completers with predict-on.

2000-09-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 12744: Doc/Zsh/contrib.yo, Doc/Zsh/mod_complist.yo,
 	Functions/Zle/incremental-complete-word: change context for i-c-w
 	styles, update docs

2000-09-04  Bart Schaefer  <schaefer@zsh.org>

	* 12742: Doc/.distfiles, Doc/Makefile.in, Doc/Zsh/.distfiles,
	Doc/Zsh/builtins.yo, Doc/Zsh/compsys.yo, Doc/Zsh/contrib.yo,
	Doc/Zsh/manual.yo, Doc/Zsh/zftpsys.yo, Doc/Zsh/zle.yo,
	Doc/zsh.yo, Doc/zshcontrib.yo, Functions/Prompts/promptinit,
	Functions/Zle/history-search-end, Functions/Zle/predict-on:
	Create new "User Contributions" chapter in the manual; move
	some items there from existing chapters; fix a few typos.
	Minor improvements to promptinit and history-search-end.
	Larger improvements to predict-on, including removing the
	`:completion' prefix from most of its style contexts.

2000-09-04  Peter Stephenson  <pws@csr.com>

	* 12741: Src/math.c: problem with nested matheval unexpectedly
	stomping on outputradix.

2000-09-04  Andrej Borsenkow  <Andrej.Borsenkow@mow.siemens.ru>

	* 12736: configure.in: Fix `make install' dependency
	for Cygwin static build

2000-09-04  Peter Stephenson  <pws@csr.com>

	* Config/version.mk: 3.1.9-dev-6

2000-09-04  Bart Schaefer  <schaefer@zsh.org>

	* 12733: Functions/Misc/colors: Restore `grey' and other
	accidentally-misplaced elements in the `fg*' and `bg*' arrays.

	* 12732: Src/params.c: Suppress base# prefix when base is 10 even
	if the [##base] format of 12722 was not used.

2000-09-03  Clint Adams  <schizo@debian.org>

	* 12728: Completion/User/_man: complete _files instead of
	manpages if -l or --local-file is present on the commandline.

2000-09-03  Bart Schaefer  <schaefer@zsh.org>

	* 12726,12727: Functions/Misc/zrecompile: Handle pass-through of
	all zcompile options.

2000-09-02  Bart Schaefer  <schaefer@zsh.org>

	* 12725: Util/helpfiles: Recognize more end-of-page patterns, and
	find the end of the builtins section correctly.

	* 12723: Util/reporter: Modernize variables and options handling;
	add zstyle to output.

2000-09-02  Andrew Main  <zefram@zsh.org>

	* 12722: Doc/Zsh/arith.yo, Src/math.c, Src/params.c: Allow
	[##base] as well as [#base]; the doubled # suppresses output
	of a base prefix.  Also clean up parsing of [] base-selection
	constructs.

2000-09-01  Bart Schaefer  <schaefer@zsh.org>

	* 12721: Functions/Misc/allopt: Remove "emulate" which changes the
	output of the function; other minor cleanup.

2000-08-30  Clint Adams  <schizo@debian.org>

	* 12720: Completion/Debian/_dpkg: change two instances of
	_files to _path_files to avoid completion of all-files.

2000-08-29  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 12719: Doc/Zsh/mod_zle.yo, Src/utils.c, Src/Zle/zle_main.c:
	handle quoting of separators in arrays when there might also be
	real backslashes around.

2000-08-29  Sven Wischnowsky  <wischnow@zsh.org>

	* 12717: Src/Zle/zle_tricky.c: fix for unbalanced calls to
 	{push,pop}heap in docomplete()/get_comp_string()

2000-08-28  Bart Schaefer  <schaefer@zsh.org>

	* 12716: Doc/Zsh/builtins.yo, Doc/Zsh/compctl.yo,
	Doc/Zsh/compsys.yo, Doc/Zsh/expn.yo, Doc/Zsh/grammar.yo,
	Doc/Zsh/mod_zutil.yo, Doc/Zsh/params.yo: Documentation and index
	entries for the REPLY and reply parameters, plus index entries for
	a couple of paramters used by the completion system.

2000-08-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 12710: Src/exec.c: fix for `function' without names

2000-08-27  Oliver Kiddle  <opk@zsh.org>

	* 12708: Completion/AIX/_logical_volumes: new AIX completion function

2000-08-23  Sven Wischnowsky  <wischnow@zsh.org>

	* 12692: Alexandre: 12691; 12692: Completion/User/_gv,
	Completion/User/_pdf, Completion/User/_ps, Completion/User/_pspdf:
 	complete compressed files for gv; improve results from _pspdf

2000-08-21  Sven Wischnowsky  <wischnow@zsh.org>

	* 12682: Completion/Builtins/_zmodload: use return value

2000-08-18  Oliver Kiddle  <opk@zsh.org>

	* 12677: Completion/Builtins/_zmodload: use _arguments in _zmodload

2000-08-16  Peter Stephenson  <pws@csr.com>

	* unposted: Src/.distfiles: forgot this yet again.

	* pws/Andrej: 12594, 12661: Src/zsh.rc, Src/zsh.ico, Src/Makefile.in,
	configure.in: basic support for Windows resources including icon,
	will be built in for cygwin.

	* Andrej: 12658: .cvsignore, Src/.cvsignore: cscope ignorance.

2000-08-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 12654: Doc/Zsh/mod_parameter.yo, Src/Modules/parameter.c: make
 	$modules report aliases correctly

	* unposted: Completion/Builtins/_pids: remove unnecessary local parameter

2000-08-15  Peter Stephenson  <pws@csr.com>

	* 12650: Completion/Builtins/_zmodload: don't lists aliases if
	there aren't any.

2000-08-15  Bart Schaefer  <schaefer@zsh.org>

	* 12652: Src/module.c: Fix variable scoping problem that caused
	crash in `zmodload -u'.

2000-08-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 12640: Completion/Builtins/_pids, Completion/Builtins/_zstyle,
 	Doc/Zsh/compsys.yo: call ps only once and be more intelligent when
 	finding the PIDs

	* 12635: Completion/Builtins/_pids: small improvement to allow
 	lists where the pid is not in the first column

2000-08-14  Bart Schaefer  <schaefer@zsh.org>

	* Andrej: 12623: configure.in, Src/mkmakemod.sh, Src/zsh.h:  Fix
	dynamic linking on cygwin, again.

	* 12621: Src/Zle/zle_main.c: Use ztrdup() on a string that will
	later be freed; this appears to have been a bug ever since 9839.

	* Andrej: 12620: configure.in, Src/system.h: Fix cache variable
	test for mmap, remove cygwin special-case.

	* 12617: configure.in: Use AC_FUNC_MMAP rather than just test for
	existence of mmap.

	* Andrej: 12614: Test/53completion.ztst, Test/54compmatch.ztst,
	Test/55arguments.ztst: Add %clean sections to unload zpty module.

	* Andrej: 12614: Completion/Builtins/_zmodload: Add DLL to suffix
	list, for benefit of cygwin.

2000-08-14  Sven Wischnowsky  <wischnow@zsh.org>

	* Andrej: 12613: Src/lex.c: missing mod_export

	* 12610: Src/Zle/computil.c: make all builtins in computil test if
 	they were called from a completion function

2000-08-13  Bart Schaefer  <schaefer@zsh.org>

	* 12604: Src/compat.c, Src/system.h, Src/Modules/files.c,
	Src/Modules/parameter.c: Remove calls to zpathmax(); fix some
	serious errors in zpathmax() but wrap it in #if 0 anyway; minor
	fixes to comments and coding style for zopenmax().

	* 12601: aczsh.m4, configure.in: configure --enable-cflags and the
	like, i.e., with no =... part, should preserve the environment
	values for CFLAGS etc. rather than erase them.

2000-08-11  Peter Stephenson  <pws@csr.com>

	* 12598: INSTALL, aczsh.m4, configure.in: --enable-cppflags=...,
	--enable-cflags=..., --enable-ldflags=..., --enable-libs=...

2000-08-11  Bart Schaefer  <schaefer@zsh.org>

	* 12596: INSTALL: Update for module aliasing changes.

2000-08-11  Sven Wischnowsky  <wischnow@zsh.org>

	* 12592: Completion/Core/_parameters, Src/Zle/compcore.c,
 	Src/Zle/zle_tricky.c: fixes for completion in math contexts: don't
 	quote spaces and do normal parameter expansion completion after `$'

2000-08-11  Peter Stephenson  <pws@csr.com>

	* Config/version.mk: 3.1.9-dev-5.

2000-08-10  Oliver Kiddle  <opk@zsh.org>

	* 12585: Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo, Doc/Zsh/expn.yo,
	Doc/Zsh/mod_complist.yo, Doc/Zsh/mod_zutil.yo: minor doc fixes

	* 12583: Completion/Base/_math, Completion/Builtins/_arrays,
	Completion/Builtins/_vars, Completion/Builtins/_zpty,
	Completion/Commands/_bash_completions, Completion/Core/_parameters,
	Doc/Zsh/compsys.yo: add -g option to _parameters to restrict the
	type of parameters completed

2000-08-10  Peter Stephenson  <pws@csr.com>

	* 12582: Misc/Functions/is-at-least: make it accept name
	parts in the first argument (though I forgot to handle things
	like 3.1.6.random3 with no separator).

	* 12581: Doc/Zsh/options.yo, Src/options.c, Src/params.c,
	Src/zsh.h: Add C_BASES option to output hexadecimal as 0xFF
	instead of 16#FF, and similarly for octal if OCTAL_ZEROES is set.

2000-08-09  Oliver Kiddle  <opk@zsh.org>

	* 12578: Completion/Builtins/_read, Completion/Builtins/_vars,
	Completion/Builtins/.distfiles: new completion for read builtin

2000-08-08  Clint Adams  <schizo@debian.org>

	* 12568: configure.in, Src/compat.c, Src/exec.c, Src/init.c,
	Src/system.h: check sysconf(_SC_OPEN_MAX) if available instead
	of OPEN_MAX/NOFILES.

2000-08-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 12567: Completion/Linux/_rpm, Src/Zle/computil.c: handle the
 	right option in strings with multiple single-letter options (and
 	correctly handle its argument)

	* 12565: Completion/Core/_expand, Completion/Core/_path_files,
 	Doc/Zsh/mod_computil.yo, Src/Zle/computil.c: more fixes for
 	completion of special characters (quoting)

2000-08-08  Peter Stephenson  <pws@csr.com>

	* unposted: Src/xmods.conf, Src/Aliases/*: Remove Src/Aliases
	files and delete alias modules from xmods.conf (should now
	use `zmodload -A' to generate module aliases).

	* 12561: Completion/Builtins/_zmodload, Doc/Zsh/builtins.yo,
	Src/builtin.c, Src/module.c, Src/zsh.h: aliases for modules
	done internally via `zmodload -[AR]'.

2000-08-07  Peter Stephenson  <pws@csr.com>

	* 12555: Fix static linking on cygwin.

2000-08-07  Bart Schaefer  <schaefer@zsh.org>

	* users/3358: Zero shout when closing SHTTY in subshells.

2000-08-05  Bart Schaefer  <schaefer@zsh.org>

	* unposted (Wayne, 12549): Src/system.h: Missing paren.

2000-08-04  Bart Schaefer  <schaefer@zsh.org>

	* 12547, 12458: configure.in, Src/compat.c, Src/Modules/files.c:
	Handle ENOENT and ENOTDIR within zpathmax(), and therefore back
	out the changes from 12541 and 12533.

2000-08-04  Clint Adams  <schizo@debian.org>

	* 12541: configure.in, Src/compat.c: zrealpath wrapper around
	realpath().

	* 12533: Src/Modules/files.c: drop the tail of the path
	passed to mkdir in the call to pathconf().

2000-08-04  Sven Wischnowsky  <wischnow@zsh.org>

	* 12525: Src/module.c: remove (wrong) test for linked-in modules
 	in require_module()

2000-08-04  Bart Schaefer  <schaefer@zsh.org>

	* 12516: Src/compat.c, Src/system.h, Src/Modules/files.c,
	Src/Modules/parameter.c: Rewrite the pathconf() support using a
	wrapper function in compat.c to isolate the #ifdefs.

2000-08-03  Peter Stephenson  <pws@csr.com>

	* Andrej: 12501: Src/params.c: getenv etc. become zgetenv etc.
	and call getenv where necessary.

2000-08-03  Sven Wischnowsky  <wischnow@zsh.org>

	* 12503: Completion/Commands/_bash_completions,
 	Completion/Commands/_complete_debug,
 	Completion/Commands/_complete_help,
 	Completion/Commands/_correct_word,
 	Completion/Commands/_expand_word,
 	Completion/Commands/_history_complete_word,
 	Completion/Commands/_next_tags, Completion/Core/_expand,
 	Completion/Core/_main_complete, Completion/Core/_path_files,
 	Completion/Core/compdump, Src/glob.c, Src/Modules/parameter.c:
	try to get quoting of special character (`>' and `\') right; fix
 	for pathmax in parameter.c

	* 12497: Doc/Zsh/builtins.yo: small fix for `read -r' doc

	* 12496: Completion/Core/_path_files: one more problem with
 	quoting of glob characters in filename completion

	* 12494: Doc/Zsh/options.yo, Src/Zle/zle_main.c: make binding of
 	^D be used in first column if ignoreeof is set and ^D is bound to
 	a shell function widget

2000-08-02  Peter Stephenson  <pws@csr.com>

	* Andrej: 12487: configure.in, Etc/MACHINES, Src/Makefile.in,
	Src/init.c, Src/main.c, Src/makepro.awk, Src/mkmakemod.sh,
	Src/parse.c, Src/zsh.h, Src/Zle/zle_utils.c: Dynamic loading
	on cygwin.

2000-08-02  Clint Adams  <schizo@debian.org>

	* 12489: Src/Modules/files.c, Src/Modules/parameter.c: check
	errno change from pathconf() in case of unlimited path length.

	* 12472: configure.in, Src/Modules/files.c,
	Src/Modules/parameter.c: use pathconf() instead
	of PATH_MAX if possible.

2000-08-02  Adam Spiers  <adam@spiers.net>

	* 12486: Completion/Base/{.distfiles,_cache_invalid,_retrieve_cache,
	_store_cache}, Completion/Builtins/_zstyle, Completion/Linux/_rpm,
	Completion/User/_perl_modules, Doc/Zsh/compsys.yo: new completion
	caching layer

2000-08-02  Sven Wischnowsky  <wischnow@zsh.org>

	* 12483: Completion/Base/_arguments, Completion/Core/_complete,
 	Doc/Zsh/compsys.yo: if compcontext is an assoc, the keys are the
 	completions and the values are their descriptions

	* 12475: Completion/Base/_arguments: prefer user-defined specs
 	over ones derived from --help output

2000-08-01  Sven Wischnowsky  <wischnow@zsh.org>

	* Jan Fedak: 12463: Completion/User/_slrn: new completion function
	for slrn

	* 12462: Completion/Base/_arguments: fix for automatically
 	recognised options, don't expect an argument after each of them

	* 12453: Completion/Bsd/_bsd_pkg, Completion/Bsd/_kld,
 	Completion/Commands/_next_tags, Completion/User/_cvs,
 	Completion/User/_mailboxes, Completion/X/_xset,
 	Completion/X/_xwit, Src/exec.c: remove tests for kshautoload (use
 	zcompile -z); fix for setting scriptname for functions that
 	redefine themselves

	* 12449: Completion/Base/_arguments, Completion/Base/_values,
 	Completion/Core/_complete, Doc/Zsh/compsys.yo: make $compcontext
 	more powerful and easier to use for simple cases

2000-07-31  Peter Stephenson  <pws@csr.com>

	* Config/version.mk: 3.1.9-dev-4.

	* unposted: Completion/Core/.distfiles: add compaudit

2000-07-31  Sven Wischnowsky  <wischnow@zsh.org>

	* 12439: Src/hist.c: isalpha() -> ialpha(); avoid a compiler
 	warning

	* 12438: Doc/Zsh/compsys.yo: clarify manual for menu style;
 	select= and yes= may be given both a number and one of the long*
 	values at the same time

2000-07-30  Andrew Main  <zefram@zsh.org>

	* 12436: Doc/Zsh/invoke.yo, Src/init.c: Make -b behave like
	the csh -b, permitting more options to be stacked after it and
	take effect.  Make -b take effect depending on SH_OPTION_LETTERS,
	consistent with all the other single-letter options, rather than
	having a clashing check of emulation type.

2000-07-30  Andrew Main  <zefram@zsh.org>

	* 12434: Doc/Zsh/invoke.yo, Src/init.c, Src/options.c, Src/zsh.h,
	Src/zsh.mdd: Allow options to be specified on the zsh command line
	in the form of GNU-style long options.	Also handle --version
	and --help.  Do not permit extra option letters to be stacked
	after `-whatever-' (they used to be ignored).  Exit if the
	command line specifies an option name that doesn't exist.

2000-07-28  Bart Schaefer  <schaefer@zsh.org>

	* 12393: Src/jobs.c: The `wait' builtin searches the job table for
	any process ID it's asked to wait for, and rejects those it
	doesn't find.

2000-07-28  Peter Stephenson  <pws@csr.com>

	* 12421: Src/Makemod.in.in: extra tab

	* Andrej: 12419: Src/builtin.c, Src/params.c: use putenv() and
	getenv() if available and try to make minimal assumptions about
	environment handling.

	* Andrej: 12411: check for brk() and sbrk() and use sbrk() if no
	brk().

2000-07-27  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 12415: Src/utils.c: fix bug in 12414 when quoting metafied field
	separator.

2000-07-27  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12414: Doc/Zsh/mod_zle.yo, Src/exec.c, Src/utils.c,
	Src/Zle/zle_main.c: vared quotes separators when editing arrays.

2000-07-27  Sven Wischnowsky  <wischnow@zsh.org>

	* 12408: Test/55arguments.ztst: fix completion test (55*) because
 	of 12394

	* 12405: Completion/Core/_main_complete, Doc/Zsh/compsys.yo: fix a
 	bug that started menu selection too often; fix bug for `yes=long'
 	and documentit

2000-07-27  Bart Schaefer  <schaefer@zsh.org>

	* 12396: Functions/Misc/zed: The value of `$(functions $1)' for
	autoloadable functions has changed.

2000-07-27  Sven Wischnowsky  <wischnow@zsh.org>

	* 12400: Src/Zle/computil.c: compdescribe shouldn't use the sets
 	after failed initialisation

	* 12394: Completion/Core/_main_complete: don't hide possible
 	completions if there is only one and at the same time messages are
 	shown

2000-07-26  Adam Spiers  <adam@spiers.net>

	* unposted: Completion/User/_perl: -e, -I, -m and -M parameters
	can be specified multiple times

2000-07-26  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Andrej/pws: 12381: configure.in: cygwin on Windows 2000 is
	mysteriously returning status 0 even though the test fails, so
	create a file we can test to see if the test got that far.

2000-07-26  Bart Schaefer  <schaefer@zsh.org>

	* 12377: Completion/Core/compaudit, Completion/Core/compinit,
	Doc/Zsh/compsys.yo: Separate compinit security checks into their
	own callable function.

	* 12370: Functions/Misc/zed: Add a context for controlling
	completion within zed, and a style to enable tab insertion at the
	beginnings of lines in zed by default.

	* 12162: Completion/Core/_expand, Completion/Core/_path_files,
	Src/utils.c: Use `eval' instead of `$(print ...)' to suppress
	some syntax error failures; this requires that zwarn() does not
	trashzle() when the output is not going to the terminal.

2000-07-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 12378: Completion/Base/_arguments: make `_arguments --' use
 	specs after the `--' even for options not described in the help
 	output to get arguments

	* users/3337: Completion/Base/_value: allow _value:<assoc> functions to
 	override completion for all keys of an assoc

2000-07-24  Oliver Kiddle  <opk@zsh.org>

	* 12356: Completion/User/_mh: use mhpath and mhparam instead of
	guessing the directory

2000-07-24  Sven Wischnowsky  <wischnow@zsh.org>

	* 12354: Completion/Core/_multi_parts: optimisations for
 	_multi_parts

2000-07-22  Clint Adams  <schizo@debian.org>

	* 12347: Completion/User/_mutt: options -a, -b, and -c are
	repeatable.

2000-07-21  Sven Wischnowsky  <wischnow@zsh.org>

	* 12337: Src/parse.c: fix parsing of `time' without a command

2000-07-20  Wayne Davison  <wayned@users.sourceforge.net>

	* unposted: tweaked a function name in hist.c for Sven.

2000-07-20  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12239: Fr. Br. George (George V Kouryachy), adapted:
	configure.in: prefer curses to termcap on solaris.

2000-07-20  Bart Schaefer  <schaefer@zsh.org>

	* 12326: Completion/User/_cvs: Discard stderr of a command subst.

2000-07-20  Wayne Davison  <wayned@users.sourceforge.net>

	* 12323: Src/hist.c: support "builtin" in HIST_NO_STORE check.

2000-07-19  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 12319: Completion/User/_perl_builtin_funcs: Get also /usr/share/man.

2000-07-19  Wayne Davison  <wayned@users.sourceforge.net>

	* 12318: Doc/Zsh/options.yo, Src/builtin.c, Src/exec.c, Src/hist.c,
	Src/init.c, Src/lex.c, Src/parse.c, Src/Zle/zle_main.c: Removed
	remhist() and the HA_JUNKED flag.  Now hend() is called with an
	Eprog pointer so that it can access the lexer's data for the
	current command.  Added shouldIgnoreLine() so that hend() can
	determine in advance if a command should be saved in the history.
	Added the aliasspaceflag variable to note when we expand an alias
	that starts with a space.

2000-07-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 12314: Src/Zle/compmatch.c: a bit of security for a VARARR()

2000-07-19  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12313: Doc/Zsh/metafaq.yo: bad phrasing corrected.

	* 12308: Completion/User/_man: Andrej and pws: cope with systems
	where manual pages just have bare .Z and no number; don't be
	too clever about suffix until we try to strip it.

2000-07-18  Sven Wischnowsky  <wischnow@zsh.org>

	* 12297: Src/Zle/compcore.c: don't let duplicate matches keep us
 	from recognising exact matches if they produce the same string on
 	the line

2000-07-18  Wayne Davison  <wayned@users.sourceforge.net>

	* 12295: Src/builtin.c, Src/hist.c, Src/input.c, Src/lex.c: Fixed
	the history command to output correctly when the current command was
	already removed from the history.  Fixed remhist() to not remove
	the wrong line in the above scenario.  Got rid of "spaceflag".

2000-07-17  Tanaka Akira  <akr@zsh.org>

	* 12274: Test/53completion.ztst, Test/55arguments.ztst,
	Test/.distfiles: separates _arguments tests.

2000-07-17  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Config/version.mk: 3.1.9-dev-3.

2000-07-17  Sven Wischnowsky  <wischnow@zsh.org>

	* 12266: Src/Zle/computil.c: don't treat non-option arguments as
 	options

2000-07-17  Wayne Davison  <wayned@users.sourceforge.net>

	* 12265: Src/hist.c: Fixed gethistent().  Fixed a race condition
	in the SHARE_HISTORY code that could fail to import some shared
	history lines from other shells.

2000-07-16  Wayne Davison  <wayned@users.sourceforge.net>

	* 12260: Src/hist.c: Added unmeta() calls.  Fixed lockhistfile().

2000-07-13  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12247: Src/init.c, Src/params.c, Src/prompt.c: remove hostnam
	internal variable and use $HOST wherever hostname is needed.

	* 12242: Fr. Br. George (George V Kouryachy) and pws:
	Doc/Zsh/prompt.yo, Src/prompt.c: negative integers in prompt
	escapes count from the other end of the appropriate string.

2000-07-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 12243: Src/hist.c: try to get (z) parameter flag parsing for
 	conditions right

	* 12241: Completion/Core/_main_complete, Src/Zle/computil.c: fix
 	for _arguments with single-letter options: recognize
 	option-strings with multiple options; in _main_complete stop
 	trying completers when one called _message, don't display warnings
 	in such cases

	* 12238: Src/Zle/zle_thingy.c: fix zle widget -n num with num>9

	* 12237: Src/hist.c, Src/lex.c: slightly improved (z) flag for
 	parsing conditions; recognising glob flags in conditions still
 	doesn't work

2000-07-12  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12231: Completion/Core/compinstall: fix setting of list-prompt.

2000-07-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 12229: Doc/Zsh/compsys.yo: fix for list-prompt docs

	* 12228: Src/hist.c, Src/lex.c: fix for (z) flag, don't take # as
 	comment

2000-07-12  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12227: Completion/Core/compinstall: add select-prompt handling
	and correct menu entry and missing local parameters.

2000-07-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 12226: Completion/Core/_main_complete: don't start menu
 	selection with only select=long

	* 12225: Completion/Linux/_rpm: check if options were completed

2000-07-11  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12222: Src/exec.c: ignore EINTR in helper processe for
	tee and cat with multios.  It might be considered unfortunate
	that the shell is liable to exit on SIGPIPE if these disappear
	early.

	* 12220: Src/exec.c: print error message for unfound autoload
	function body at lower locallevel.

2000-07-10  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Completion/User/_killall: Complete process IDs and
	names for all processes when EUID is 0 (root); suggested by
	Thomas Kohler in 12202 and followups.

2000-07-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 12208: Completion/Core/_path_files: avoid insertion of `+'
 	before ~1/<TAB>; don't use undeclared local $tmp

2000-07-08  Tanaka Akira  <akr@zsh.org>

	* 12201: Completion/User/_java: fix completion for jar. complete
	package qualified class names. fix typos.

2000-07-07  Bart Schaefer  <schaefer@zsh.org>

	* 12193: configure.in, Src/Builtins/rlimits.mdd: Fix unnecessary
	rebuilds of rlimits.o on platforms where getrlimit() is not found.

2000-07-06  Oliver Kiddle  <opk@zsh.org>

	* 12181: Completion/AIX/_lscfg, Completion/AIX/_object_classes,
	Completion/AIX/_physical_volumes, Completion/AIX/_smit,
	Completion/AIX/_volume_groups, Completion/User/_printers: updates
	and additions to completions for AIX commands

2000-07-05  Oliver Kiddle  <opk@zsh.org>

	* 12177: Doc/Zsh/compsys.yo, Completion/Builtins/_unhash,
	Doc/Zsh/compwid.yo, Doc/Zsh/expn.yo, Doc/Zsh/mod_zutil.yo: add more
	standard tags to docs and fix typos

2000-07-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 12171: Completion/User/_arp: get return status right

2000-07-05  Bart Schaefer  <schaefer@zsh.org>

	* 12167: Test/Makefile.in: Ignore failure exit from "for" loop
	so that cleanup code following it will be executed.

2000-07-04  Oliver Kiddle  <opk@zsh.org>

	* 12165: Completion/User/_arp: new completion for arp

2000-07-04  Bart Schaefer  <schaefer@zsh.org>

	* 12160: Completion/Core/compdump: Return failure early if the
	dot-file directory is not writable.

2000-07-04  Oliver Kiddle  <opk@zsh.org>

	* unposted: Src/params.c, Src/Zle/compcore.c, Src/Zle/zle_utils.c:
	AIX dependency fixes

2000-07-04  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12158: Src/Modules/parameter.c: cast pid_t to int for printing.

2000-07-04  Sven Wischnowsky  <wischnow@zsh.org>

	* 12156: Completion/Core/_expand, Completion/Core/_path_files: add
 	some $(print...)s because of possible math-parse errors

2000-07-03  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12149: acconfig.h, configure.in, Src/Modules/zftp.c:
	h_errno wasn't found on HPUX 10.20.  Maybe in some library.

2000-07-03  Adam Spiers  <adam@spiers.net>

	* 12152: Completion/User/_perl: tweak completion of Perl script
	parameters to perl.

2000-07-03  Bart Schaefer  <schaefer@zsh.org>

	* 12151: Test/Makefile.in, Test/comptest: Point ZDOTDIR into the
	Test directory itself, and clean up .zcompdump after testing.

	* 12148: Completion/Core/_path_files: Followup to 12133 as
	suggested by Sven in 12137: Don't merge display-ordering glob
	flags into the parens in $(...) expressions.

2000-07-03  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12146: Doc/Makefile.in: reintroduce mysteriously disappeared
	code do install info files in directory.

	* 12140: Completion/Core/compinit, Completion/Core/compinstall,
	Doc/Zsh/compsys.yo: compinstall calls compinit after styles
	are defined; compinit checks for _expand completer and if
	necessary rebinds ^i to complete-word.

	* Config/version.mk: 3.1.9-dev-2.

	* 12138: Src/params.c, Test/06arith.ztst: setting of array
	elements in math context didn't work (ever).

	* 12121: Src/utils.c, Doc/Zsh/options.yo: save and restore stopmsg
	for precmd, fix #ifdef's for variable declaration in read_poll().

2000-07-03  Sven Wischnowsky  <wischnow@zsh.org>

	* 12134: Completion/Core/_main_complete, Doc/Zsh/compsys.yo,
 	Doc/Zsh/mod_complist.yo, Src/Zle/comp.h, Src/Zle/compcore.c,
 	Src/Zle/complist.c: change format style with warnings tag, don't
 	add descriptions as matches; make a-a-i-n-h in menu selection work
 	even without matches

2000-07-02  Bart Schaefer  <schaefer@zsh.org>

	* 12133: Completion/Core/_expand, Completion/Core/_path_files:
	Discard error output from parameter expansions and use "eval" to
	protect the completion system from parse errors and other garbage
	in the strings taken from the command line.

2000-06-29  Sven Wischnowsky  <wischnow@zsh.org>

	* 12125: Src/parse.c, Test/09funcdef.ztst: fix for `foo () print
 	bar' (function definitions without braces)

	* 12122: Completion/Core/_main_complete: reverse meaning of yes=num
 	again

	* 12119: Completion/Core/_complete, Completion/Core/_normal: try
 	to return the right value

	* 12118: Completion/Core/_expand: don't expand partially typed
 	parameter expansions

	* 12115: Completion/Core/_expand, Doc/Zsh/compsys.yo: change
 	suffix style to still do expansion if the suffix contains
 	something to expand

	* 12114: Completion/Core/_main_complete, Doc/Zsh/compsys.yo: even
 	more fun with the menu style (no=num, yes=long-list, reverse
 	meaning of yes=num)

	* 12113: Completion/Core/_expand, Src/Zle/zle_tricky.c: quote
 	brace-strings

2000-06-28  Bart Schaefer  <schaefer@zsh.org>

	* 12112: Src/params.c: Don't make namedirs out of hash elements.

2000-06-28  Sven Wischnowsky  <wischnow@zsh.org>

	* 12109: Completion/Core/_complete: make _complete return the
 	right value

	* 12107: Completion/Core/_setup, Src/Zle/complist.c: fix for
 	list-colors handling

	* 12105: Completion/Core/_main_complete: reset _comp_mesg (saying
 	whether there were messages) appropriately

	* Jan Fedak: 12097: Completion/User/_ssh: use _ports when
	completing remote ports

	* Andrej: 12094: Doc/Zsh/compsys.yo: a bit of cleanup

	* 12099: Completion/Core/_oldlist: make _oldlist not use the dummy
 	match added for the warning

	* 12093: Src/Zle/compcore.c, Src/Zle/complist.c, Src/Zle/compresult.c:
 	make a-a-i-n-h in menu selection work with one match; better undo
 	behaviour for menu selection

2000-06-27  Bart Schaefer  <schaefer@zsh.org>

	* 12086: Doc/Zsh/compsys.yo: Move _use_lo doc into alphabetical
	order; separate _files and _path_files for same reason.

2000-06-27  Sven Wischnowsky  <wischnow@zsh.org>

	* users/3219: Completion/Core/_main_complete, Doc/Zsh/compsys.yo:
	menu style accepts yes=x to start menu completion if there are at
	least x matches

	* Andrej: 12084: Src/Modules/zpty.c: don't close slave if not yet open

	* 12082: Doc/Zsh/compsys.yo: document _use_lo

2000-06-27  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Andrej: 12081: Src/Modules/zpty.c: compiles under Cygwin, but
	still glitches.

2000-06-26  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* unposted: Src/builtin.c, Src/utils.c: move read_poll to utils.c
	as suggested by Bart.

2000-06-26  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12076: Completion/Core/compinstall: overwrote file if no
	style information; overwrote symbolic link instead of following;
	didn't check file name for sanity.

2000-06-26  Bart Schaefer  <schaefer@zsh.org>

	* 12074: Doc/Zsh/builtins.yo, Doc/Zsh/manual.yo: Remove one more
	reference to compfmt; add missing menu items to node listing.

2000-06-26  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12073: Src/builtin.c, Src/utils.c, Doc/Zsh/builtins.yo: first
	pass at `read -t' which tests for availability of input before
	inputting.

2000-06-26  Sven Wischnowsky  <wischnow@zsh.org>

	* users/3208: Completion/User/_use_lo: default completion even if
	there are options

	* 12070: Completion/Core/_ignored: fix for completer lookup in
 	_ignored

	* 12068: Doc/Zsh/mod_computil.yo, Src/Zle/computil.c: remove
 	compfmt; a bit of explanation for compfiles and compgroups

	* 12067: Completion/Core/_history, Src/Zle/zle_tricky.c: typo in
 	_history; missing free()s in zle_tricky.c

	* 12066: Src/Zle/computil.c: missing allocation of list for option
 	arguments

2000-06-25  Bart Schaefer  <schaefer@zsh.org>

	* 12063: Doc/Zsh/builtins.yo, Doc/Zsh/compwid.yo,
	Doc/Zsh/mod_computil.yo, Doc/Zsh/mod_zutil.yo: Fix typos; assorted
	clarification and reformatting.

2000-06-23  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12044: Src/builtin.c:  read -A assigned an unnecessary null
	if there was trailing whitespace; careful of distinction between
	whitespace and non-whitespace field separators.

2000-06-23  Sven Wischnowsky  <wischnow@zsh.org>

	* 12041,12043 : Completion/Core/compinit: even more compinit stuff,
 	change prompt, search for insecure parent dirs

2000-06-22  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 12040: Src/builtin.c: typeset -r on existing parameter set
	the readonly flag before assigning any value on the same command
	line.

2000-06-22  Bart Schaefer  <schaefer@zsh.org>

	* 12039: Test/comptest: Use "compinit -u" to avoid a possible
	prompt about security of the directories; point ZDOTDIR into
	the temporary test directory for the .zcompdump file.

2000-06-22  Sven Wischnowsky  <wischnow@zsh.org>

	* 12033: Completion/Core/compinit: followup to compinit-security
 	patch

	* 12029: Completion/Builtins/_arrays, Completion/Builtins/_zstyle,
 	Completion/Commands/_bash_completions,
 	Completion/Commands/_history_complete_word,
 	Completion/Core/_history, Completion/Core/_main_complete,
 	Completion/Core/_parameters, Completion/Core/_setup,
 	Completion/Core/_tags, Completion/Debian/_apt,
 	Completion/X/_x_extension, Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo,
 	Src/zsh.h, Src/Zle/compcore.c, Src/Zle/compctl.c,
 	Src/Zle/complist.c, Src/Zle/computil.c: allow subscripts for
 	compadd -[ak]; new style for history completion; better
 	list-colors handling

2000-06-22  Clint Adams  <schizo@debian.org>

	* 12027: Completion/User/_mailboxes: fix splitting problem in
	12024, add intelligence for mutt mailboxes in $maildirectory
	not specified in muttrc.

	* 12024: Completion/User/_mailboxes: handle multiple mailboxes
	lines in muttrc.

2000-06-21  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 12019: Completion/User/_ssh: upgrade to the last openssh
	options.

2000-06-21  Sven Wischnowsky  <wischnow@zsh.org>

	* 12011: Completion/Commands/_history_complete_word,
 	Completion/Core/_expand, Completion/Core/_history: make history
 	completion use I{PREF,SUF}FIX

2000-06-20  Oliver Kiddle  <opk@zsh.org>

	* unposted: Src/exec.c: AIX dependency fix

2000-06-20  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 12000: Functions/Misc/zmv: emulate zsh doesn't unset MARKDIRS,
	so use emulate -R.

2000-06-20  Sven Wischnowsky  <wischnow@zsh.org>

	* 11998: Completion/Builtins/_pids, Completion/Core/compdump,
 	Completion/Core/compinit, Doc/Zsh/compsys.yo: a bit of security
 	for compinit (avoid using things writable by others); avoid
 	handling files with the same name twice; remove compconf

2000-06-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 11992: Src/Zle/complist.c: make undo break out of menu selection
 	if nothing to undo inside it

	* 11985: Completion/Debian/_dpkg, Doc/Zsh/compsys.yo,
	Src/Zle/computil.c: _arguments: small fix for -s and new `!...' for
	things not to complete (but to understand)

	* 11982: Test/comptest: update comptest to not set ZLS_COLORS
 	directly

	* 11981: Src/Zle/computil.c: more careful when optimising patterns
 	in compfiles

	* 11977: Completion/Core/_options, Completion/Core/_set_options,
 	Completion/Core/_unset_options, Doc/Zsh/compwid.yo,
 	Src/Zle/comp.h, Src/Zle/complete.c, Src/Zle/compmatch.c,
 	Test/54compmatch.ztst: new match spec characters bBeE, match only
 	word/line not both

	* 11973: Completion/Builtins/_zstyle, Completion/Core/_description,
 	Completion/Core/_expand, Doc/Zsh/compsys.yo, Src/Zle/zle_tricky.c:
 	allow _expand to expand braces; better detection of braces to
 	complete instead of passing to shell code

2000-06-19  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* unpost: additions to Completion/Commands/.distfiles and
	.distfiles.

	* users/3189: Functions/Misc/zmv:  use depth-first ordering with
	**/; ignore files whose names are unchanged by the substitution.

2000-06-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 11971: Completion/Core/_path_files, Doc/Zsh/compsys.yo,
 	Src/Zle/compcore.c, Src/Zle/computil.c: improve filename
 	completion; use accept-exact for in-path completion; new fake style

	* users/3188: Completion/Core/_description, Completion/Core/_setup,
 	Doc/Zsh/compsys.yo: restore ZLS_COLORS when possible; better
 	group-name handling in ZLS_COLORS

2000-06-17  Clint Adams  <schizo@debian.org>

	* 11966: Completion/Core/_main_complete: use double brackets
	around comparison to prevent 'command not found: no' error.

2000-06-17  Bart Schaefer  <schaefer@zsh.org>

	* 11961: Src/subst.c: 11959 was really a bug in magicequalsubst,
	it shouldn't have treated x:=y as a reason to expand =y.

2000-06-17  Tanaka Akira  <akr@zsh.org>

	* 11959: Completion/User/_urls: make it magicequalsubst aware.

	* 11958: Completion/User/_java: new completion for Java.

2000-06-17  Bart Schaefer  <schaefer@zsh.org>

	* 11956: Src/loop.c: Fix off-by-one error in wordcode pc executing
	case statement fall-through.

	* unposted: Test/01grammar.ztst: Add a test for 11956.

2000-06-16  Clint Adams  <schizo@debian.org>

	* 11951: Completion/Debian/_dpkg: replaced _arguments -A
	for install and record-avail  with an evaluation kludge.

2000-06-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 11939: Src/Zle/compmatch.c, Src/Zle/compresult.c,
	Src/Zle/zle_tricky.c: allow completion after `a{{b,c},'; fix for
	closing brace re-insertion when completing from both ends
	(CLF_MID)

	* 11938: Completion/Core/_description, Doc/Zsh/compsys.yo: enhance
 	ignore-line to ignore all/current/other word(s)

	* 11937: Completion/Core/_expand, Completion/Core/_list,
 	Doc/Zsh/compsys.yo, Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c:
 	zstyle -e option; change math-styles to boolean ones; change
 	defaults for _expand styles

2000-06-15  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Felix: 11908: Test/54compmatch.ztst: tests for problematic
	cases.

	* as 11916: moved bottom of ChangeLog to ChangeLog-Release to
	avoid unnecessary network activity when committing.  To be
	merged into ChangeLog.4.0 for next release.

2000-06-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 11924: Src/Zle/compmatch.c: more security in completion matching

	* 11915: Completion/Core/_files, Doc/Zsh/compsys.yo: make _files
 	try each pattern only once (and stop after `*')

	* 11910: Src/Zle/computil.c: fix for _arguments, it took
 	non-option strings as options

2000-06-14  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11906: Src/signals.c: yet another two bugs with saving traps:
	flags were prematurely restored when resetting and TRAPEXIT
	was sometimes saved incorrectly when exitting the scope.

2000-06-14  Oliver Kiddle  <opk@zsh.org>

	* 11903: Completion/Core/_expand: handle suffix style for arrays

2000-06-14  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11902: Test/08traps.ztst: add test for localtraps with SIGWINCH.

	* 11901: Src/signals.c: not one but two more bugs in trap
	saving: sigfuncs wasn't reset for function signals, and dosavetrap()
	didn't check sigtrapped before assuming sigfuncs was valid.

	* 11895: Src/signals.c: exit traps weren't cleared from the
	list properly, resulting in memory management problems.

2000-06-14  Sven Wischnowsky  <wischnow@zsh.org>

	* 11885: Src/parse.c: nix kaboom with `time time'

	* 11890: Src/Zle/complist.c: better fix for menu selection on dumb
	terminal

2000-06-13  Clint Adams  <schizo@debian.org>

	* 11882: Completion/Debian/_dpkg: more intelligence in
	dpkg completion.

2000-06-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 11876: Doc/Zsh/compsys.yo, Src/Zle/computil.c: make -A take a
	pattern as argument to match non-arguments; allow single-letter
	option strings to have multiple arguments; fix to allow option
	completion with multiple sets

	* 11872 Completion/Commands/_generic, Doc/Zsh/compsys.yo: new
	_generic widget to call completion with $WIDGET in function field
	of context

	* 11873: Completion/Core/_main_complete, Doc/Zsh/compsys.yo: allow
	insert-tab style to contain `pending[=num]' to handle the case
	when there is pending input

	* 11874: Completion/Core/_expand, Doc/Zsh/compsys.yo: new style
	`suffix', use accept-exact style in _expand

	* 11875: Src/Zle/complist.c: fix for longer capability strings;
	very bad

2000-06-13  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11877: Src/zsh.h: make PRINT_ flags unique again.

2000-06-13  Sven Wischnowsky  <wischnow@zsh.org>

	* 11870: Completion/Core/_path_files, Src/Zle/complete.c,
 	Src/Zle/compmatch.c, Src/Zle/computil.c: fixes for calling
	compfiles, for completing words with special characters; make
	compfiles optimisations work with globcomplete and simple match
	specs

2000-06-12  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11867: Src/builtin.c, Src/params.c, Src/zsh.h,
	Doc/Zsh/builtins.yo: don't use -H flag for parameters mentioned
	explicitly or by pattern.

2000-06-11  Bart Schaefer  <schaefer@zsh.org>

	* 11866: Functions/Misc/colors, Functions/Prompts/promptinit:  Set
	up color/colour assoc arrays to map the full range of ANSI text
	properties; preserve more state during themed prompt previewing.

	* Alexandre: unposted: Src/Zle/complist.c: Shift an array the
	opposite way to fix colored listings crash.

2000-06-11  Tanaka Akira  <akr@zsh.org>

	* 11861: Completion/User/_cvs: fix -a use for compadd.

2000-06-10  Bart Schaefer  <schaefer@zsh.org>

	* 11850: Src/Zle/complist.c: Don't try to menuselect in a listing
	that isn't there, e.g., because the TERM is too dumb to draw it.

2000-06-09  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11842 (repeat of 11838): Doc/Zsh/builtins.yo, Src/builtin.c,
	Src/params.c, Src/subst.c, Src/zsh.h, Src/Modules/mapfile.c,
	Src/Modules/parameter.c: add the HIDEVAL parameter attribute and
	set it by default for parameters created by the mapfile and
	parameter modules, to restore sanity of `typeset' output.

2000-06-09  Clint Adams  <schizo@debian.org>

	* 11839: Src/signals.c: prevent segmentation fault in
	endtrapscope() by not dereferencing null pointers.

2000-06-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 11836: Src/Zle/compcore.c, Src/Zle/complist.c: fix for
 	menu-completion when another completion came right after it

	* 11833: Completion/Core/_path_files, Src/Zle/computil.c: improve
 	_path_files, move some code into C, try to optimise glob patterns
 	and immediately accept exact directory matches

2000-06-08  Oliver Kiddle  <opk@zsh.org>

	* 11823: Doc/Makefile.in, Completion/User/_urls: avoid bug in
	IRIX's sed and use new -K option to zparseopts in _urls

2000-06-08  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11820: Src/main.c: metafication of command line arguments
	didn't work because type table wasn't set up.

2000-06-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 11817: Src/Zle/compmatch.c: more anchor matching fixes

	* 11815: Completion/Core/_expand, Doc/Zsh/compsys.yo: trying to
 	improve _expand; new keep-prefix style, add-space gives more control

	* 11814: Src/Zle/zle_tricky.c: make C-code expansion add a space
 	only when more than one word was generated

2000-06-08  Tanaka Akira  <akr@zsh.org>

	* users/3130: Completion/Debian/_apt: fix actions for _alternative.

2000-06-07  Sven Wischnowsky  <wischnow@zsh.org>

	* 11796: Src/Zle/compmatch.c: try to get the tests for `strings
 	long enough' right in anchor matching code

2000-06-07  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11711: Andrej Borsenkow: Test/ztst.zsh: Ignore diff output
	unless the test failed, to work around some diffs which produce
	success messages.

2000-06-07  Sven Wischnowsky  <wischnow@zsh.org>

	* user/3124: Completion/Core/_normal, Src/Zle/compctl.c: optimise
 	command lookup in old and new completion

	* 11794: Src/Zle/compcore.c, Src/Zle/complist.c, Src/Zle/zle_tricky.c:
 	hopefully more consistent beeping with menu-selection

	* 11792: Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c: -K option for
 	zparseopts to keep previous array values

	* 11789: Completion/Commands/_correct_word,
 	Completion/Commands/_expand_word, Completion/Commands/_next_tags:
 	setup options in bindable commands

2000-06-06  Oliver Kiddle  <opk@zsh.org>

	* 11772: Completion/User/_urls: improvements to 11756 suggested by
	Bart in 11763

2000-06-06  Sven Wischnowsky  <wischnow@zsh.org>

	* 11777: Completion/Core/_expand: make _expand ignore empty
 	expansions

	* 11776: Completion/Core/_path_files: fix for _path_files and
 	globcomplete, better test if word contains wildcards

	* 11768: Doc/Zsh/expn.yo, Src/lex.c, Src/subst.c: make (e) flag be
 	silent unless (X) is given, too

2000-06-05  Oliver Kiddle  <opk@zsh.org>

	* 11756: Completion/User/_urls, Completion/Linux/_rpm: accept -g
	option in _urls and use _urls in _rpm

	* 11755: test/comptest: fix wording in error messages

2000-06-05  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Config/version.mk: 3.1.9, already.

2000-06-05  Oliver Kiddle  <opk@zsh.org>

	* unposted: Src/params.c: AIX dependency fix

2000-06-05  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: Config/version.mk: 3.1.8 released.

	* unposted: 14array.ztst missing from Test/.distfiles.

2000-06-05  Sven Wischnowsky  <wischnow@zsh.org>

	* 11745: Src/builtin.c, Src/Modules/parameter.c, Src/Zle/compresult.c:
 	some more memory leak fixes
	
2000-06-04  Bart Schaefer  <schaefer@zsh.org>

	* 11743: Completion/Linux/_rpm: Complete http as well as ftp URLs
	in the package_file state.

2000-06-04  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 11740: Completion/Linux/_rpm: --{rebuild,recompile} is always
	local files.

2000-06-04  Clint Adams  <schizo@debian.org>

	* 11739: Completion/Debian/_dpkg: complete multiple arguments
	for -i, -r, -P, -l, -L, -s, -S.  _funcalls for the
	newly-introduced states.

2000-06-03  Bart Schaefer  <schaefer@zsh.org>

	* 11737: Src/Makefile.in: Remove modules.index and modules-bltin
	during "make distclean" not "make clean" to prevent unnecessary
	rebuilding of Makefiles in module subdirectories.

	* 11736: Src/signals.c: Fix special scoping of TRAPEXIT.

	* Felix: 11734: Src/Zle/compcore.c, Doc/Zsh/mod_complist.yo: Fix
	one more memory leak and a doc mistake.

2000-06-02  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11733: Doc/Makefile.in: Solaris sed was behaving strangely with
	the commands to create Zsh/modlist.yo.

2000-06-02  Wayne Davison  <wayned@users.sourceforge.net>

	* 11723: Src/glob.c:  Fixed glob-array indexing.

	* unposted: Test/14array.ztst: improved array-indexing tests.

2000-06-02  Sven Wischnowsky  <wischnow@zsh.org>

	* Felix: 11718: Src/module.c: fix for memory leak

	* 11722: Src/Zle/compcore.c, Src/Zle/complete.c: fix some memory
 	leaks (thanks, Felix)
	
2000-06-02  Wayne Davison  <wayned@users.sourceforge.net>

	* 11717: Src/glob.c, Src/params.c, Src/subst.c, Src/zsh.h,
	Src/Modules/mapfile.c, Src/Modules/parameter.c, Src/Zle/complete.c:
	make $array[-4,4] work again.

	* unposted: Test/14array.ztst: added array-indexing tests.

2000-06-01  Wayne Davison  <wayned@users.sourceforge.net>

	* 11716: Src/params.c: Made $array[0,0] work like $array[0].

2000-06-01  Bart Schaefer  <schaefer@zsh.org>

	* 11713: Test/53completion.ztst: Revert the change made in 11647
	because of the completion fix in 11678.

	* 11701: Src/Zle/zle_main.c: Adjust 11566 to disable vared only
	for interactive shells where ZLE has been explicitly disabled,
	but also for any shell running in an emacs buffer.

2000-06-01  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* unposted: Etc/NEWS: notes for 3.1.8.

	* 11707: Src/subst.c: further promptexpand leaks.

	* Felix Rosencrantz: 11700: Src/utils.c memory leak in return
	value of promptexpand.

2000-05-31  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11696: Src/params.c: fix bugs reported in 10990 localising
	readonly specials if they were integer or hashes that needed
	copying.

2000-05-31  Sven Wischnowsky  <wischnow@zsh.org>

	* 11688: Completion/Commands/_complete_debug,
 	Completion/Core/_main_complete, Completion/Core/_setup,
 	Doc/Zsh/compwid.yo, Functions/Zle/incremental-complete-word,
 	Src/Zle/compcore.c, Src/Zle/complist.c, Src/Zle/compresult.c:
 	allow display of only messages via $compstate[list]=messages
	
	* 11549: Completion/Base/_combination, Completion/Base/_command_names,
 	Completion/Base/_describe, Completion/Base/_equal,
 	Completion/Base/_subscript, Completion/Base/_tilde,
 	Completion/Base/_value, Completion/Builtins/_aliases,
 	Completion/Builtins/_bindkey, Completion/Builtins/_builtin,
 	Completion/Builtins/_cd, Completion/Builtins/_command,
 	Completion/Builtins/_compdef, Completion/Builtins/_functions,
 	Completion/Builtins/_hash, Completion/Builtins/_popd,
 	Completion/Builtins/_unhash, Completion/Builtins/_vars,
 	Completion/Builtins/_which, Completion/Builtins/_zcompile,
 	Completion/Builtins/_zle, Completion/Builtins/_zmodload,
 	Completion/Builtins/_zpty, Completion/Builtins/_zstyle,
 	Completion/Commands/_bash_completions,
 	Completion/Commands/_history_complete_word,
 	Completion/Core/_all_labels, Completion/Core/_expand,
 	Completion/Core/_file_descriptors, Completion/Core/_history,
 	Completion/Core/_multi_parts, Completion/Core/_next_label,
 	Completion/Core/_options, Completion/Core/_path_files,
 	Completion/Core/_requested, Completion/Core/_sep_parts,
 	Completion/Core/_set_options, Completion/Core/_unset_options,
 	Completion/Core/_wanted, Completion/User/_archie,
 	Completion/User/_cvs, Completion/User/_domains,
 	Completion/User/_gprof, Completion/User/_groups,
 	Completion/User/_hosts, Completion/User/_lp,
 	Completion/User/_mailboxes, Completion/User/_make,
 	Completion/User/_mount, Completion/User/_mysql_utils,
 	Completion/User/_netscape, Completion/User/_perl,
 	Completion/User/_perl_basepods,
 	Completion/User/_perl_builtin_funcs,
 	Completion/User/_perl_modules, Completion/User/_ports,
 	Completion/User/_rcs, Completion/User/_urls,
 	Completion/User/_users, Completion/User/_yp,
 	Completion/X/_x_color, Completion/X/_x_cursor,
 	Completion/X/_x_extension, Completion/X/_x_font,
	Completion/X/_x_keysym, Completion/X/_xutils: use compadd -[ak]
	
	* Andrej: 11660: Completion/User/_man: fix for ${..//..} with % in 
	search string

	* 11686: Completion/Core/compdump, Completion/Core/compinit: allow
 	using menu-select for compdef -k (i.e.: autoload zsh/complist in
 	such cases)
	
2000-05-31  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Wayne Davison: 11680: Src/params.c: subscript too small/big
	error messages.

	* Wayne Davison: 11677, 11681: Src/glob.c, Src/params.c, Src/subst.c,
	Src/zsh.h, Src/Modules/mapfile.c, Src/Modules/parameter.c,
	Src/Zle/complete.c: make $array[1,0] return a zero-length array.

	* Wayne Davison: 11676: Src/pattern.c: uninitialised variable.

	* Wayne Davison: 11675: Test/07cond.ztst: apparent race condition.

2000-05-31  Sven Wischnowsky  <wischnow@zsh.org>

	* 11682: Src/Zle/compresult.c: move to last cursor after not
 	asking a second time if list should be shown
	
	* 11679: Src/Zle/compcore.c: fix for ignore-line style
	
	* 11678: Completion/Base/_arguments: avoid reporting the same
 	->state more than once
	
2000-05-30  Oliver Kiddle  <opk@zsh.org>

	* 11661: Src/hist.c: AIX dependency fix

2000-05-30  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Config/version.mk: 3.1.7 released.

	* 11652: Etc/MACHINES: tests fail on cygwin.

2000-05-30  Sven Wischnowsky  <wischnow@zsh.org>

	* 11647: Completion/Base/_arguments, Completion/Linux/_rpm,
 	Src/Zle/computil.c, Test/53completion.ztst: fixes for _arguments
 	without multiple sets; change completion test for empty actions
	
2000-05-29  Bart Schaefer  <schaefer@zsh.org>

	* 11644: Use `print -s' in _complete_debug, now that it works.
	
	* 11643: Completion/Linux/_rpm: Factor out option sets that are
	repeated in several states; add more options from RPM v3.
	
	* Wayne Davison: 11641: Src/hist.c, Src/Modules/parameter.c,
	Src/Zle/compctl.c, Src/Zle/zle_main.c: Make sure `curline' has
	sane values at more points during history manipulation, so that
	"print -s" from a ZLE widget doesn't cause confusion.

	* unposted: Completion/Core/_path_files: Add a comment to explain
	the change made in 11635.

2000-05-29  Sven Wischnowsky  <wischnow@zsh.org>

	* 11638: Doc/Zsh/compsys.yo: doc fix, missing `)'
	
	* 11635: Completion/Core/_path_files: make _path_files use glob
 	qualifiers from the line when doing pattern matching
	
	* users/3101: Doc/Zsh/compsys.yo: make handling of default tag clearer
 	in the docs
	
	* 11634: Src/Zle/compcore.c, Src/Zle/compmatch.c, Src/Zle/compresult.c:
 	matching bugs with patterns with two anchors
	
	* 11631: Completion/Base/_arguments: keep information about things
 	to complete in _arguments
	
	* 11624: Completion/Base/_arguments, Completion/Builtins/_zpty,
 	Doc/Zsh/compsys.yo, Src/Zle/computil.c: fixes for _arguments with
 	sets; make _zpty not use sets
	
2000-05-28  Bart Schaefer  <schaefer@zsh.org>

	* 11618: Completion/Base/_arguments: Fix bad shift.

2000-05-28  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11616: Src/Modules/zftp.c: configure test for netinet/in_systm.h
	is broken on several architectures, so just include it everywhere
	except cygwin.

2000-05-28  Oliver Kiddle  <opk@zsh.org>

	* 11615: Completion/Builtins/_which, Completion/Builtins/_unhash:
	use of _arguments for completion of a couple more builtins

2000-05-27  Bart Schaefer  <schaefer@zsh.org>

	* 11606: Src/parse.c, Test/01grammar.ztst: Propagate parse errors
	out of parse_list() and parse_event(), and test that it worked.

	* 11607: Src/builtin.c: For "read -q", open shout if necessary
	even when SHTTY is already a valid descriptor; just don't close
	it again in that case.  Restores behavior from 10727 that was
	lost in 11524.

2000-05-26  Clint Adams  <schizo@debian.org>

	* 11599: Completion/User/_perl_modules: check to make sure
	the directories in @INC exist and are executable before
	trying to cd to them.

2000-05-26  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11590: configure.in, Config/defs.mk.in, Etc/MACHINES,
	Src/Makefile.in, Src/Modules/mathfunc.c, Src/Modules/zftp.c:
	Various Cygwin fixes: compilation glitches in zsh/mathfunc and
	zsh/zftp; installation didn't handle .exe extension properly;
	installation note.

	* 11587: Felix Rosencrantz: Src/pattern.c: uninitialised variable.

2000-05-26  Sven Wischnowsky  <wischnow@zsh.org>

	* 11566: Src/Zle/zle_main.c: disable vared if zle is not enabled
	
2000-05-25  Oliver Kiddle  <opk@u.genie.co.uk>

	* 11579: Completion/Builtins/_compdef, Completion/Builtins/_zpty:
	split _arguments calls into sets to avoid long mutex lists

2000-05-25  Sven Wischnowsky  <wischnow@zsh.org>

	* 11576: Completion/Core/compdump, Completion/Core/compinit:
 	beautify format of compdump file
	
	* 11570: Completion/Core/_path_files: fix for special-dirs when
 	used with -g patterns
	
	* 11569: Src/Zle/complist.c: better cursor-movement in
 	menu-selection
	
2000-05-25  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11567: Src/Modules/zftp.c: fix fcntl() argument for FD_CLOEXEC.

2000-05-25  Sven Wischnowsky  <wischnow@zsh.org>

	* 11565: Completion/Base/_in_vared, Completion/Commands/_complete_debug,
 	Src/Zle/complist.c: force listing in _complete_debug; make
 	complist with list-scrolling stopt at the end of the list when
 	prompt would scroll it out; fix _in_vared to handle `foo[bar]'
	
2000-05-24  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11561: Src/lex.c, Doc/Zsh/expn.yo: don't use RC_QUOTES in Posix
	$'...' quoting.

	* 11560: Doc/Zsh/expn.yo: pipes are pipes even if plumbing isn't.

2000-05-24  Bart Schaefer  <schaefer@zsh.org>

	* 11554: Doc/Zsh/compsys.yo: Rearrange _arguments doc some more.

2000-05-24  Sven Wischnowsky  <wischnow@zsh.org>

	* 11552: Completion/Linux/_rpm, Src/Zle/computil.c: fix for
 	comparguments to make -s have an effect again
	
2000-05-24  Clint Adams  <schizo@debian.org>

	* 11548: Completion/User/_ispell: add -h switch to
	designate input file as HTML.

2000-05-23  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11542: Doc/Zsh/compsys.yo: more wording `improvements'.

2000-05-23  Oliver Kiddle  <opk@zsh.org>

	* 11541:  Completion/User/_chown, Completion/User/_perl_basepods,
	Completion/User/_perl_modules, Completion/User/_user_at_host,
	Completion/AIX/_lsdev: minor completion fixes

	* 11539: Completion/User/_netscape, Completion/User/_urls: further
	suffix handling improvements

2000-05-23  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11537: Completion/Command/_complete_tag,
	Completion/Command/.distfiles, Doc/Zsh/compsys.yo: new
	_complete_tag function.

2000-05-23  Sven Wischnowsky  <wischnow@zsh.org>

	* 11536: Doc/Zsh/mod_zutil.yo: doc clarifications for zparseopts
	
	* 11533: Doc/Zsh/compwid.yo, Src/params.c, Src/Zle/comp.h,
 	Src/Zle/compcore.c, Src/Zle/complete.c: add -[ak] options to
 	compadd
	
	* 11530: Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c: add -E option
 	to zparseopts
	
	* 11525: Completion/Base/_arguments, Completion/Commands/_complete_help,
 	Completion/Commands/_next_tags, Completion/Core/_description,
 	Completion/Core/_next_label: use `set -A' instead of `eval' in
 	more places
	
	* 11524: Src/builtin.c: fix for read -q without a shout
	
	* 11523: Src/hist.c, Src/init.c, Src/lex.c, Src/zsh.h, Src/Zle/zle.h,
 	Src/Zle/zle_main.c, Src/Zle/zle_tricky.c: save and restore more
 	variables in bufferwords(); move gotword() into core
	
2000-05-22  Oliver Kiddle  <opk@zsh.org>

	* 11517: Completion/Core/_next_label: don't lose empty arguments

2000-05-22  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11516: Completion/Core/compinstall: select=long-list can
	be combined with select=some number.

2000-05-22  Bart Schaefer  <schaefer@zsh.org>

	* 11515: Completion/Base/_arguments: Fix infinite loop.

	* 11508: Doc/Zsh/index.yo: Add texipage() to printindex().

	* 11485, 11488: Relocate "Compatibility" and "Restricted Shell" docs.

2000-05-22  Chmouel Boudjnah  <chmouel@mandrakesoft.com>

	* 11501: Completion/Linux/_rpm: --buildarch is like --target.

2000-05-22  Sven Wischnowsky  <wischnow@zsh.org>

	* 11503: Src/Zle/zle_tricky.c: make sure wouldinstab is set before
 	calling docomplete()
	
	* 11500: Completion/Core/_main_complete: another fix for
 	`select=long*' in menu style
	
	* 11497: Completion/Core/_main_complete: fix for select-long-list
 	in menu style
	
	* 11496: Src/Zle/compmatch.c: fix for clines in suffix
	
	* 11493: Completion/Core/_main_complete, Doc/Zsh/compwid.yo,
 	Src/Zle/compcore.c, Src/Zle/zle_tricky.c: be more careful when
 	decided if to insert tabs instead of completing
	
	* 11490: Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c: remove -h
 	option from zstyle
	
	* 11489: Completion/Base/_arguments, Doc/Zsh/compsys.yo,
 	Src/Zle/computil.c: pat(-) in long-option patterns to say that
 	argument should be completed only after the `='; merge _arguments
 	and _argument_sets; slightly better test when not to complete options
	
	* 11487: Completion/Core/_expand, Src/Zle/complist.c: fix for
 	a-a-m-c in menu selection; scroll explanations onto screen again
 	when cursor comes near them
	
2000-05-21  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Doc/Zsh/options.yo: Missing () in a tt().
	
	* 11483: Doc/Zsh/func.yo: Fix formatting and other small errors
	introduced in 11352.

2000-05-21  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Config/version.mk: 3.1.7-pre-4.

	* 11478: Doc/Zsh/mod_complist.yo, Doc/Zsh/mod_computil.yo,
	Doc/Zsh/mod_parameter.yo, Doc/Zsh/mod_zle.yo,
	Doc/Zsh/mod_zprof.yo, Doc/Zsh/mod_zpty.yo, Doc/Zsh/mod_zutil.yo,
	Doc/Zsh/zftpsys.yo: Wording changes.

2000-05-20  Bart Schaefer  <schaefer@zsh.org>

	* 11477: Doc/Zsh/compsys.yo: Alphabetize itemized lists.

	* 11473: Src/utils.c: Turn off xtrace while printing PS4.

2000-05-19  Oliver Kiddle  <opk@zsh.org>

	* 11471: Completion/User/_netscape, Completion/User/_urls: do
	a better job of completing suffixes in netscape remote commands

2000-05-19  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* zsh-users/3071: Completion/Core/compdump: avoid HOME=/
	causing zcompdump beginning with //, which confuses cygwin.

	* 11467: Src/match.c, Src/params.c, Src/subst.c, Doc/Zsh/arith.yo:
	[#<base>] in math mode specifies output base for printing and any
	implicit type conversions.

	* zsh-users/3066: Src/system.h: undef HAVE_MMAP for cygwin;
	creates problems running external commands.

2000-05-19  Oliver Kiddle  <opk@zsh.org>

	* 11470: Completion/User/_su: fix to use user's shell after -c

2000-05-19  Bart Schaefer  <schaefer@zsh.org>

	* 11469: Completion/Commands/_complete_debug,
	Completion/Core/_main_complete: Locally unset the errexit option
	and ZERR trap.

	* 11461: Src/builtin.c: Make "read" interruptible even when used
	in the tail of a pipeline.

2000-05-19  Sven Wischnowsky  <wischnow@zsh.org>

	* 11466: Src/Zle/compresult.c: fix for unambiguous string insertion
	
	* 11464: Completion/Base/_arguments, Completion/Core/_approximate,
 	Completion/Core/_files, Completion/Core/_multi_parts,
 	Completion/Core/_sep_parts, Completion/Debian/_apt,
 	Completion/User/_enscript, Completion/User/_finger,
 	Completion/User/_urls, Completion/X/_xutils: don't use $match for
 	something different than (#b)ackrefs
	
2000-05-18  Sven Wischnowsky  <wischnow@zsh.org>

	* 11460: Completion/User/_netscape: fix for completion of
 	`netscape -remote'
	
	* 11459: Completion/Core/_main_complete, Doc/Zsh/compsys.yo: allow
 	_main_complete to call an arbitrary command given as arguments
	
	* 11457: Doc/Zsh/compsys.yo, Src/Zle/compctl.mdd: small doc fix;
 	make compcall autoload compctl module
	
2000-05-18  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11455: Completion/Core/_oldlist: old-menu defaults on.

2000-05-18  Sven Wischnowsky  <wischnow@zsh.org>

	* 11453: Completion/Core/_files: make _files remove backslashes in
 	patterns
	
2000-05-17  Bart Schaefer  <schaefer@zsh.org>

	* Felix Rosencrantz: 11450: Test/comptest: Replace `tr` with
	parameter substitution.

2000-05-17  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws; 11448: Doc/Zsh/compsys.yo, Doc/Zsh/metafaq.yo: more
	changes of phrasing.

2000-05-17  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11444: Completion/Builtins/_zstyle: add old-list and old-menu.

2000-05-17  Tanaka Akira  <akr@zsh.org>

	* 11441: Test/comptest, Test/53completion.ztst,
	Test/54compmatch.ztst: use only one zsh process to test for each
	completion test file.

2000-05-17  Sven Wischnowsky  <wischnow@zsh.org>

	* Felix: 11397 and my 11439: Doc/Zsh/compwid.yo, Src/Zle/comp.h,
	Src/Zle/compcore.c, Src/Zle/compmatch.c, Test/.distfiles,
	Test/54compmatch.ztst, Test/comptest: add Felix' completion
	matching test; some fixes for bugs shown by it

2000-05-17  Bart Schaefer  <schaefer@zsh.org>

	* 11435: Test/53completion.ztst: Update for 11406.

	* 11431: Doc/Zsh/mod_zutil.yo: Chop up the zstyle entry into
	an itemized list for easier reference.

2000-05-17  Sven Wischnowsky  <wischnow@zsh.org>

	* 11429: Completion/Core/_main_complete: fix completion after
 	tilde and equal sign inside quotes
	
2000-05-17  Tanaka Akira  <akr@zsh.org>

	* 11426: Src/Modules/zpty.c: don't use #elif.

2000-05-16  Tanaka Akira  <akr@zsh.org>

	* 11420: Src/Modules/zpty.c: try more pty device files.

2000-05-16  Bart Schaefer  <schaefer@zsh.org>

	* 11419: Test/Makefile.in: Interpolate TESTNUM variable in the
	glob that specifies which tests are run.
	
	* Felix Rosencrantz: 11398: Completion/User/_lzop,
	Completion/Bsd/_bsd_pkg: Fix typos in option descriptions.

	* 11378: Functions/Misc/is-at-least, Misc/make-zsh-urls: Remove
	RCS Id strings.

	* unposted: Doc/Zsh/cond.yo: Yodl off some excess whitespace.
	
2000-05-16  Tanaka Akira  <akr@zsh.org>

	* 11415: Completion/User/_cvs: follow the new matcher-list behaviour.

2000-05-16  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11410: Src/glob.c: tokenize `=' in tokenize(), so that `=cmd'
	will be a candidate for expansion if `~user' is (respecting
	any relevant options).

2000-05-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 11408: Completion/Core/_main_complete, Completion/Core/_normal,
 	Doc/Zsh/compsys.yo: fixed configuration of menu-selection with
 	menu style; pseudo-context `-command-line-', handy for completion
 	in vared

	* 11407: Completion/Base/_tilde, Completion/Core/_path_files:
 	avoid tilde- and parameter-completion in quotes

	* 11406: Completion/Base/_arguments: make _arguments take the
 	attempt to add matches as an indication not to do default
 	option-completion

	* 11403: Completion/Core/_expand, Src/Zle/compcore.c,
	Src/Zle/complist.c: fix scrolling in menu-selection with matches
	spanning multiple lines

2000-05-16  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: one hunk of 11381: Completion/Builtins/_vars_eq:
	bad substitution, now picked up by changes in 11380.

	* pws: 11402: Doc/Zsh/options.yo: correct and expand OCTAL_ZEROES
	entry.
	
2000-05-16  Sven Wischnowsky  <wischnow@zsh.org>

	* 11401: Src/Zle/complist.c: make menu-select accept the match
 	when typing a non-special character
	
2000-05-16  Tanaka Akira  <akr@zsh.org>

	* 11396: Completion/User/_look: display a message when
	an argument is empty.

	* 11394: Completion/User/_cvs: rewrite filename completion
	functions.

2000-05-15  Tanaka Akira  <akr@zsh.org>

	* 11393: Completion/User/_diff_options: use `=-'.

	* 11392: Completion/Core/_description: ignore-line fix.

2000-05-15  Clint Adams  <schizo@debian.org>

	* 11387: Doc/Zsh/options.yo, Src/math.c, Src/options.c,
	Src/zsh.h: new option OCTAL_ZEROES to enable parsing
	in 11385, on by default in 'sh' emulation.

	* 11385: Src/math.c: interpret integer constants beginning
	with '0' as octal to conform to IEEE Std 1003.2-1992
	(ISO 9945-2:1993).

2000-05-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 11380: Src/subst.c: detect additional characters in parameter
 	expansions and signal an error for them
	
	* 11379: Completion/Base/.distfiles, Completion/Base/_in_vared,
 	Completion/Core/_compalso, Completion/Core/_complete,
 	Completion/Core/_main_complete, Doc/Zsh/compsys.yo: add _in_vared
 	for completion inside vared; make insert-tab default to `false'
 	there
	
2000-05-15  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11375: Completion/Core/compinstall: menu select keyword takes
	values long and long-list.

2000-05-15  Oliver Kiddle  <opk@zsh.org>

	* 11376: Makefile.in: install functions before man pages

2000-05-15  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* unposted: Etc/FAQ.yo: updated from website.

2000-05-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 11374: Src/Zle/compcore.c: extra paranoia for empty
 	prefix/suffix in completion matching
	
	* 11368: Src/utils.c: fix for empty (s::) separator and strings
 	with meta-characters
	
	* 11365: Src/Zle/zle_tricky.c: fix for completion of string with
 	single quote
	
	* 11364,11367: Completion/Core/_path_files, Src/Zle/compmatch.c:
	fix for suffix-matching; better in-path completion in _path_files
	
2000-05-15  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11362: Doc/Zsh/manual.yo, Doc/Zsh/metafaq.yo, Doc/Zsh/seealso.yo:
	pointers and menu entries for userguide wrong.

2000-05-15  Sven Wischnowsky  <wischnow@zsh.org>

	* 11360: Src/Modules/zutil.c: zparseopts should detect if it is
 	called without option descriptions
	
2000-05-15  Oliver Kiddle  <opk@zsh.org>

	* 11358: Src/builtin.c, Src/hashtable.c, Completion/Builtins/_hash,
	Doc/Zsh/builtins.yo, Completion/Builtins/_vars_eq: add -L opt to hash

2000-05-14  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11352: Src/builtin.c: make integer builtin understand `-i base'.

	* 11352: Completion/Base/_jobs: typo in suspended jobs.

	* 11352: Doc/Zsh/*: various changes of phrasing.

2000-05-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 11349: Completion/Base/_arguments, Completion/Core/_message,
 	Src/Zle/computil.c: fix for completing options with `_arguments
 	-s'; fix for _message to use `builtin compadd'
	
2000-05-12  Oliver Kiddle  <opk@zsh.org>

	* 11347: Completion/Builtins/_hash, Completion/Builtins/_vars_eq:
	use _arguments for hash completion and add + options for typeset

2000-05-12  Sven Wischnowsky  <wischnow@zsh.org>

	* 11346: Src/Zle/compmatch.c, Src/Zle/compresult.c: fixes for
 	completion matching
	
	* 11335: Src/Zle/compcore.c: fix for compadd -x when there are no
 	matches
	
2000-05-11  Bart Schaefer  <schaefer@zsh.org>

	* 11332: Completion/Commands/_complete_debug: Test descriptors
	correctly for redirect/restore of stderr; plus aesthetic tweak.

	* 11326: Src/exec.c: Don't reinitialize SHTTY upon "exec < file"
	when ZLE is active.

2000-05-11  Oliver Kiddle  <opk@zsh.org>

	* 11329: Completion/User/_groups: redirect ypcat stderr to /dev/null

2000-05-11  Sven Wischnowsky  <wischnow@zsh.org>

	* 11324: Completion/Base/_argument_sets, Completion/Base/_arguments,
 	Src/Zle/computil.c: make _argument_sets add the options as
 	defaults when there is nothing else to complete

	* 11321: Completion/Core/_files: _files used alternative tag-order
 	values even if not needed

	* 11320: Completion/Base/_argument_sets, Completion/Base/_arguments,
 	Doc/Zsh/compsys.yo, Src/Zle/computil.c: allow internally-mutually
 	exclusive sets in _argument_sets; fixes for _argument_sets and the
 	C-code forit

	* 11319: Completion/Core/_main_complete, Doc/Zsh/compsys.yo,
 	Doc/Zsh/mod_complist.yo, Src/Zle/compcore.c, Src/Zle/complist.c:
 	make ^G in menu-selection restore the old command line; add
 	select=long* values for menu style to start menu-selection if list
 	is too long for screen

2000-05-11  Oliver Kiddle  <opk@zsh.org>

	* 11315: Doc/Zsh/builtins.yo, Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo,
	Doc/Zsh/expn.yo, Doc/Zsh/grammar.yo, Doc/Zsh/mod_complist.yo,
	Doc/Zsh/mod_computil.yo, Doc/Zsh/mod_deltochar.yo,
	Doc/Zsh/mod_mathfunc.yo, Doc/Zsh/mod_parameter.yo, Doc/Zsh/mod_zle.yo,
	Doc/Zsh/mod_zutil.yo, Doc/Zsh/options.yo, Doc/Zsh/params.yo,
	Doc/Zsh/zftpsys.yo: Fix spelling in docs

	* 11316: Src/params.c: remove return value from uniqarray which
	caused a compiler error on IRIX

2000-05-10  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11314: Src/builtin.c, Src/params.c: typeset -Uing tied variables
	didn't update the value in the environment.

2000-05-10  Bart Schaefer  <schaefer@zsh.org>

	* 11312: Config/config.mk: defs.mk depends on config.status.

2000-05-10  Tanaka Akira  <akr@zsh.org>

	* 11309, 11310: Doc/Zsh/expn.yo: fix missing section.

2000-05-10  Bart Schaefer  <schaefer@zsh.org>

	* 11302: Functions/Zle/edit-command-line: Cursor placement and
	defensive programming.

2000-05-10  Oliver Kiddle  <opk@zsh.org>

	* 11301: Src/Zle/zle_misc.c: AIX dependency fix

	* 11300: Completion/User/_nedit: fix breakage from 11195

2000-05-10  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11299: Bart/pws: Functions/Zle/edit-command-line: edit command
	line with external editor.

2000-05-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 11298: Doc/Zsh/compsys.yo, Src/Zle/computil.c: more fixes for
 	_arguments and its docs
	
2000-05-10  Bart Schaefer  <schaefer@zsh.org>

	* 11297: Doc/Zsh/compwid.yo, Doc/Zsh/zle.yo: Document that ZLE
	user-defined widget functions are executed with standard input
	closed.
	
2000-05-10  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Naoki Wakamatsu: 11287: Completion/Core/compinstall: tab had
	incorrectly turned to spaces.

2000-05-10  Sven Wischnowsky  <wischnow@zsh.org>

	* 11295: Doc/Zsh/compsys.yo, Src/Zle/computil.c: misc. _arguments
 	fixes
	
	* 11294: Src/Zle/computil.c: fix for `-+opt' with mutex list
	
	* 11292: Completion/Core/_files: update `%p' replacement in _files
	
2000-05-09  Bart Schaefer  <schaefer@zsh.org>

	* 11288: Completion/Commands/_complete_help,
	Completion/Core/_main_complete: Reopen stdin from /dev/null,
	because ZLE closes it during any widget function, which confuses
	some external programs.

2000-05-09  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11285: Src/Modules/zftp.c: move cleanup code to
	zftp_cleanup() to be called from exit hook.

2000-05-09  Oliver Kiddle  <opk@zsh.org>

	* 11284: Completion/Base/_math: use _math to complete the let builtin

	* 11282: Completion/Builtins/_vars_eq: complete using _arguments
	for typeset and its variants

2000-05-09  Tanaka Akira  <akr@zsh.org>

	* 11278: Completion/User/_ssh: disable forwarding to use ssh.

2000-05-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 11277: Functions/Misc/nslookup: make nslookup function more like
 	real nslookup

2000-05-09  Tanaka Akira  <akr@zsh.org>

	* 11276: configure.in, Src/Modules/zftp.c: fix build on OpenBSD.

2000-05-09  Sven Wischnowsky  <wischnow@zsh.org>

	* 11274: Completion/Builtins/_zstyle, Completion/Core/_main_complete,
 	Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo, Src/Zle/compcore.c,
 	Src/Zle/zle_tricky.c: give control over insertion of tab when no
 	non-blank character before cursor; add insert-tab style
	
	* 11273: Completion/Base/_argument_sets,
 	Completion/Base/_arguments: option name clash in _arguments
	
	* 11272: Completion/Base/_arguments: fix for _arguments without
 	options and no more arguments to complete
	
	* 11270: Doc/Zsh/compsys.yo, Src/Zle/computil.c: new -A and -S
 	options to _arguments; `-opt=-' specs for options whose argument
 	has to come after the `='
	
2000-05-08  Oliver Kiddle  <opk@zsh.org>

	* 11268: Doc/Zsh/compsys.yo, Doc/Zsh/builtins.yo: minor typo fixes

	* unposted: Etc/CONTRIBUTORS fix

2000-05-08  Bart Schaefer  <schaefer@zsh.org>

	* 11264: Doc/Zsh/compat.yo: Missed bit for 10771.

2000-05-08  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11260: Doc/Zsh/options.yo: docs for 11044

	* Hiroki Tamakoshi: 11044: Src/options.c, Src/utils.c, Src/zsh.h: 
	Option to use Dvorak keyboard in spell-checking.

2000-05-08  Geoff Wing  <gcw@zsh.org>

	* gcw: unposted: Etc/CONTRIBUTORS fix

2000-05-08  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11252: Functions/Zftp/zf*: context should be
	e.g. `:zftp:zfopen', no colon at the end.

2000-05-08  Sven Wischnowsky  <wischnow@zsh.org>

	* 11255: Src/Modules/zpty.c: close fd for pty-master in sub-shell
	
	* 11253: Completion/Base/_arguments, Src/Zle/computil.c: more
 	problems with optional arguments in _arguments
	
	* 11248: Src/Zle/compmatch.c: better cursor positioning in words
 	with multiple ambiguous word parts
	
2000-05-08  Tanaka Akira  <akr@zsh.org>

	* Bart, Tanaka Akira: 11247: Src/exec.c: Don't signal to a process
	group which has only zombie processes.

2000-05-08  Peter Stephenson <pws@zsh.org>

	* Config/version.mk: 3.1.7-pre-3

2000-05-08  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11244: Completion/Builtins/_zstyle, Completion/Core/_description,
 	Completion/Core/_expand, Doc/Zsh/compsys.yo: make _expand call
 	_complete when called from _expand_word; add ignore-line style to
 	ignore words already on the line
	
	* 11242: Completion/Builtins/_pids, Completion/Builtins/_zstyle,
 	Completion/Commands/_complete_help, Completion/Core/_all_labels,
 	Completion/Core/_approximate, Completion/Core/_expand,
 	Completion/Core/_ignored, Completion/Core/_main_complete,
 	Completion/Core/_prefix, Completion/Core/_setup,
 	Doc/Zsh/compsys.yo, Src/Zle/complete.mdd, Src/Zle/complist.c:
 	misc. completion cleanups and changes
	
2000-05-06  Bart Schaefer  <schaefer@zsh.org>

	* 11236: Completion/Base/_arguments: Handle tabs between options
	and their descriptions when parsing --help output.

2000-05-06  Tanaka Akira  <akr@zsh.org>

	* 11224: Util/mkdisttree.sh: problem with pattern matching `.' in
	find.

	* 11223: Completion/Base/_regex_arguments, Completion/Debian/_apt,
	Completion/X/_xset, Completion/X/_xwit, Doc/Zsh/compsys.yo:
	_regex_arguments use _alternative.

2000-05-05  Tanaka Akira  <akr@zsh.org>

	* 11219: Completion/User/_cvs, Completion/User/_diff_options: add
	option description to `_cvs' and fix typo in _diff_options.

2000-05-05  Oliver Kiddle  <opk@zsh.org>

	* 11216: Doc/Zsh/builtins.yo, Src/loop.c: small doc fix and AIX
	dependency fix

2000-05-05  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11214: Completion/Core/compinstall: remember file in
	filename style for :compinstall context; make null matchers
	more obvious.

	* 11200: Src/subst.c, Doc/Zsh/expn.yo: backout change that
	${foo/$subst/repl} would allow # and % anchors inside $subst.

	* Andrej Borsenkow: 11194: Completion/Base/_arguments,
	Completion/User/_configure: use globsubst for substitutions
	via -s option to _arguments and hence use (#s) for anchor
	in _substitutions from _configure.

2000-05-05  Tanaka Akira  <akr@zsh.org>

	* 11213: Completion/User/_cvs: don't complete files which is
	already on command line for `cvs add', `cvs remove' and `cvs commit'.

	* 11204: Completion/User/_look: use more precise explanation and
	complete an optional second argument.

2000-05-05  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11196: Functions/Misc/zmv: allow (**/) to map to a
	parameter in the obvious way; allow automatic recognition of
	wildcards with -w flag; turn off glob qualifiers by default, use
	-Q to turn on; fix bug with empty match eliding a positional
	parameter; fix bug that empty `to' pattern wasn't picked up.

	* pws: unposted: fixes for Etc/CONTRIBUTORS based on suggestions
	in 11187 and 11197

2000-05-05  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11195: Completion/AIX/_lsdev, Completion/Builtins/_bindkey,
 	Completion/Builtins/_compdef, Completion/Builtins/_zcompile,
 	Completion/Builtins/_zpty, Completion/Builtins/_zstyle,
 	Completion/User/_archie, Completion/User/_bzip2,
 	Completion/User/_compress, Completion/User/_enscript,
 	Completion/User/_finger, Completion/User/_gzip,
 	Completion/User/_imagemagick, Completion/User/_look,
 	Completion/User/_lynx, Completion/User/_lzop,
 	Completion/User/_mutt, Completion/User/_nedit,
 	Completion/User/_nslookup, Completion/User/_socket,
 	Completion/User/_telnet, Completion/User/_wget,
 	Completion/User/_whois, Completion/X/_xauth: completion function
 	cleanup for `_arguments' with the `-C' option and using it's
 	return value
	
	* 11193: Src/Zle/comp.h, Src/Zle/compcore.c: some more memory
 	initialisation after allocation; shouldn't possibly have done any
 	harm
	
2000-05-05  Tanaka Akira  <akr@zsh.org>

	* 11190: Completion/User/_look: new completion for look.

2000-05-05  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11185: Etc/CONTRIBUTORS: updated for 3.1.7.

2000-05-05  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11188: Completion/Core/_main_complete, Completion/Core/_message:
 	make _message independent of when it is called
	
	* 11186: Functions/Misc/nslookup: use `eval' in nslookup for
 	pager, in case someone has PAGER='less -foo' or some such
	
2000-05-05  Oliver Kiddle  <opk@zsh.org>

	* 11184: Completion/User/.distfiles, Completion/User/_bzip2,
	Completion/User/_compress, Completion/User/_lzop,
	Completion/User/_pack, Completion/User/_zcat: use one function for
	each of compress/uncompress and pack/unpack and new lzop completion

2000-05-05  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11181: Src/Modules/zpty.c: make zpty -r stoppable even when
 	SIGINT is caught (and the handler calls return or some such)
	
	* 11177: Functions/Misc/nslookup: make nslookup page it's output
 	if too long for screen
	
	* Wayne: 11171: Src/builtin.c, Src/hist.c: fix for print -s when
	called from widget; added lines are not immediately available,
	though

	* 11172: Src/Zle/computil.c: fix for completion arguments of
 	options, don't use all of them at once
	
	* 11170: Src/jobs.c: fix for jobs -l -d, check if directory of job
 	is already set
	
2000-05-04  Tanaka Akira  <akr@zsh.org>

	* 11166: Completion/Base/_regex_arguments: remove debugging code.

	* 11165: Completion/Base/_regex_arguments, Completion/Debian/_apt,
	Completion/X/_xset, Completion/X/_xwit, Doc/Zsh/compsys.yo,
	Src/Modules/zutil.c: _regex_arguments support tag stuff.

	* 11157: Completion/Core/_requested: fail if _all_labels is failed.

2000-05-04  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11147: Test/08traps.ztst: test for trap bugs fixed in
	11026 and 11066.

2000-05-04  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11151: Src/exec.c, Src/parse.c, Src/Modules/zpty.c: close dump
 	file descriptors in children
	
	* 11145: Src/lex.c: parse_subst_string() should use modified
 	version of `len'
	
	* 11144: Src/Modules/zpty.c: make pty the controlling terminal of
	their commands

	* 11142: Src/lex.c: save and restore `len' in lexsave/restore
	
	* 11140: Completion/Builtins/_zstyle, Completion/Core/_main_complete,
 	Doc/Zsh/compsys.yo, Src/Zle/compcore.c, Src/Zle/compctl.c: don't
 	list when all matches look the same; force-list style to give
 	users control over this
	
2000-05-03  Tanaka Akira  <akr@zsh.org>

	* 11137: Test/07cond.ztst: detect block device file using find.

2000-05-03  Bart Schaefer  <schaefer@zsh.org>

	* 11136: Doc/Zsh/expn.yo: Reorganize history expansion doc.

2000-05-03  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11126: Doc/Zsh/expn.yo: typos in 11117.

2000-05-03  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11121: Completion/User/_fakeroot, Completion/User/_rlogin,
 	Completion/User/_ssh, Completion/User/_sudo,
 	Completion/User/_xargs, Completion/X/_xutils, Doc/Zsh/compsys.yo,
 	Src/Zle/computil.c: allow `-' in exclusion lists for _arguments,
 	to avoid completing all options
	
	* 11117: Doc/Zsh/expn.yo, Src/hist.c: fix for the (z) flag: report
 	partial word (like `"foo', without a closing quote); mention in
 	manual that (z) is handled lately
	
	* Andrej: 11067: Completion/Builtins/_zcompile: handle -t option

	* 11113: Doc/Zsh/expn.yo, Src/hist.c, Src/subst.c,
 	Src/Modules/parameter.c, Src/Zle/zle_misc.c: new (z) parameter
 	flag to do shell-word splitting on the value
	
	* 11110: Completion/Core/_expand, Src/Zle/complist.c: remove
 	backslashes before `$' in _expand when `substitute' is unset; fix
 	for clearing end-of-list lines in menu-selection
	
2000-05-03  Tanaka Akira  <akr@zsh.org>

	* 11109: Completion/X/_xauth: new completion for xauth.

	* 11106: Completion/User/_mount: fix glob for device files.

2000-05-03  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11096: Test/ztst.zsh, Test/13parameter.ztst: fix test output
	for C locale and ensure C locale is used

2000-05-03  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11094: Doc/Zsh/compsys.yo: more doc fixes
	
	* 11092: Completion/Base/_arguments, Src/Zle/compcore.c: make sure
 	that completion messages are displayed even when there are no
 	matches
	
	* 11091: Functions/Zftp/zfcd_match: fix for completion of
 	directories for zftp suite
	
	* 11086: Src/builtin.c: allow calling `print -s' in widgets, avoid
 	duplicated history number
	
2000-05-02  Bart Schaefer  <schaefer@zsh.org>

	* 11077: Relocate misplaced redirection from 11043.

	* 11036, 11063: Always write the `read -q' prompt to shout;
	elminate some redundant close() calls.

2000-05-02  Oliver Kiddle  <opk@zsh.org>

	* 11078: README: update download location for yodl

2000-05-02  Tanaka Akira  <akr@zsh.org>

	* 11075: configure.in: install completion functions for AIX and BSD.

2000-05-02  Andrew Main  <zefram@zsh.org>

	* 11074: Src/Makemod.in.in: make sure .{e,}pro files are
	non-empty, to keep the AIX compiler quiet.

2000-05-02  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11066: Src/exec.c: suppress doing ZERR traps at the end
	of a sequence of &&/|| when another sublist follows.

2000-05-02  Oliver Kiddle  <opk@zsh.org>

	* 11065: Completion/Commands/_complete_debug: small fix to avoid
	using slashes in temporary file name

2000-05-02  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11061: Functions/Misc/zrecompile: make zrecompile detect deleted
 	and new files
	
	* 11060: Doc/Zsh/compsys.yo: two more doc fixes
	
2000-05-02  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 11057: Src/builtin.c:  getopts for options with arguments
	miscounted $OPTIND and index into subsequent options (see 9095).

2000-05-02  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11058: Completion/Core/_message, Doc/Zsh/compwid.yo, Src/Zle/comp.h,
 	Src/Zle/compcore.c, Src/Zle/complete.c: add -x option to compadd
 	to display message unconditionally
	
	* 11053: Completion/Commands/_complete_help: always use empty
 	matcher-list style in _complete_help
	
	* 11052: Src/Zle/computil.c: fix for _arguments, use
 	on-line-argument-numbers only for normal arguments, not for
 	arguments of options
	
	* 11049: Completion/Base/_arguments, Completion/Base/_first,
 	Completion/Builtins/_hash, Completion/Core/_expand,
 	Completion/User/_gprof, Completion/User/_mount,
 	Completion/User/_socket, Completion/User/_urls: completion
 	cleanup, mostly _wanted and $expl
	
	* 11048: Completion/Base/_first, Completion/Core/_complete,
 	Completion/Core/_path_files: make completion-in-vared complete
 	parameter values as default; cleanup for _path_files
	
	* 11047: Completion/Core/_sort_tags, Doc/Zsh/compsys.yo,
 	Doc/Zsh/compwid.yo: completion doc fixes and cleanup; _sort_tags
 	updated
	
2000-05-01  Bart Schaefer  <schaefer@zsh.org>

	* 11043: Completion/Core/_expand, Completion/User/_nedit: Catch
	an eval-time parse error by forcing the eval into a subshell;
	don't fail on nonexistent ~/.nedit file.

2000-05-01  Oliver Kiddle  <opk@zsh.org>

	* 11041: Completion/User/.distfiles, Completion/User/_bzip2:
	use of _arguments for bzip2 completion

	* 11037: Etc/MACHINES, Etc/NEWS, Etc/completion-style-guide,
	Etc/zsh-development-guide: spelling corrections

2000-04-30  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11033: Completion/Commands/.distfiles,
	Completion/User/.distfiles, Config/version.mk, Etc/NEWS:
	new NEWS and minor fixes for version 3.1.7-pre-2.

2000-04-30  Bart Schaefer  <schaefer@zsh.org>

	* 11032: Src/init.c: Fix signed-ness problem reported by OPK.

2000-04-30  Oliver Kiddle  <opk@zsh.org>

	* 11031: Src/math.c, Src/glob.c, Src/module.c, Src/Zle/compcore.c
	Src/Zle/compresult.c: AIX dependency fixes.

2000-04-30  Bart Schaefer  <schaefer@zsh.org>

	* 11029: Src/hashtable.c, Src/signals.c: Back out more bits of
	11015 made obsolete by 11026.

2000-04-30  Clint Adams  <schizo@debian.org>

	* 11027: Josip Rodin: Completion/User/_joe:
	completion for joe.

2000-04-30  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 11026: Src/builtin.c, Src/hashtable.c, Src/signals.c,
	Test/08traps.ztst: fix unfunction problem for localtraps by
	always copying traps to be saved, hence decoupling saved and actual
	traps.

2000-04-30  Bart Schaefer  <schaefer@zsh.org>

	* 11024: Completion/Commands/_complete_debug, Doc/Zsh/compsys.yo:
	Completion widget that enables and captures xtrace output.

2000-04-29  Adam Spiers  <adam@spiers.net>

	* 11019: Doc/Zsh/compsys.yo: fix bug in _description example

	* 11017: Completion/Linux/_rpm: fixes for --rmsource and
	--recompile options, and for breakage caused by 10772

2000-04-28  Bart Schaefer  <schaefer@zsh.org>

	* 11015: Src/builtin.c, Src/hashtable.c, Src/signals.c:
	`unfunction TRAPxxx' now works with localtraps in effect.

2000-04-28  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 11013: Completion/Core/compinstall: more breaks and
	a completion context.

2000-04-28  Bart Schaefer  <schaefer@zsh.org>

	* 11012: Doc/Zsh/intro.yo, Doc/Zsh/manual.yo: Reorder menus
	to match sections in 11008.

2000-04-28  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 11008: Doc/zsh.yo, Doc/Zsh/compctl.yo, Doc/Zsh/compsys.yo,
 	Doc/Zsh/compwid.yo, Doc/Zsh/modules.yo, Doc/Zsh/seealso.yo,
 	Doc/Zsh/zle.yo: move compctl docs behind compsys, mention
 	`zcompile -z' in compsys
	
	* 11007: Src/Zle/compmatch.c: misplaced cursor with partial-word
 	matching
	
	* Tanaka: 11001: Completion/User/_enscript, Completion/User/_lp,
	Completion/User/_printers: printer-detection moved to new
	_printers; used by _enscript

	* 11003: Src/Zle/computil.c: fix for reporting multiple actions in
 	comparguments, options with non-optional arguments
	
2000-04-28  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* pws: 10999: Completion/Core/compinstall: some idiot didn't
	get searching of alternative files for definitions to work properly.

2000-04-28  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10992: Src/Zle/complist.c: avoid wrapping around both
 	horizontally and vertically at the same time
	
2000-04-27  Bart Schaefer  <schaefer@zsh.org>

	* Tanaka Akira: 10980: Completion for enscript.

2000-04-27  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10985: Completion/Core/compinstall: _oldlist, list-prompt and
	matcher-list enhancements.

2000-04-27  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10979: originally from Felix: 10894: Completion/Core/.distfiles,
	Completion/Core/_history, Doc/Zsh/compsys.yo: new _history completer
	
	* 10978: Src/Zle/complist.c: better wrap around for cursor
	movement widgets; avoid flicker when leaving menu-selection
	
	* 10977: and Andrej: 10976: Completion/User/_make: use $words[1]
 	to call make in _make and throw away stderr and use _call
	
	* 10974: Completion/Base/_arguments: ensure $PWD is prepended to
 	cache-names for long options in _arguments
	
2000-04-27  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10971: Src/pattern.c: noglobdots didn't work with the PAT_ANY
	flag, which meant that **/ always globbed dots.

2000-04-27  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10967: Completion/Base/_arguments: fix for automatic
 	option-argument completion with partially typed option in _arguments
	
	* 10965: and Felix: 10952: Completion/User/_urls,
 	Doc/Zsh/compsys.yo: document _wanted -C; fix for call to _wanted
 	in _urls
	
	* 10963: Src/Zle/complete.c: fix for parse error with
 	left-anchored patterns
	
	* 10961: Src/Zle/complist.c: make menu-selection handle
 	undefined-key
	
	* 10959: Completion/Core/_main_complete, Doc/Zsh/compsys.yo,
 	Doc/Zsh/mod_complist.yo, Src/params.c, Src/Zle/compcore.c,
 	Src/Zle/complete.c, Src/Zle/complist.c, Src/Zle/compresult.c:
 	renamed parameters for menu selection to MENUSELECT, MENUPROMPT
 	and MENUSCROLL; no special value for LISTMAX to turn on list
 	scrolling, this is done by setting LISTPROMPT now; default values
 	for LISTPROMPT and MENUPROMPT when set but empty
	
2000-04-27  Adam Spiers <adam@spiers.net>

	* 10949: Completion/User/_perl_modules: print warning when
	perl not found on PATH forces guessing of @INC

2000-04-26  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10933: Completion/Commands/_bash_completions,
 	Completion/Commands/_history_complete_word: ensure options are set
 	as expected in _history_complete_word and _bash_completions
	
	* Adam Spiers: 10892: Completion/User/_perl_modules: ensure perl
	is there and better pattern for searching modules

	* Tanaka Akira: 10890: Completion/User/_gunzip,
	Completion/User/_gzip, Completion/User/_zcat: new completion for
	GNU zip commands

	* Tanaka Akira: 10885: Completion/X/_xset: new completion function
	for xset

	* 10926: Completion/X/_x_color, Doc/Zsh/compwid.yo, Src/Zle/complete.c,
 	Src/Zle/compmatch.c: allow to anchor on gaps between strings in
 	matching control specs
	
	* 10925: Src/Zle/compmatch.c: faster test for `*'-patterns in
 	matching control; prefer direct character matches over match specs
 	in recursive invocations of match_str()
	
	* 10924: Src/Zle/compmatch.c: fix for matching control; improve
 	merging cline lists
	
	* 10923: Completion/Core/_main_complete: better default value for
 	list-prompt style
	
	* 10922: Completion/Core/_path_files: file-sort made $fignore fail
	
2000-04-25  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10917: Src/Zle/complist.c, Src/Zle/compresult.c: don't show
 	empty hidden matches even in menu-selection
	
	* 10916: Completion/Core/_main_complete, Src/Zle/complist.c:
 	re-calculate number of line with mark when needed; make default
 	prompts more consistent
	
	* 10915: Src/Zle/computil.c: forgotten fix for _arguments using
 	multiple actions
	
	* 10912: Src/Zle/compresult.c: don't always ignore backslashes in
 	paths when testing file type
	
	* 10910: Completion/Base/_tilde, Completion/Core/_all_labels,
 	Completion/Core/_requested: small fix for _requested to be able to
 	use _all_labels from within it
	
	* 10909: Completion/Core/_expand, Src/Zle/compcore.c,
 	Src/Zle/compresult.c: report prefix/suffix of parameter expansion
 	in IPREFIX/ISUFFIX; make _expand use them to be able to expand $foo
	
	* 10908: Completion/Base/.distfiles, Completion/Base/_argument_sets,
 	Completion/Base/_arguments, Completion/Base/_describe,
 	Completion/Builtins/_bindkey, Completion/Builtins/_compdef,
 	Completion/Builtins/_emulate, Completion/Builtins/_zpty,
 	Completion/Core/_tags, Doc/Zsh/compsys.yo,
 	Etc/completion-style-guide, Src/Zle/computil.c: make _arguments
 	use more than one action when appropriate; add _argument_sets to
 	complete different sets of arguments and options for the same command
	
2000-04-24  Bart Schaefer  <schaefer@zsh.org>

	* 10900: Src/Makefile.in: Replace a dependency on Makefile with a
	more accurate dependency on config.status.

2000-04-20  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10881: Functions/Misc/zrecompile: don't remove *all* .zwc files,
 	keep the first one
	
	* 10868: Src/Zle/complist.c: fix off-by-one error in scrolled
 	menu-selections
	
	* 10861: Completion/Bsd/.distfiles, Completion/Bsd/_bsd_pkg,
 	Completion/Bsd/_cvsup, Completion/Bsd/_kld: new completions for
 	FreeBSD commands
	
	* 10854: Completion/Commands/_expand_word, Completion/Core/_expand,
 	Doc/Zsh/compsys.yo: default values for styles in _expand_word,
 	listing expansions with ^Xd, _expand uses add-space style
	
2000-04-20  Oliver Kiddle  <opk@zsh.org>

	* 10857: Completion/AIX/.distfiles Completion/AIX/_floppy
	Completion/AIX/_lsdev Completion/AIX/_lslv Completion/AIX/_lspv
	Completion/AIX/_lsvg Completion/AIX/_physical_volumes
	Completion/AIX/_smit Completion/AIX/_volume_groups: new completions
	for AIX commands

	* 10848: Completion/Builtins/_print, Completion/Core/.distfiles,
	Completion/Core/_file_descriptors: Add completion for file
	descriptors

2000-04-19  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Config/version.mk: 3.1.7-pre-1

	* Functions/Misc/.distfiles: add zstyle+.

	* Test/.distfiles, Test/12procsubst.ztst, Test/13parameter.ztst,
	Test/ztst.zsh: new tests; use null glob clearing up.

2000-04-19  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* Ollivier Robert: 10844: prefer curses to termcap on HPUX 11
	like 10.

2000-04-19  Oliver Kiddle  <opk@zsh.org>

	* 10833: Completion/Builtins/_print, Completion/Builtins/.distfiles,
	Completion/Builtins/_nothing: new print completion, no arguments to
	clear and logname

2000-04-19  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10830: Doc/Makefile.in: don't force dvips to use 300 dpi.

2000-04-19  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10828: Src/module.c, Src/Zle/zle_tricky.c: ensure zsh/compctl
 	(ick!) module is loaded when zle is loaded from init file but
 	zsh/complete isn't
	
	* 10816: Completion/Core/_main_complete, Doc/Zsh/compsys.yo,
 	Doc/Zsh/mod_complist.yo, Src/Zle/complist.c: default for
 	list-prompt style, %[MLP] use fixed-width strings, %[mlp] use
 	variable-width strings
	
2000-04-18  Sven Wischnowsky  <wischnow@informatik.hu-berlin.de>

	* 10812: Completion/Core/_path_files: fix completion after ~<num>
	
2000-04-18  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10808: Completion/Core/compinstall: handle list-prompt.

	* 10802: Doc/Zsh/mod_complist.yo: typo

2000-04-18  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10807: Completion/Base/_value: change suffix added when
 	completing an assigned value
	
	* 10801: Completion/Builtins/_zstyle, Completion/Core/_main_complete,
 	Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo, Doc/Zsh/mod_complist.yo,
 	Src/Zle/complist.c: completion list scrolling cleanup; *STATUS
 	renamed to *PROMPT, styles for new used parameters, use local
 	keymap when waiting at list-prompt
	
	* 10799: Src/text.c: fix to get newlines in non-job-texts (I'm
 	sooo stupid)
	
	* 10798: Src/Zle/compmatch.c: join_clines() tested the wrong
 	variable
	
2000-04-17  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10789: Doc/Zsh/expn.yo: better documentation for <(...) and
	>(...) implementations and their drawbacks.

	* Chmouel: 10772: Completion/Linux/_rpm:  --target support.

2000-04-17  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10795: Functions/Misc/zstyle+: simplify definiton of styles

	* 10790: Doc/Zsh/mod_complist.yo, Src/params.c, Src/Zle/compcore.c,
 	Src/Zle/complete.c, Src/Zle/complist.c, Src/Zle/compresult.c,
 	Src/Zle/zle_tricky.c, Src/Zle/zle_utils.c: scrolling in completion
 	lists and menu-selection, version1
	
	* 10788: Src/text.c: display newlines as spaces in job-texts
	
	* 10782: Src/Zle/computil.c: fix for exclusion lists for -+o
 	specifications
	
	* 10780: Completion/Base/_default, Completion/Base/_value,
 	Completion/Builtins/_vars_eq, Completion/Builtins/_zstyle,
 	Doc/Zsh/compsys.yo: better completion after `=', everywhere
	
	* 10775: Completion/Core/_description, Completion/Core/_path_files,
 	Completion/Core/_tags, Src/Zle/computil.c: make _tags use C-code
 	for braces in tag-order values; and misc. stuff
	
	* 10774: Src/Zle/compmatch.c: fix for partial word completion with
 	empty parts and common suffix
	
2000-04-16  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10771: Etc/MACHINES: successful compilation on OpenBSD, from
	Anthony Schneider.

	* 10771: Doc/Zsh/builtins.yo, Doc/Zsh/options.yo, Src/builtin.c,
	Src/options.c, Src/zsh.h: New option GLOBAL_EXPORT set by default
	makes typeset -x equivalent to typeset -gx.

2000-04-15  Clint Adams  <schizo@debian.org>

	* 10768: configure.in: DLLDFLAGS for OpenBSD.

2000-04-14  Clint Adams  <schizo@debian.org>

	* 10764: Radim Kolar: Functions/Misc/run-help: support
	for reserved words and multiple arguments being passed
	on to man.

	* 10763: Completion/Builtins/_vars_eq: complete after :

2000-04-14  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10760: Completion/User/_diff_options: just some missing `+'s

2000-04-14  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10756, 10761: Doc/Zsh/expn.yo, Src/glob.c, Src/pattern.c,
	Src/zsh.h: fix (#s) and (#e) to work in allerlei parameter
	substitutions; fix potential problem with (#e) in exclusions; note
	things in manual which should work.

2000-04-13  Clint Adams  <schizo@debian.org>

	* 10748: configure.in: set MAXJOB to whatever you want.

	* 10745: acconfig.h, configure.in, Src/zsh.h: set MAXJOB
	to MAX_TASKS_PER_USER if available under Linux.

2000-04-13  Peter Stephenson  <pws@cambridgesiliconradio.com>

	* 10743: Src/params.c: replenv() failed importing special params
	at start up because it was using the wrong environment block.

	* 10738: Doc/Zsh/builtins.yo, Doc/Zsh/params.yo, Src/builtin.c,
	Src/params.c: local parameters can be exported; typeset +g -x
	and local -x work in a natural way; currently typeset -g still
	behaves like typeset -gx.

2000-04-13  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10733: Completion/Builtins/_pids, Completion/User/_killall,
 	Doc/Zsh/compsys.yo: remove the `pids' tag, use `processes' instead
	
	* 10727: Src/builtin.c: make read -[kq] always print the prompt,
 	if any; after all they make sure they have a terminal anyway
	
	* 10726: Src/hashtable.c: fix field name for HAVE_NIS_PLUS
	
	* 10725: Src/Zle/compcore.c, Src/Zle/compctl.c,
 	Src/Zle/compresult.c: comment the `#if's for group numbers in
 	$compstate[insert]
	
	* 10724: Src/Zle/compresult.c, Src/Zle/zle_tricky.c: display
 	number of matches again when asking if a completion list should be
 	shown (only when not zero)
	
2000-04-12  Bart Schaefer  <schaefer@zsh.org>

	* 10706: Andrej: Completion/User/_man: Fix quoting in awk args.

2000-04-12  Oliver Kiddle  <opk@u.genie.co.uk>

	* 10701: Completion/Builtins/_bindkey, Doc/Zsh/mod_zle.yo:
	use _arguments for bindkey completion and fix typo in docs

2000-04-12  Bart Schaefer  <schaefer@zsh.org>

	* 10700: Andrej: Completion/User/_man: Support for Pyramid.

2000-04-12  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10699: Src/parse.c, Src/zsh.h: compare mapped zwc files using
 	stat instead of the pathnames
	
	* 10695: Completion/Core/_files, Completion/Core/_tags,
 	Doc/Zsh/compsys.yo: allow brace expansion on patterns for
 	file-patterns and tag-order
	
	* 10692: Src/builtin.c: missing initialisation for next field in
 	assignments for substitutions for fc builtin

	* 10691: Completion/Core/_main_complete, Completion/Core/_oldlist:
 	keep _oldlist from using the dummy match inserted for warnings
	
	* 10690: Doc/Zsh/compwid.yo, Src/Zle/compcore.c, Src/Zle/compctl.c,
 	Src/Zle/compresult.c: comment out the code to allow
 	$compstate[insert] to select the group
	
	* 10686: Src/Zle/compresult.c, Src/Zle/zle_tricky.c: display
 	number of lines instead of number of matches when asking whether
 	to show completion lists
	
	* 10685: Doc/Zsh/zle.yo, Src/hist.c, Src/Modules/parameter.c,
 	Src/Zle/iwidgets.list, Src/Zle/zle_misc.c: new widget
 	copy-prev-shell-word, like copy-prev-word but uses shell parsing
 	to find word
	
2000-04-11  Clint Adams  <schizo@debian.org>

	* 10680: Completion/User/_diff_options: spelling corrections.

2000-04-11  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10669: Completion/Core/compinstall:  will now ask for
	alternative files both for input and output.

2000-04-11  Bart Schaefer  <schaefer@zsh.org>

	* 10681: Completion/Commands/_complete_help: Setopts the same
	as _main_complete.

	* 10657: Completion/User/_make: One change missed in 10635.

	* Functions/Prompts/prompt_bart_setup: No-op cleanup.

2000-04-11  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10650: Completion/Core/_files: make trailing blanks in
 	file-patterns tags be removed
	
	* 10648: Completion/Core/_oldlist: make _oldlist ignore old list
 	when _complete_help is used
	
	* 10641: Completion/Core/_approximate, Completion/Core/_match,
 	Completion/Core/_oldlist: make _oldlist ignore list from
 	_complete_help; _match runs for every match spec from
 	matcher-list; _approximate doesn't redefine compadd if that is
 	already a function
	
	* 10635: Completion/User/_make: _make uses $words[1] for command
 	name
	
	* 10632: Completion/Base/_brace_parameter, Completion/Base/_condition,
 	Completion/Base/_default, Completion/Base/_describe,
 	Completion/Base/_first, Completion/Base/_jobs,
 	Completion/Base/_values, Completion/Builtins/_compdef,
 	Completion/Builtins/_hash, Completion/Builtins/_pids,
 	Completion/Builtins/_popd, Completion/Builtins/_sched,
 	Completion/Builtins/_signals, Completion/Builtins/_vars,
 	Completion/Builtins/_zcompile, Completion/Builtins/_zftp,
 	Completion/Builtins/_zpty, Completion/Builtins/_zstyle,
 	Completion/Commands/_next_tags, Completion/Core/_all_labels,
 	Completion/Core/_files, Completion/Core/_next_label,
 	Completion/Core/_requested, Completion/Core/_wanted,
 	Completion/Debian/_apt, Completion/Debian/_deb_packages,
 	Completion/User/_cvs, Completion/User/_gdb,
 	Completion/User/_gprof, Completion/User/_groups,
 	Completion/User/_lp, Completion/User/_mh, Completion/User/_mount,
 	Completion/User/_netscape, Completion/User/_nslookup,
 	Completion/User/_rlogin, Completion/User/_socket,
 	Completion/User/_tiff, Completion/User/_urls,
 	Completion/User/_users, Completion/User/_users_on,
 	Completion/User/_whois, Completion/X/_x_colormapid,
 	Completion/X/_x_display, Completion/X/_x_extension,
 	Completion/X/_x_font, Completion/X/_x_keysym,
 	Completion/X/_x_window, Completion/X/_xmodmap,
 	Completion/X/_xutils, Completion/X/_xwit, Doc/Zsh/compsys.yo,
 	Etc/completion-style-guide, Functions/Zftp/zfcd_match,
 	Functions/Zftp/zfget_match, Src/Zle/computil.c: _wanted now tests
 	both tags and labels; change places where _wanted was called
 	without a command; allow multiple patterns per string in
 	file-patterns; update _next_tags to work with labels
	
2000-04-10  Bart Schaefer  <schaefer@zsh.org>

	* 10628: Doc/Zsh/compsys.yo, Completion/User/_make: Check for
	GNU make using "_call version ..." as was done for GNU diff.

2000-04-10  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10625: Src/parse.c, Src/signals.c: detect ignored signals
 	correctly
	
	* 10622: Completion/Core/_files: typo caused ignored-patterns to
 	be ignored
	
	* 10621: Src/Zle/zle_tricky.c: addx() inserts x more often
	
	* 10620: Src/exec.c: properly restore scriptname in doshfunc()

	* users/3019: Completion/Core/_path_files: use special-dirs with
 	_path_files -g
	
	* 10614: Src/Modules/parameter.c: more careful with checking index
 	of $history
	
	* 10609: Src/Zle/compcore.c, Src/Zle/compresult.c, Src/Zle/zle_tricky.c:
 	fix for bashautolist+automenu
	
2000-04-09  Bart Schaefer  <schaefer@zsh.org>

	* 10606: Fix thinko in 10598.

	* 10602: Completion/Core/compinstall: Fix typo.

	* 10598: Completion/Builtins/_zstyle, Doc/Zsh/compsys.yo:
	Fix typo; reformat styles documentation for readability.

2000-04-09  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Config/version.mk: 3.1.6-dev-22.

	* Completion/Core/compinstall, Doc/Zsh/compsys.yo:  rewrite
	of compinstall to set styles.  Most of this was already in
	3.1.6-dev-21.

2000-04-08  Bart Schaefer  <schaefer@zsh.org>

	* 10594: Functions/Prompts/prompt_bart_setup: Fix index into
	$history in prompt_bart_precmd.

	* 10591: Chmouel Boudjnah: Completion/User/_fakeroot: Completion
	for the fakeroot program.

	* 10590: Chmouel Boudjnah: Completion/Linux/_rpm: Signature
	checking completes only local package files.

2000-04-07  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10584: Doc/Zsh/mod_stat.yo, Src/Modules/stat.c: -o shows
	numeric file modes in octal.

2000-04-07  Bart Schaefer <schaefer@zsh.org>

	* 10582: Src/exec.c: Apply STTY only to process group leaders.

	* 10581: Etc/BUGS, Src/Modules/zpty.c: Note a fixed bug; typo.

	* Chmouel Boudjnah: 10562: Completion/Linux/_rpm: Complete
	only .src.rpm files for "rpm --rebuild".

2000-04-07  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10579: Completion/Base/_arguments, Completion/Base/_values,
 	Completion/Core/_alternative: make sure caller-supplied
 	explanation takes precedence
	
	* 10575: Completion/User/_make: complete make targets of the form
 	`foo bar:'
	
	* 10573: Src/Zle/compmatch.c: cursor placed on wrong word part
 	with ** match spec
	
	* 10571: Completion/Core/_main_complete,
 	Completion/Core/_path_files: missing initialisations, -W with
 	multiple directories didn't work

2000-04-06  Clint Adams  <schizo@debian.org>

	* Felix Rosencrantz: 10564: Completion/X/_x_display:
	typo in _wanted.

	* 10565: acconfig.h, configure.in, Src/exec.c:
	add configure option for function depth limit.

	* 10566: Src/glob.c: change invocation of patgetglobflags
	to use two arguments.

2000-04-06  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10547: Doc/Zsh/expn.yo, Misc/globtests, Src/pattern.c,
	Src/subst.c, Test/11glob.ztst, Test/ztst.zsh: add
	(#s) and (#e) to match at start and end of string.

2000-04-06  Andrew Main  <zefram@zsh.org>

	* 10555: Src/lex.c: Support "3&> foo" etc.

2000-04-06  Andrew Main  <zefram@zsh.org>

	* 10552: configure.in, Etc/zsh-development-guide: List of tools
	required for development work, and a little more conspicuous
	explanation of the config.status hack.

2000-04-06  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10543: Makefile.in: avoid distcleaning Test twice

	* 10542: Completion/Core/_files, Doc/Zsh/compsys.yo: tag in
	file-patterns optional, use `files' as default

	* 10531: Src/init.c: use `zsh' as command name in error messages
	even with -c

2000-04-05  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* 10524: Util/mkdisttree.sh: always copy files to tarred tree;
	chmod g-s.

	* Oliver: 10519: Src/utils.c, Doc/Zsh/compsys.yo: AIX dependencies
	and minor typo in docs.

	* Alexandre: 10516: Completion/User/_prcs: diff options behaviour.
	
	* 10513: Src/glob.c, Doc/Zsh/expn.yo: glob order qualifier (od)
	implements depth-first ordering.

2000-04-05  Bart Schaefer  <schaefer@zsh.org>

	* 10499: Makefile.in: Dependencies relative to $(sdir).

2000-04-05  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10514: Completion/Base/_arguments, Doc/Zsh/compsys.yo:
	support automatically inserted dummy in $words

	* 10511: Completion/Debian/_apt, Completion/Debian/_bug,
	Completion/Debian/_dpkg, Completion/User/_chown,
	Completion/User/_dvi, Completion/User/_imagemagick,
	Completion/User/_ispell, Completion/User/_lp,
	Completion/User/_mount, Completion/User/_mysql_utils,
	Completion/User/_pbm, Completion/User/_psutils,
	Completion/User/_rcs, Completion/User/_rlogin,
	Completion/User/_ssh, Completion/User/_tiff, Completion/User/_yp,:
	Completion/X/_xutils: use basename of commands instead of $words[1]

	* 10508: Completion/Builtins/_zstyle, Completion/Core/_path_files,
	Doc/Zsh/compsys.yo, Functions/Zle/incremental-complete-word: 
	renaming some styles

	* 10507: Completion/Core/_files, Completion/Core/_main_complete:
	two small fixes (-g in _files and menu style)

	* 10502: Src/parse.c: use magic number in zwc files as zwc-version,
	report zsh-version in error message.

	* 10500: Doc/Zsh/zle.yo, Functions/Zle/incremental-complete-word,
	Src/utils.c, Src/Zle/zle_params.c: add zle special parameter
	$PENDING, giving the number of un-read bytes.

	* 10498: Completion/Commands/_next_tags: fix for handling
	file-patterns.

2000-04-04  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Clint: 10477: Functions/Zftp/zfcd_match: some awks don't like
	index zero.

	* Clint: 10448: Completion/Debian/_dpkg: complete after -S.

	* Chmouel: 10440: Completion/Linux/_rpm: rpm tags should have %
	in front.

2000-04-04  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10471: Completion/User/_imagemagick: new completion function

	* 10467: Src/builtin.c, Src/parse.c: better error handling for
	zwc files

	* 10465: Src/Zle/computil.c: fix for completion of options
	after option with rest-arguments

	* 10463: Src/builtin.c, Src/params.c, Src/zsh.h: PM_HASHELEM
	flag to keep association elements from being exported with
	ALL_EXPORT set

	* 10459: Completion/Commands/_next_tags, Doc/Zsh/compwid.yo,
	Src/Zle/compcore.c: _next_tags should be usable with menu-
	completion

	* 10456: Src/Zle/compcore.c: Copy QIPREFIX/QISUFFIX.

2000-04-04  Andrew Main  <zefram@zsh.org>

	* 10444: Src/lex.c, Src/pattern.c: Insist on proper syntax
	for numeric globbing (with the "-").  Also fix the bug whereby
	"echo 1<2-3>" would lose the "1".

2000-04-03  Sven Wischnowsky <wischnow@informatik.hu-berlin.de>

	* 10408: Completion/Core/_path_files: better quoting

	* 10409: Completion/Core/_path_files: completion after ~+<num>

	* 10412: Src/Zle/compmatch.c: better partial word completion for
 	new parts

	* 10413: Completion/Commands/_complete_help, Doc/Zsh/compsys.yo:
	style list optional in _complete_help

	* 10416: Completion/Core/_main_complete, Doc/Zsh/compsys.yo:
 	default completer style contains _ignored

	* 10425: Completion/Core/_files, Completion/User/_gdb,
	Completion/User/_getconf, Completion/User/_mh,
	Completion/User/_netscape, Completion/User/_tiff,
	Completion/User/_urls, Completion/X/_xmodmap,
	Doc/Zsh/compsys.yo, Src/Zle/computil.c: Various completion fixes.

2000-04-03  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Clint: 10424: Completion/Debian/_dpkg: reported -i=irs failure.

2000-04-02  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Config/version.mk: 3.1.6-dev-21.

2000-04-01  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 10376: LICENCE: new file, with licence as it appears
	in some (but not all) files in distribution.

	* Bart: 10372: Doc/Zsh/builtins.yo, Doc/Zsh/mod_zutil.yo:
	cross-reference builtin descriptions in modules.

	* Chmouel: 10370: zsh-3.1.6-dev-20/Completion/Linux/_rpm: rpm -p
	handling.

	* Bart: 10368: Doc/Zsh/mod_zle.yo: improved bindkey -R description.

	* Oliver: 10367: Completion/Builtins/_nothing,
	Completion/Builtins/_cd, Completion/Builtins/_emulate,
	Completion/Builtins/_enable, Completion/Builtins/_disable,
	Completion/Builtins/_fc: update some functions to use _arguments.

	* Bart: 10366: Doc/Zsh/builtins.yo: reword 10364.

	* Sven: 10364: Doc/Zsh/builtins.yo, Src/parse.c: -c and -a flags
	for current and autoloadable functions are now orthogonal.

	* Bart: 10360: Doc/zsh.yo, Doc/Zsh/compctl.yo, Doc/Zsh/compsys.yo,
	Doc/Zsh/compwid.yo, Doc/Zsh/manual.yo, Doc/Zsh/mod_compctl.yo,
	Doc/Zsh/modules.yo, Doc/Zsh/zftpsys.yo, Doc/Zsh/zle.yo: reorder
	completion manual entries.

	* Sven: 10358: Doc/Zsh/params.yo, Src/jobs.c, Src/params.c,
	Src/zsh.h: $pipestatus gives return values for all commands in
	pipeline.

	* Sven: 10353: Completion/Commands/_history_complete_word:
	updated to use latest tags mechanism.

	* Sven: 10352: Src/exec.c: fix 10331 for script names.

2000-03-30  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 10335: Functions/Misc/zrecompile: -[rm] should be -[RM] in
	one more place.

	* Sven: 10332: Completion/Core/compinstall: temporary fix-up for
	old compinstall.

	* Sven: 10331: Src/exec.c: keep old script name for autoloading.

	* Sven: 10329, 10334: Src/Zle/compmatch.c: ** in match specs.

	* Sven: 10328: Src/Zle/iwidgets.list, Src/Zle/zle_utils.c:  undo
	fixes for completion (don't need double undo any more) and
	for history stuff.

	* Sven: 10327: Completion/Builtins/_autoload,
	Completion/Builtins/_zcompile, Completion/Core/_path_files: new
	and improved completions.

	* Bart: 10322: Test/11glob.ztst, Test/53completion.ztst:
	more comprehensive globbing tests, plus problem when TERM is
	too dumb in completion test.

2000-03-29  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 10320: Src/pattern.c: freeing of buffer was messed up in 
	10284.
	
2000-03-28  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Bart: 10319: Doc/Zsh/compsys.yo: add kindex entry for tag-order.

	* Bart: 10317: Test/11glob.ztst: real glob tests to pick up ** and
	~ things.

	* Sven: 10311: Doc/Zsh/builtins.yo, Src/builtin.c, Src/parse.c:
	zcompile -a to force functions marked for autoloading to be dumped
	as wordcode.

	* Sven: 10310: Src/exec.c: arguments in kshautoloaded function
	problem: keep old zsh way of doing things for now.

	* Sven: 10309: Completion/Base/_arguments,
	Completion/Base/_describe, Completion/Base/_jobs,
	Completion/Base/_subscript, Completion/Base/_tilde,
	Completion/Base/_values, Completion/Builtins/_compdef,
	Completion/Builtins/_pids, Completion/Builtins/_popd,
	Completion/Builtins/_sched, Completion/Builtins/_signals,
	Completion/Builtins/_stat, Completion/Builtins/_zftp,
	Completion/Builtins/_zpty, Completion/Builtins/_zstyle,
	Completion/Core/.distfiles, Completion/Core/_alternative,
	Completion/Core/_path_files, Completion/Core/_requested,
	Completion/Core/_wanted, Completion/User/_gdb,
	Completion/User/_getconf, Completion/User/_groups,
	Completion/User/_lp, Completion/User/_make, Completion/User/_mh,
	Completion/User/_netscape, Completion/User/_tiff,
	Completion/User/_urls, Completion/User/_users,
	Completion/User/_users_on, Completion/X/_x_colormapid,
	Completion/X/_x_extension, Completion/X/_x_font,
	Completion/X/_x_keysym, Completion/X/_x_window,
	Completion/X/_xmodmap, Completion/X/_xutils, Completion/X/_xwit,
	Doc/Zsh/compsys.yo, Etc/completion-style-guide,
	Functions/Zftp/zfcd_match, Functions/Zftp/zfget_match:
	rename _try by _next_label and _loop by _all_labels; files
	themselves also renamed.

	* Clint: 10303: Doc/Zsh/params.yo, Src/params.c: restore
	$MACHTYPE, run-time determination of $CPUTYPE.

2000-03-27  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 10297: Doc/Zsh/builtins.yo, Functions/Misc/zrecompile,
	Src/parse.c: restrict -c option not to work with -k, swap -r -m
	and -R -M options.

	* Sven: 10294: Doc/Zsh/builtins.yo, Src/Modules/parameter.c,
	Src/builtin.c, Src/cond.c, Src/exec.c, Src/hashtable.c,
	Src/loop.c, Src/parse.c, Src/zsh.h: natural behaviour of autoload
	+X for ksh-style autoloading.

	* Sven: 10293: Completion/Base/_default,
	Completion/Commands/_complete_help,
	Completion/Core/_main_complete, Doc/Zsh/compsys.yo: improve help
	formatting and information content.

	* Sven: 10292: Completion/Core/_approximate,
	Completion/Core/_complete, Completion/Core/_correct,
	Completion/Core/_expand, Completion/Core/_ignored,
	Completion/Core/_list, Completion/Core/_main_complete,
	Completion/Core/_match, Completion/Core/_menu,
	Completion/Core/_oldlist, Completion/Core/_path_files,
	Completion/Core/_prefix, Doc/Zsh/compsys.yo: aliases for
	completers; allow more flexibility with contexts at upper
	levels.

2000-03-26  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 10284: Src/pattern.c: exclusions with absolute path
	didn't work; closures after exclusions in subdirectories crashed
	the shell.

	* Sven: 10272, 10275: Doc/Zsh/builtins.yo, Src/builtin.c, Src/exec.c:
	autoload can force zsh/ksh styles with -z, -k; integrate
	execautofn() and loadautofn().  Side effect that -kX must run the
	code to get at the function defintion.

	* Sven: 10273: Src/Zle/complete.c: problem with test for empty
	prefix.

	* Sven: 10271: Completion/Core/_expand: _requested problem.

	* Sven: 10267: Completion/Builtins/_zstyle,
	Completion/Commands/_next_tags, Completion/Core/_files,
	Completion/Core/_tags, Doc/Zsh/compsys.yo, Src/Zle/computil.c:
	better consistency between _file tags and other tags using
	improved file-patterns style; remove tag-aliases style, better
	done in other way.s

	* Bart: 10266: Doc/Zsh/compsys.yo: update for 10263.

	* Sven: 10265: Completion/Builtins/_zstyle,
	Completion/Core/_approximate, Doc/Zsh/compsys.yo: tag-order and
	file-patterns completions; subst-globs-only and _approximate
	improvements.

	* Sven: 10264: Completion/Core/_call, Completion/Core/compdump,
	Completion/Core/compinit, Doc/Zsh/compsys.yo,
	Functions/Zle/incremental-complete-word, Functions/Zle/predict-on:
	Allow options to #autoload tag; fix uses of force-list.

	* Bart: 10263: Doc/Zsh/compsys.yo, Doc/Zsh/index.yo,
	Doc/Zsh/manual.yo, Doc/Zsh/zftpsys.yo: style and tags index,
	removed unused key index.

	* Sven: 10262: Src/Zle/compcore.c: compadd -D problem.

	* Sven: 10260: Doc/Zsh/compwid.yo: resolve incompatibilities
	between 10258 and 10230.

	* Sven: 10179: Src/text.c: a bit more safety in printing wordcode
	structures.

	* Sven: 10233: Completion/X/_x_colormapid, Completion/X/_xwit:
	some uses of tag aliases.

	* Sven: 10231: Completion/Builtins/_zstyle,
	Completion/Commands/_next_tags, Completion/Core/_tags,
	Doc/Zsh/compsys.yo, Src/Zle/computil.c: tag-order can take
	patterns, new tag-aliases style, aliases starting with a hyphen
	are appended to existing tag.

	* Sven: 10230: Completion/Builtins/_zstyle,
	Completion/Core/_description, Completion/Core/_ignored,
	Completion/Core/_main_complete, Completion/Core/_path_files,
	Completion/Core/_prefix, Completion/Core/_setup,
	Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo,
	Functions/Zle/incremental-complete-word, Src/Zle/comp.h,
	Src/Zle/compcore.c, Src/Zle/complete.c, Src/Zle/compresult.c:
	Remove builtin alternate matching and implement as _ignored
	completer.

	* Bart: 10258: Doc/ztexi.yo, Doc/Zsh/builtins.yo,
	Doc/Zsh/compctl.yo, Doc/Zsh/compwid.yo, Doc/Zsh/expn.yo,
	Doc/Zsh/filelist.yo, Doc/Zsh/files.yo, Doc/Zsh/redirect.yo,
	Doc/Zsh/zle.yo: more enhanced documentation.

	* Bart: 10250: Doc/Zsh/builtins.yo, Doc/Zsh/files.yo,
	Doc/Zsh/func.yo: improved documentation for new wordcode dumping
	and loading.

2000-03-24  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Bart: 10243: Completion/User/_groups, Src/Modules/zpty.c:
	9897 and 10089 weren't merged properly; bit which got missed
	out of 9981 because it was applied by hand.

	* Clint: 10242: configure.in, Src/params.c: determine $MACHTYPE at
	run time.

2000-03-23  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Config/version.mk: 3.1.6-dev-20
	
	* Tanaka Akira: 10234, 10236: Completion/X/_xwit: _message passing.

	* Tanaka Akira; 10232: Test/comptest, Test/ztst.zsh, ChangeLog(!):
	minor test fixes and typo.

	* Sven: 10226: Completion/Core/_path_files: quoting problem.

	* Sven: 10225: Completion/Core/_path_files: dot problems with
	files.

	* Tanaka Akira: 10223: Completion/Base/_regex_arguments,
	Completion/X/_x_colormapid, Completion/X/_xwit:
	new X completions.

	* Bart: 10218: Src/prompt.c: possible realloc() in
	putpromptchar().

2000-03-22  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 10215: Completion/User/_nedit: and this one.

	* Sven: 10214: Completion/Builtins/_cd,
	Completion/Builtins/_zstyle, Completion/User/_pbm,
	Completion/User/_pspdf, Completion/User/_tiff,
	Completion/User/_zdump: some _path_files calls now need loop for
	tags.

	* Sven: 10210: Completion/Commands/_next_tags,
	Completion/Core/_main_complete, Completion/Core/compinit,
	Doc/Zsh/compsys.yo: _next_tags doesn't need to be in completer
	list any more; $compprefuncs array does pre-completion functions.
	
	* Sven: 10209: Completion/Core/_loop, Completion/Core/_try:
	missing functions form 10195.

	* 10204: Completion/Base/_arguments, Completion/Base/_values,
	Completion/Core/_alternative, Completion/Core/_tags,
	Completion/Core/_wanted, Src/Zle/computil.c: additions to 10195.

	* Sven: 10195: Completion/Base/_arguments,
	Completion/Base/_brace_parameter, Completion/Base/_condition,
	Completion/Base/_default, Completion/Base/_describe,
	Completion/Base/_first, Completion/Base/_jobs,
	Completion/Base/_math, Completion/Base/_parameter,
	Completion/Base/_subscript, Completion/Base/_tilde,
	Completion/Base/_values, Completion/Builtins/_arrays,
	Completion/Builtins/_autoload, Completion/Builtins/_bindkey,
	Completion/Builtins/_builtin, Completion/Builtins/_cd,
	Completion/Builtins/_command, Completion/Builtins/_compdef,
	Completion/Builtins/_echotc, Completion/Builtins/_functions,
	Completion/Builtins/_hash, Completion/Builtins/_limits,
	Completion/Builtins/_pids, Completion/Builtins/_popd,
	Completion/Builtins/_sched, Completion/Builtins/_signals,
	Completion/Builtins/_stat, Completion/Builtins/_vars,
	Completion/Builtins/_zftp, Completion/Builtins/_zle,
	Completion/Builtins/_zmodload, Completion/Builtins/_zpty,
	Completion/Builtins/_zstyle, Completion/Commands/_next_tags,
	Completion/Core/_alternative, Completion/Core/_files,
	Completion/Core/_main_complete, Completion/Core/_multi_parts,
	Completion/Core/_options, Completion/Core/_parameters,
	Completion/Core/_path_files, Completion/Core/_requested,
	Completion/Core/_sep_parts, Completion/Core/_set_options,
	Completion/Core/_setup, Completion/Core/_tags,
	Completion/Core/_unset_options, Completion/Core/_wanted,
	Completion/Debian/_apt, Completion/Debian/_deb_packages,
	Completion/Linux/_rpm, Completion/User/_archie,
	Completion/User/_cvs, Completion/User/_dd,
	Completion/User/_domains, Completion/User/_gcc,
	Completion/User/_gdb, Completion/User/_getconf,
	Completion/User/_gprof, Completion/User/_groups,
	Completion/User/_gs, Completion/User/_hosts, Completion/User/_lp,
	Completion/User/_mailboxes, Completion/User/_make,
	Completion/User/_man, Completion/User/_mh, Completion/User/_mount,
	Completion/User/_mutt, Completion/User/_mysql_utils,
	Completion/User/_netscape, Completion/User/_nslookup,
	Completion/User/_pbm, Completion/User/_perl_basepods,
	Completion/User/_perl_builtin_funcs,
	Completion/User/_perl_modules, Completion/User/_ports,
	Completion/User/_rcs, Completion/User/_rlogin,
	Completion/User/_socket, Completion/User/_ssh,
	Completion/User/_stty, Completion/User/_tar,
	Completion/User/_telnet, Completion/User/_tiff,
	Completion/User/_urls, Completion/User/_user_at_host,
	Completion/User/_users, Completion/User/_users_on,
	Completion/User/_whois, Completion/User/_yp,
	Completion/X/_x_color, Completion/X/_x_cursor,
	Completion/X/_x_display, Completion/X/_x_extension,
	Completion/X/_x_font, Completion/X/_x_keysym,
	Completion/X/_x_modifier, Completion/X/_x_window,
	Completion/X/_xmodmap, Completion/X/_xutils, Doc/Zsh/compsys.yo,
	Doc/Zsh/mod_zutil.yo, Etc/completion-style-guide,
	Functions/Zftp/zfcd_match, Functions/Zftp/zfget_match,
	Src/Modules/zutil.c, Src/Zle/computil.c: implement tag aliases,
	which allows neat tricks with styles.

	* Sven: 10197: Src/exec.c, Src/init.c: %_ sometimes got cmdstack
	wrong in source(); $(...) didn't show up at all.

	* Bart: 10193: Src/prompt.c: prompttrunc() didn't track realloc()'s.

	* Bart: 10181: Functions/Prompts/prompt_bart_setup: Bart's Theme
	and Variations.

	* Sven: 10178: Completion/Commands/_next_tags, Doc/Zsh/compsys.yo:
	don't bind _next_tags by default and add some more docs.

	* Sven: 10176: Src/Zle/compresult.c, Src/init.c, Src/parse.c:
	optimize list-packed.

	* Sven: 10174: Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo: tweaks on
	completer and -V.

	* Bart: 10173: Functions/Prompts/prompt_bart_setup,
	Functions/Prompts/promptinit: Bart's Theme.

	* Sven: 10172: Completion/Core/_main_complete: typo.

	* Bart: 10168: Src/init.c: move hbegin() to get it right in
	precmd.

	* Oliver: 10166: Completion/X/_xt_arguments,
	Completion/User/_nedit: new and improved.

	* Bart: 10165: Doc/Zsh/builtins.yo, Doc/Zsh/compsys.yo: move doc
	for using a completer twice; zcompile doc tweak.

	* Oliver: 10162: Completion/Core/_expand: use nullglob option
	instead of (N) so that user's qualifiers work.

	* Sven: 10159: Src/Zle/compresult.c: wrong calculation of display
	length when not using zsh/complist.

	* Sven: 10156: Src/exec.c: possible invalid field in function
	definition when loading.

	* Zefram: 10152: Src/mem.c: fix ordering ambiguity ANSI wouldn't
	have liked.

	* Bart: 10150: Src/exec.c, Test/51xtrace.ztst: `one last' xtrace
	redirection fix.

	* Sven: 10149: Doc/Zsh/builtins.yo, Src/builtin.c, Src/exec.c,
	Src/parse.c: allows native and ksh-like wordcode function styles.

	* Sven: 10148: Src/Zle/comp.h, Src/Zle/compcore.c, Src/mem.c:
	optimization for added matches where things didn't change.

	* Sven: 10146: Completion/Core/_sort_tags, Completion/Core/_tags,
	Doc/Zsh/compsys.yo: return value of function called by _tags used
	to decide dispositions.

	* Sven: 10145: Doc/Zsh/mod_zle.yo: confess to users that zle input
	is on a stack.

	* Sven: 10144: Doc/Zsh/builtins.yo, Src/Modules/parameter.c,
	Src/builtin.c, Src/exec.c, Src/linklist.c, Src/parse.c: dump
	functions from current shell.

	* Sven: 10143: Src/init.c, Src/math.c: better ignoring of bits
	that shouldn't get evaluated in math expressions.

	* Sven: 10135: Doc/Zsh/compsys.yo, Src/Zle/computil.c: complex
	argument handling expressions.

	* Sven: 10131: Src/Modules/stat.c, Src/Modules/zpty.c,
	Src/Modules/zutil.c, Src/Zle/compctl.c, Src/Zle/complete.c,
	Src/Zle/computil.c, Src/Zle/zle_main.c, Src/Zle/zle_thingy.c,
	Src/parse.c: more consistent zerrnam/zwarnnam usage.

	* Sven: 10129: Doc/Zsh/builtins.yo, Src/builtin.c, Src/parse.c:
	autoload -w can mark all functions in .zwc files for autoloading.

	* Sven: 10128: Doc/Zsh/zle.yo, Src/Zle/zle_main.c, Src/init.c,
	Src/signals.c, Src/zsh.h: zle parameters available readonly in
	traps.

	* Sven: 10127: Doc/Zsh/zle.yo, Src/Zle/compresult.c,
	Src/Zle/iwidgets.list, Src/Zle/zle_main.c, Src/Zle/zle_misc.c,
	Src/Zle/zle_refresh.c, Src/Zle/zle_thingy.c, Src/Zle/zle_tricky.c:
	end-of-list widget to display prompt under command line, plus
	$MARK documentation.

	* Sven: 10126: Src/Zle/compcore.c: quotes in $PREFIX and $SUFFIX.

	* Sven: 10125: Src/math.c, Src/params.c: restore old cruddy
	behaviour removed in 10104, but using recursion counter.

	* Sven: 10120: Src/exec.c, Src/loop.c, Src/parse.c: state not
	tested properly in some constructs.

	* Sven: 10117: Doc/Zsh/mod_zle.yo, Src/Zle/zle_params.c,
	Src/Zle/zle_thingy.c: zle on its own returns zle status;
	MARK parameter; disallow widgets in traps.

	* Oliver: 10116: Completion/Builtins/_source: wasn't looking
	through the path.

	* Sven: 10112: Completion/Base/_condition, Src/Zle/zle_tricky.c:
	fix up altmodische _condition; `[[ ... && ' thought it was in
	command position for completion.

	* Sven: 10108: Completion/Commands/.distfiles,
	Completion/Commands/_next_tags, Completion/Core/_files,
	Completion/Core/_main_complete, Completion/Core/_requested,
	Completion/Core/_wanted, Doc/Zsh/compsys.yo,
	Functions/Misc/.distfiles: _next_tags allows you to cycle through
	sets of completions according to the tags.

	* Sven: 10107: Doc/Zsh/compwid.yo, Src/Zle/complete.c,
	Src/Zle/compmatch.c: ** in match spec allows matching including
	the anchor as well.

	* Sven: 10106: Functions/Misc/zrecompile, Src/exec.c, Src/parse.c,
	Src/zsh.h: recompilation of wordcode files and related bugs.

	* Sven: 10105: Src/lex.c: single exclamation marks in conditions.

	* Sven: 10104: Src/math.c, Src/params.c: retrieve parameters in
	math evaluations more directly rather than recursively calling
	matheval(), which was kind of stupid, so stupid I could	quite
	possible have put it in myself, but I don't think I did this time.

	* Sven: 10103: Src/glob.c: bad handling of ./ and ../ in
	closures.

	* Bart: 10098: configure.in, Src/cond.c: check for AIX's
	faccessx() and neaten configure library function tests.

	* Oliver: 10088: Completion/User/_groups,
	Completion/Base/_condition: better handling of files after
	conditions, checking of use of NIS.

	* Adam: 10087: Completion/User/_perl_modules,
	Completion/User/_perl: new and enhanced perl completions.

	* Oliver: 10073: Src/cond.c: /dev/fd emulation for access tests.

	* Adam: 10072: Completion/User/_mysql_utils: new completion
	function for something with suspcicious `SQL' bit in its name.

	* Bart: 10071: Src/exec.c: xtrace output redirection problem.

	* Sven: 10059: Src/builtin.c, Src/lex.c, Src/parse.c, Src/text.c,
	Src/zsh.h: bugs found by ksh tests: typeset -Ai didn't create
	assocs (still doesn't create ints), some heredoc difficulties, |&
	difficulties.

	* Alexandre: 10058: Completion/User/_prcs, Completion/User/_diff,
	Completion/User/_diff_options: another solution for the GNU diff
	completion problem.

	* Bart: 10056: Etc/MACHINES: RLIM_INFINITY incompatibility with
	some Linux/GNU libraries.

	* Sven: 10044: Completion/User/_diff, Completion/User/_use_lo:
	gdiff should use diff completion, pretty obviously.

	* Sven: 10041: Doc/Zsh/builtins.yo, Doc/Zsh/files.yo,
	Doc/Zsh/func.yo, Src/init.c, Src/parse.c: enhancements for digest
	files including digests of sourced files.  Or maybe digestion of
	sauce.

	* Sven: 10040: Completion/User/_diff_options: can test for GNU
	diff.

	* Oliver: 10029: Src/utils.c: bad handling of '^^' in keystring
	parsing.

	* Andrej: 10028: Completion/Builtins/_cd: remove local directory
	from cdpath.

	* Sven: 10025: Functions/Misc/nslookup, Src/Modules/zpty.c:
	optimizations for pty reads.

	* Sven: 10017: Doc/Zsh/builtins.yo, Src/lex.c, Src/parse.c:
	fix buffer problem for autoloading and unportable macro.

	* Oliver: 10013: Completion/Builtins/_compdef,
	Completion/Builtins/_zpty, Completion/User/_getconf: two new
	functions and one updated.

	* Andrej: 10011: Completion/User/_sudo: options for recent sudo.

	* Bart: 10009: Completion/Base/_subscript: didn't get arrays the
	right length.

	* Bart: 10006: configure.in, Src/utils.c: use mktemp() if
	available.

	* Bart: 9992: Functions/Zle/predict-on: tweaks.

	* Bart: 9990: Test/07cond.ztst: compatibility fix for chmod g+s.

	* Bart: 9982: Test/53completion.ztst, Test/Makefile.in,
	Test/comptest, Test/ztst.zsh: better handling of uninstalled
	modules.

	* Andrej: 9981: Src/Modules/zpty.c: SYSV-related pty stuff.

	* Bart: 9980: Src/Makefile.in: separate mymods.conf and xmods.conf
	dependencies.

	* Sven: 9966: Doc/Zsh/builtins.yo, Doc/Zsh/func.yo, Src/parse.c:
	require .zwc ending for digest files.

	* Bart: 9963: Test/11glob.ztst: existing globbing tests run under
	new test harness.

	* Bart: 9961: INSTALL, Src/Makefile.in, Test/53completion.ztst,
	Test/comptest: errors trying to load zpty for static shell in
	tests; INSTALL didn't describe mymods.conf properly.

	* Tanaka Akira: 9960: Test/comptest, Test/53completion.ztst: avoid
	zpty timing problem.

	* Sven: 9958: Src/parse.c: sharing strings made test fail with
	new wordcode.

	* Tanaka Akira: 9957: Test/comptest: clear to end.

	* Sven: 9953: Src/Zle/complist.c: was incorrectly omitting some
	display sequences.

	* Tanaka Akira: 9952: Test/comptest: compatibility, quoting and
	debugging fixes.

	* Sven: 9951: Completion/Core/_multi_parts: was producing
	mysterious blank entries.

	* Sven: 9948: Src/exec.c, Src/parse.c: stripkshdef() was broken.

	* Sven: 9947: Completion/Core/compdump, Completion/Core/compinit,
	Doc/Zsh/builtins.yo, Doc/Zsh/func.yo, Src/builtin.c, Src/cond.c,
	Src/exec.c, Src/glob.c, Src/lex.c, Src/loop.c, Src/math.c,
	Src/mem.c, Src/parse.c, Src/text.c, Src/utils.c, Src/zsh.h:
	Wordcode compilation for functions using .zwc or `digest
	functions' in $fpath.

	* Bart: 9946: Src/subst.c: return type in 9937.

	* Bart: 9945: Src/prompt.c: truncation messed up non-literal
	parts of the prompt.

	* Bart: 9942: Src/prompt.c: truncation in true part of ternary
	expression incorrectly showed false part and closing parenthesis.

	* Sven: 9937: Src/subst.c: parsing problem with parameter
	substitution which showed up in file completion.

	* Sven: 9938: Src/Modules/parameter.c: problem assigning to
	dirstack.

	* Tanaka Akira: 9936: Src/Zle/complist.c, Test/comptest,
	Test/53completion.ztst: tests for completion using zpty.

	* Tanaka Akira: 9935: Test/52zregexparse.ztst: tests for
	zregexparse.

2000-03-21  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9920: Completion/Core/.distfiles, Completion/Core/_call:
	the function needed for 9897.

	* Bart: 9912: Completion/User/_mailboxes: further improvements.

	* Sven: 9904: Src/utils.c: getquery() and rmstarsilent.

	* Sven: 9902: Completion/Core/_path_files: _files -g problem.

	* Sven: 9900, 9903: Src/exec.c: parsing oddity in here documents.

	* 9897: Completion/Base/_arguments, Completion/Builtins/_pids,
	Completion/Linux/_rpm, Completion/User/_a2ps,
	Completion/User/_archie, Completion/User/_diff_options,
	Completion/User/_finger, Completion/User/_groups,
	Completion/User/_gs, Completion/User/_killall,
	Completion/User/_lp, Completion/User/_telnet,
	Completion/User/_users_on, Completion/User/_yp,
	Completion/X/_x_font, Completion/X/_x_window, Doc/Zsh/compsys.yo:
	use _call function and `command' style to override command
	used in various completions.

	* Sven: 9895: Completion/Base/_combination,
	Completion/Builtins/_zstyle, Completion/User/_telnet,
	Doc/Zsh/compsys.yo: usage of combination styles.

	* Sven: 9893: Completion/Core/_multi_parts: return values.

	* Sven: 9892: Completion/Core/_main_complete,
	Completion/Core/_path_files, Completion/Core/compdump,
	Completion/Core/compinit: improved fix for 9886; typo in
	_main_complete; compdump uses (q) flag; remove compstyle; update
	compconf.

	* Bart: 9891: Completion/User/_cvs: kshautoload problem.

	* Bart: 9889: acconfig.h, configure.in, Src/exec.c,
	Src/prototypes.h: from 3.0.8: detect mknod(), minor redirection
	tweaks.

	* Bart: 9886: Completion/Core/_path_files: matcher problem.

	* Tanaka Akira: 9885: Completion/User/_dvi, Completion/User/_lynx,
	Completion/X/_xutils: extra arguments for completion functions.

	* Alexandre: 9882: Completion/User/_prcs: error messages.

	* Sven: 9880: Completion/Core/_path_files: error message with
	~unknown.

	* Sven: 9879: Completion/User/_tilde_files: use of magicequalsubst
	with completion.

	* Sven: 9877: Src/parse.c: wordcode bug in functions with failed
	builtins.

	* Sven: 9876: Completion/Base/_combination,
	Completion/User/_rlogin, Completion/User/_ssh,
	Completion/User/_user_at_host, Doc/Zsh/compsys.yo: more flexible
	handling of separators in combinations.

	* Sven: 9870: Completion/Core/_path_files,
	Completion/User/.distfiles, Completion/User/_dd,
	Completion/User/_tilde_files, Src/Zle/compresult.c: better
	handling of paths beginning ~ in various places.

	* Sven: 9865: Completion/Builtins/_zstyle,
	Completion/Core/_main_complete, Completion/Core/_setup,
	Doc/Zsh/compsys.yo, Src/Zle/compcore.c, Src/Zle/compresult.c:
	implement prefer-ignored style to prefer alternative matches
	to going on to another completer.

	* Sven: 9863: Src/parse.c, Src/text.c: wordcode problems, using
	old code.

	* Sven: 9861: Completion/Core/_main_complete: interaction of
	_main_complete and _oldlist.

	* Sven: 9860: Src/Zle/compctl.c: storing of match and display list.

	* Sven: 9855: Completion/Core/_multi_parts, Doc/Zsh/compsys.yo:
	_multi_parts accepts -f.

2000-02-23  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9845: Functions/Zle/incremental-complete-word: another
	context change.

	* Sven: 9844: Functions/Zle/predict-on: rationalize 9837.

	* Sven: 9840: config.sub: test for alphaev6 systems.

	* Sven: 9839: Src/Builtins/sched.c, Src/Modules/example.c,
	Src/Modules/mapfile.c, Src/Modules/parameter.c,
	Src/Modules/zftp.c, Src/Modules/zprof.c, Src/Modules/zpty.c,
	Src/Modules/zutil.c, Src/Zle/compcore.c, Src/Zle/compctl.c,
	Src/Zle/complete.c, Src/Zle/complist.c, Src/Zle/compresult.c,
	Src/Zle/computil.c, Src/Zle/zle_hist.c, Src/Zle/zle_main.c,
	Src/Zle/zle_misc.c, Src/Zle/zle_thingy.c, Src/Zle/zle_tricky.c,
	Src/Zle/zleparameter.c, Src/builtin.c, Src/cond.c, Src/exec.c,
	Src/glob.c, Src/hist.c, Src/init.c, Src/jobs.c, Src/lex.c,
	Src/linklist.c, Src/loop.c, Src/main.c, Src/math.c, Src/mem.c,
	Src/module.c, Src/params.c, Src/parse.c, Src/pattern.c,
	Src/prompt.c, Src/signals.c, Src/subst.c, Src/utils.c, Src/zsh.h:
	Eliminate `useheap' variable and consequent HEAPALLOC/PERMALLOC
	usage throughout the shell (hooray!)  All memory allocation is
	either explicitly on the heap or permanent.

	* Sven: 9838: Src/Modules/parameter.c, Src/Zle/computil.c,
	Src/Zle/zle_main.c, Src/builtin.c, Src/cond.c, Src/exec.c,
	Src/glob.c, Src/hashtable.c, Src/init.c, Src/jobs.c, Src/lex.c,
	Src/linklist.c, Src/loop.c, Src/params.c, Src/parse.c,
	Src/signals.c, Src/signals.h, Src/subst.c, Src/text.c,
	Src/version.h, Src/zsh.h: parser now emits wordcode directly; a
	whole heap of optimisations of the execution tree.

	* Sven: 9837: Completion/User/_gunzip, Functions/Zle/predict-on:
	no. of colons in predict-on, typo in _gunzip.

	* Sven: 9835: Completion/Builtins/_zstyle,
	Completion/Core/_main_complete, Doc/Zsh/compsys.yo: document
	single-ignored style, better handling of descriptions with
	warnings about no matches.

	* Bart: 2930: Completion/User/_ssh: basic completion for remote
	files.

2000-02-22  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9831: Completion/Core/_multi_parts: better separator
	removal.

	* Sven: 9830: Completion/X/_x_arguments: reverse 9824, but use
	_default instead of _files if no special arguments.

	* Bart: 9828: Completion/User/_mailboxes: $i -> "$i" missed out.

2000-02-21  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Clint: 9824: Completion/X/_x_arguments: `*/X11/*' was too broad
	a definition for X commands taking standard arguments to be
	useful.

	* Clint: 9823: configure.in: open fifo read/write in test to avoid
	possible (unconfirmed) hang.

	* Bart: 9822: Completion/User/_mailboxes: add completions for mush
	and tkrat; allow pine to complete mh folders.

	* Sven: 9816: Completion/Core/_multi_parts,
	Completion/User/_mailboxes: improved version of 9812/9815.

	* Bart: 9812, 9815: Completion/User/_mailboxes,
	Completion/User/_mutt: improved mailbox completion for all sorts
	of types, currently only used for mutt.

	* Sven: 9810: Completion/Core/_multi_parts: difficulties with
	separator as initial character.

	* Sven: 9809: Completion/Builtins/_popd,
	Completion/Core/_approximate, Doc/Zsh/compsys.yo: documentation
	improvements and typo fixes.

	* Tanaka Akira/Sven: 9807: Completion/Core/_main_complete:
	single-ignored style, as yet undocumented, for handling of
	alternate match set.

	* Sven: 9806: Completion/Core/_multi_parts: problems with literal
	(parenthesised) arrays.

	* Sven: 9805: Completion/Core/_path_files: difficulties with
	suffixes when expanding paths.

	* Sven: 9802: Src/utils.c: no need to quote !'s in ${(qq)...}
	because they're not active in single quotes.

	* Bart: 9799: Src/utils.c: better interpretation of typeahead when
	querying user e.g. for spell checking.

	* Adam: 9798: Doc/Makefile.in: use `texi' and `html' for targets
	to avoid duplicated name complaint by gmake.

2000-02-20  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Config/version.mk: 3.1.6-dev-19.

	* Bart: 9794: Src/exec.c, Test/.distfiles, Test/51xtrace.ztst:
	pick up some problems with 9792.

2000-02-19  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Bart: 9792: Src/builtin.c, Src/cond.c, Src/exec.c, Src/init.c,
	Src/loop.c, Src/utils.c: `xtrerr' replaces stderr for output from
	xtrace, to avoid problems with redirection.

	* Sven: 9791: Completion/X/_x_arguments: complete filenames by
	default.

	* Sven: 9790: Completion/Builtins/_zstyle,
	Completion/Core/.distfiles, Completion/Core/_message,
	Completion/X/_x_borderwidth, Completion/X/_x_geometry,
	Completion/X/_x_locale, Completion/X/_x_name,
	Completion/X/_x_resource, Completion/X/_x_selection_timeout,
	Completion/X/_x_title, Doc/Zsh/compsys.yo: arguments problem with
	_x_geometry; matcher-list completed in zstyle.

	* Sven: 9787: Completion/Core/_expand, Src/utils.c: parameter
	expansion problems expanding; problem quoting in backquoted
	expressions.

	* Chmouel: 9784: Completion/User/_tar,
	Completion/User/_tar_archive: obsolete -y option for bzip2 filter.

	* Chmouel: 9781: Completion/Linux/_rpm: add --freshen.

2000-02-17  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9777: Src/Zle/compctl.c, Src/Zle/zle_tricky.c, Src/exec.c,
	Src/glob.c, Src/subst.c: yet more difficulties with completing
	brace-expanded expressions.

	* Sven: 9776: Completion/Core/_main_complete, Src/glob.c,
	Src/params.c: substitution bugs: ${foo[1,1]...} was treated
	incorrectly as a scalar rather than an array slice; extra
	duplication required when performing replacement on parameter.

	* Sven: 9775: Completion/Core/_path_files: extra array copy
	required.

	* Sven: 9774: Src/Zle/compresult.c: completion inserted some
	incorrect strings.

	* Sven: 9773: Completion/Core/_multi_parts,
	Completion/User/_groups, Completion/User/_ports,
	Completion/User/_users, Doc/Zsh/compsys.yo: remove some
	unnecessary tags which are more logically expressed by an empty
	tag field in the context.

	* Sven: 9772: Completion/Core/_approximate,
	Completion/Core/_description, Completion/Core/_expand,
	Completion/Core/_list, Completion/Core/_main_complete,
	Completion/Core/_match, Completion/Core/_menu,
	Completion/Core/_oldlist, Completion/Core/_prefix,
	Doc/Zsh/compsys.yo: matcher-list style replaces matcher;
	_matcher completer is now defunct.

	* Sven: 9770: Src/Zle/computil.c: bogus empty descriptions.

	* Sven: 9768: Completion/Core/_path_files: completing empty
	directories.

2000-02-16  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Oliver: 9761: Completion/Core/_expand: auto-removable suffixes.

	* Oliver: 9752: Completion/Core/_expand: subst-globs-only style
	bails out if no globs expanded.

	* Sven: 9765: Completion/Core/_sep_parts: problems with separators
	with metacharacters.

	* Sven: 9764: Completion/Core/_multi_parts,
	Completion/Core/_path_files, Doc/Zsh/compsys.yo: problems with
	_oldlist in _multi_parts; new -i option to complete _multi_parts
	bits in one go if possible.

	* Sven: 9763: Src/subst.c: addition to 9757.

	* Sven: 9759: Completion/Base/_default, Doc/Zsh/compsys.yo,
	Src/Zle/comp.h, Src/Zle/compcore.c, Src/Zle/compctl.c,
	Src/Zle/complete.c: use-compctl style to use existing compctls;
	on by default if zsh/compctl is loaded; extra hook needed to allow
	compctl to clear up if invoked via new completion.

	* Sven: 9757: Src/subst.c: quoting with ${(e)...}.

2000-02-15  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 9755: Completion/Core/_sep_parts: typo.

	* Bart: 9750: Src/jobs.c, Src/signames2.awk,
	Src/Modules/parameter.c: better handling for signals received by
	shell which were not in the range found when configuring (e.g. if
	OS was upgraded).

	* Sven: 9749: Src/Zle/zle_tricky.c: completion in braces.

	* Sven: 9746: Src/Zle/compctl.c: broken old-style completion.

	* Sven: 9734: Doc/Zsh/compwid.yo: descriptions for matching.

	* Sven: 9733: Completion/Core/_main_complete,
	Completion/Core/_setup: can't set defaults ZLS_COLORS and
	SELECTMIN inside completion functions, because they may already
	have been set.

	* Sven: 9732: Src/Zle/complist.c: bad test without
	alwayslastprompt.

	* Sven: 9731: Completion/Base/_arguments,
	Completion/Base/_describe, Completion/Base/_jobs,
	Completion/Base/_subscript, Completion/Base/_tilde,
	Completion/Builtins/_pids, Completion/Builtins/_popd,
	Completion/Builtins/_sched, Completion/Builtins/_signals,
	Completion/Builtins/_stat, Completion/Core/_approximate,
	Completion/Core/_files, Completion/Core/_main_complete,
	Completion/Core/_normal, Completion/Core/_path_files,
	Completion/Core/_setup, Completion/Core/_tags,
	Completion/Core/compinit, Completion/Debian/_apt,
	Completion/User/_lp, Completion/User/_socket, Doc/Zsh/compsys.yo,
	Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c: Style defaults are now
	hard-wired in, so all user styles take precedence without having
	to delete existing patterns; _complete is now the default
	completer in every context, including non-completion widgets.

2000-02-14  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9722: Completion/Commands/_expand_word,
	Src/Zle/compcore.c, Src/Zle/complist.c: last_prompt, expansion
	problems.

	* Sven: 9713: Completion/Base/_arguments, Src/Zle/computil.c: two
	more arguments problems.

	* Sven: 9711: Completion/Commands/_complete_help: number of colons
	in context brought up to date.

	* Sven: 9710: Completion/Core/_files, Completion/Core/_path_files,
	Src/Modules/zutil.c: a few random bugs: sorting of styles, bad
	directory completion, globbing problems.

	* Zefram: 9709: Src/mkmodindex.sh: should be global subst in 9701.

	* Sven: 9705: Src/exec.c: comment esprefork, esglob.

	* Sven: 9704: Completion/Core/_path_files: incorrect parameter
	name.

2000-02-13  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 9701: INSTALL, configure.in, Config/defs.mk.in,
	Src/Makefile.in, Src/mkmodindex.sh: allow --enable-omit-modules=foo,...
	to omit a list of modules from compilation and installation.
	
	* Tanaka Akira: 9697: Completion/User/.distfiles,
	Completion/User/_ps, Completion/User/_psutils: completion for all
	psutils commands.

	* Bart: 9694: Src/init.c: more portable attempt to force shell to
	suspend if running interactively in background.

	* Oliver: 9693: Src/params.c, Src/Zle/compcore.c,
	Src/Zle/complete.c: AIX module exports.

2000-02-11  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Bart: 9684: Completion/User/_mailboxes: sort of help find
	mailboxes with + prefix.

	* Bart: 2913: Completion/User/_mutt: don't set muttrc.

	* pws: Config/version.mk: 3.1.6-dev-18

	* Tanaka Akira: 9683: Completion/User/_diff_options: shut up error
	messages (after other attempts from Oliver and Bart).

	* Alexandre: 9681: Completion/User/_prcs: argument handling.

	* Sven: 9680: Completion/Core/_files,
	Completion/Core/_multi_parts, Completion/Core/_path_files,
	Completion/Core/_sep_parts: use of -M option.

	* Sven: 9677, 9679: Completion/Commands/_read_comp,
	Completion/Core/_approximate, Completion/Core/_expand,
	Completion/Core/_main_complete, Completion/Core/_match,
	Doc/Zsh/compctl.yo, Doc/Zsh/compsys.yo, Doc/Zsh/compwid.yo,
	Src/Zle/comp.h, Src/Zle/compcore.c, Src/Zle/compctl.c,
	Src/Zle/complete.c: $compmatchers bites the dust, use new matcher
	style.

	* Sven: 9676: Src/Zle/computil.c: yet more argument subtleties.

	* Tanaka Akira: 9674: Test/10prompt.ztst: some nameless idiot got
	the bits of the date wrong.

	* Sven: 9664: Completion/Core/_path_files: optimisation with
	arrays.

	* Sven: 9659: Doc/Zsh/compsys.yo: mention complete-in-words
	behaviour.

	* Sven: 9657: Completion/Core/_approximate,
	Completion/Core/_description, Completion/Core/_main_complete,
	Completion/Core/_matcher, Completion/Core/_path_files,
	Completion/Core/_prefix, Doc/Zsh/compsys.yo, Src/Zle/complete.c
	(plus Completion/Core/.distfiles change by hand): new _matcher
	completer allows more control along the lines of $compmatchers.

	* Johan: 9653: Functions/Misc/is-at-least,
	Functions/Misc/.distfiles (added by hand): function to check
	version numbers.

	* Johan: 9651: Completion/User/_cvs: handle no CVS tags case better.

	* Sven: 9650: Completion/User/_gunzip, Completion/User/_gzip:
	handle .tgz files.

	* Sven: 9648: Completion/Core/_files,
	Completion/Core/_multi_parts, Completion/Core/_path_files,
	Completion/Core/_sep_parts, Doc/Zsh/mod_zutil.yo,
	Src/Modules/zutil.c: Bartised version of zparseopts;
	fix _path_files -S ''.

	* Bart: 9639: Doc/Zsh/options.yo, Doc/Zsh/redirect.yo: typos in
	9625.

	* Tanaka Akira: 9638: Completion/User/_cvs: _cvs_rtag had no
	default implementation.

	* Sven: 9635: Completion/Core/_description,
	Completion/Core/_files, Completion/Core/_multi_parts,
	Completion/Core/_path_files, Completion/Core/_sep_parts,
	Doc/Zsh/mod_zutil.yo, Src/Modules/zutil.c, Src/Modules/zutil.mdd:
	improved performance for completion functions; option-parsing
	builtin.

	* Akim Demaille <akim@epita.fr>: 9634: Src/builtin.c: trap '' 1
	segfaulted.

	* Sven: 9633: Src/init.c: change logic in 9591.

	* Sven: 9632: Test/05command.ztst: error spotted by improved
	autoload error checking.

	* Alexandre: 9625: Src/zsh.h, Src/options.c, Src/init.c,
	Src/exec.c, Doc/Zsh/redirect.yo, Doc/Zsh/options.yo: SHNULLCMD and
	CSHNULLCMD options to allow better sh/csh emulation without
	fiddling with parameters.

	* Sven: 9623: Completion/Core/_path_files: another version of
	9616.

	* Sven: 9621: Src/Zle/computil.c: completion incorrectly adding
	space.

	* Sven: 9619: Completion/User/_texi: completion for texinfo;
	added Completion/User/.distfiles by hand.

	* Sven: 9618: Src/Zle/computil.c: memory leak in caching.

	* Sven: 9616: Completion/Core/_path_files: bad test with a
	pattern.

	* Sven: 9615: Completion/Builtins/_zstyle, Doc/Zsh/compsys.yo:
	rename and document some styles.

	* Sven: 9614: Src/exec.c: esglob wasn't initialised properly.

	* Alexandre: 9606: Completion/Builtins/_zstyle: two missing
	styles.

	* Sven: 9600: Src/exec.c: wordcode problem in execpline().

	* Bart: 9591: Src/init.c: zsh/compctl didn't get loaded
	automatically any more.

	* Geoff: 9589: Doc/Makefile.in: put back ^A's from 9584.

	* Tanaka Akira: 9585: Doc/Makefile.in: possible logic problems
	with 9584.

	* Geoff: 9584: Doc/Makefile.in: sh problems with creating
	modlist.yo.

	* Alexandre: 9583: Functions/Misc/nslookup: fix context name for
	new scheme.

	* Sven: 9390, 9394, hunk from 9396: ./Doc/Makefile.in,
	Doc/Zsh/mod_zpty.yo, Doc/Zsh/.distfiles, Functions/Misc/nslookup,
	Src/Modules/.distfiles, Src/Modules/zpty.c, Src/Modules/zpty.mdd,
	Src/builtin.c, Src/init.c, Src/zsh.h: zpty module.

2000-02-05  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Tanaka Akira: 9579: Completion/Debian/_deb_packages: was using
	bad cache variable.

2000-02-04  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9569: Completion/Core/_main_complete,
	Completion/Core/_prefix, Doc/Zsh/compsys.yo, Src/Zle/compcore.c:
	new complete-prefix completer _prefix; fix suffix matching
	problems.

	* Sven: 9568: Src/Zle/computil.c: fix difficulties with remaining
	arguments.

	* Sven: 9562: Completion/Base/_arg_compile,
	Completion/Base/_arguments, Completion/Base/_command_names,
	Completion/Builtins/_hash, Completion/User/_gdb,
	Completion/User/_ssh, Completion/User/_strip, Completion/X/_xrdb,
	Completion/X/_xutils, Src/Zle/computil.c: failure to follow links
	completing commands; bad long option handling in some cases

	* Sven: 9560 (second hunk only): Src/Zle/computil.c: more
	argument fixes.

	* Sven: 9559: Doc/Zsh/compsys.yo: better documentation for `+'
	argument handling.

	* Sven: 9558: Src/exec.c, Src/parse.c: trapping of autoloading
	errors wasn't up to scratch.

	* Alexandre: 9557: Completion/User/_flex: problem handling
	`+' argument.

2000-02-03  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Oliver: 9547: Src/parse.c, Src/hist.c: more fixups for exporting
	on AIX.

	* Sven: 9546: Completion/Base/_arguments,
	Completion/Base/_combination, Completion/Base/_describe,
	Completion/Base/_first, Completion/Base/_jobs,
	Completion/Base/_subscript, Completion/Base/_tilde,
	Completion/Base/_values, Completion/Builtins/_pids,
	Completion/Builtins/_popd, Completion/Builtins/_sched,
	Completion/Builtins/_signals, Completion/Builtins/_stat,
	Completion/Builtins/_zftp, Completion/Builtins/_zstyle,
	Completion/Commands/_complete_help,
	Completion/Commands/_correct_word,
	Completion/Commands/_expand_word,
	Completion/Commands/_history_complete_word,
	Completion/Core/_alternative, Completion/Core/_approximate,
	Completion/Core/_complete, Completion/Core/_correct,
	Completion/Core/_description, Completion/Core/_expand,
	Completion/Core/_files, Completion/Core/_list,
	Completion/Core/_main_complete, Completion/Core/_match,
	Completion/Core/_menu, Completion/Core/_message,
	Completion/Core/_normal, Completion/Core/_oldlist,
	Completion/Core/_path_files, Completion/Core/_setup,
	Completion/Core/_sort_tags, Completion/Core/_tags,
	Completion/Core/compinit, Completion/Debian/_apt,
	Completion/Debian/_deb_packages, Completion/User/_cvs,
	Completion/User/_domains, Completion/User/_groups,
	Completion/User/_hosts, Completion/User/_ports,
	Completion/User/_socket, Completion/User/_urls,
	Completion/User/_users, Completion/X/_x_color, Doc/Zsh/compsys.yo,
	Etc/completion-style-guide,
	Functions/Zle/incremental-complete-word, Functions/Zle/predict-on:
	more consistent form for style contexts in completion system,
	:completion:<func>:<completer>:<command>:<argument>:<tag>.

	* Sven: 9545: Src/Modules/zutil.c: don't use freed structs.

	* Tanaka Akira: 9544: Src/Modules/zutil.c: handle case for
	undefined match data in zregexparse.

	* Sven: 9542: Src/Zle/complete.c: use permanently allocated memory
	for copied special parameters.

	* Sven: 9541: Src/Modules/zutil.c: zstyle looks up style names
	first.

2000-02-02  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Config/version.mk: version 3.1.6-dev-17

	* Bart: 9533: Src/signals.c: make sure shell doesn't send itself
	SIGHUP when exiting.

	* Sven: 9528: Completion/Core/_files: missing variable
	initialization.

	* Sven: 9527: Doc/Zsh/compsys.yo: extra description for styles.

	* Sven: 9526: Src/Zle/computil.c: missing tokenization in
	completion listing.

	* Sven: 9524: Src/text.c: wordcode bug outputting function
	definitions.

	* Sven: 9522: Src/utils.c: return on various conditions when
	reading a character from the terminal.

	* Sven: 9521: Src/exec.c: another job-waiting fix.

2000-02-01  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 9518: Test/.distfiles, Test/10prompt.ztst: test for prompt
	escapes.

	* Clint/Sven: 9500 rewritten as 9505: Src/mem.c: more graceful exit
	after mmap() failure when used for heap allocation.

	* Alexandre: 9504: Completion/Builtins/_zstyle: complete name of
	packageset style.

	* Sven: 9503: Src/exec.c: problem updating job entry without any
	processes.

	* Alexandre: 9502: Completion/User/_urls,
	Completion/Core/compinit, Completion/Core/_menu,
	Completion/Core/_match, Completion/Base/_combination: fix 9463
	to use ':completion:...' prefix with zstyle.

2000-01-31  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9496: Src/loop.c: failure to check for return status in
	for loop.

	* Bart: 9495: Src/exec.c: re-block after waiting for jobs.

	* Sven: 9494: Src/Zle/computil.c: extraneous space with option
	description.

	* Bart: 9493: Test/09funcdef.ztst: regression test for function
	definition.

	* Sven: 9489: Src/Zle/complist.c, Src/Zle/compresult.c: avoid menu
	selection with no list and asking whether to list twice.

	* Sven: 9488: Src/exec.c: remove unnecessary child_block().

	* Sven: 9487: Src/exec.c: wordcode fix: expand names in function
	definitions.

	* Sven: 9486: Doc/Zsh/compwid.yo: fix docs for compadd -1 with -J

2000-01-30  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Tanaka Akira: 9476: Completion/User/_cvs,
	Completion/User/_patch: prefer LC_ALL to LANG as the former
	overrides the latter.

	* Tanaka Akira: 9475: Completion/User/_telnet: simplify by using
	(K) parameter flag.

	* Tanaka Akira: 9473: Completion/User/_patch: improved support for
	different versions of `patch'.

	* Bart: 9472: Doc/Makefile.in: dependencies on texinfo files when
	building out of source tree.

	* Tanaka Akira: 9470: Completion/Debian/_deb_packages: updage
	should be update throughout.

	* Clint: 9469: Completion/Debian/_deb_packages,
	Completion/Debian/_dpkg, Doc/Zsh/compsys.yo: new packageset style
	to select Debian package.

2000-01-29  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Alexandre: 1684: Completion/User/.distfiles: add _diff and
	_diff_options.

	* Alexandre: 9463: Completion/User/_urls,
	Completion/Core/compinit, Completion/Core/_menu,
	Completion/Core/_match, Completion/Base/_combination: switch to
	using zstyle instead of compstyle in various functions.

	* Sven: 9458: Src/Zle/complete.c, Src/Zle/compresult.c: used freed
	memory in completion; should have been using heaps all along.

	* Sven: 9457: Src/params.c: tokenisation problem with patterns
	using parameter flag (K).

	* Sven: 9454: Completion/Core/_path_files: handling path prefixes
	with patterns more cleverly.

	* Sven: 9452: Completion/Base/_arguments: `--exclude=' shouldn't
	show both argument list and completions of --exclude....

	* Bart: 9448: Makefile.in: treat Test subdirectory along with
	others in make procedures (notably distclean).

	* Sven: 9442: Src/Zle/compresult.c: problems with suffixes when
	cursor style set.

	* Sven: 9441: Completion/Core/_files,
	Completion/User/_diff_options: _files sometimes didn't use
	ignored-patterns; use $(command diff) just in case, plus more
	verbose descriptions.

	* Alexandre: 9436: Completion/User/_prcs,
	Completion/User/_diff_options, Completion/User/_diff: prcs
	enhancements with builtin diff support, plus diff options for use
	directly with GNU diff.

2000-01-25  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Etc/FAQ.yo: updated from latest posted version.

	* Sven: 9424: Src/Modules/parameter.c: problems with 9421 with
	aliases and dir parameters.

2000-01-24  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 9421: Src/params.c: PM_REMOVABLE parameters are freeable
	since they were created by an ordinary createparam() (fixes
	memory leak).

	* Alexandre: 9419: Src/Zle/complist.c: more problems with
	backreferences in list-colors: aborts after failed backref,
	nested backrefs not handled.

	* Sven: 9417: Src/Zle/compcore.c: prefix code confused by matcher
	specifications.

	* Sven: 9416: Completion/Core/_setup, Src/Zle/complist.c: problems
	using backreferences in list-colors, check zsh/complist is loaded
	if needed.

	* Sven: 9415: Doc/Zsh/mod_complist.yo: typo in pattern example.

	* Sven: 9414: Completion/Core/_path_files: use _comp_ignore.

	* Sven: 9413: Functions/Zftp/zfinit, Src/Modules/zutil.c,
	Src/loop.c: cleanups for module name, new completion test,
	compilation warnings.

	* Sven: 9361: Src/exec.c: simplifty getoutput() test.

2000-01-23  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: Config/version.mk, Src/Modules/.distfiles: 3.1.6-dev-16;
	zprof.mdd, zfprof.c finally added to distribution.

2000-01-22  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* pws: 9408: Src/pattern.c, Doc/Zsh/expn.yo: failed
	backreferences, such as (...)# matching zero times or (|(...))
	matching first part of branch now set match to null string and
	indices to -1 instead of crashing the shell.

	* Clint: 9405: Makefile.in: $(DESTDIR) missing in front of
	$(sitefndir).

	* Tanaka Akira: 9404: Completion/Core/_path_files: `%' missing in
	parameter expansion.

2000-01-21  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Sven: 9403: Completion/Core/_path_files, Doc/Zsh/compsys.yo:
	brace problems with squeeze-slashes.

	* Sven: 9402: Completion/Builtins/_zstyle,
	Completion/Core/_path_files, Doc/Zsh/compsys.yo: ignore-parents
	style for more tunable path completion.

	* Sven: 9401: Src/Modules/parameter.c, Src/exec.c, Src/zsh.h: use
	list-based instead of function-based system for shell function
	wrappers.

	* Tanaka Akira: 9400: Completion/User/.distfiles: add _finger

	* Sven: 9399: Functions/Zftp/zfinit: bad reverse index.

	* Sven: 9398: Functions/Zftp/zfcd_match,
	Functions/Zftp/zfget_match: fix _description calls

	* Sven: 9397: Functions/Zftp/zfinit: incorrect zmodload for
	autoloaded builtin

	* Sven: 9396: Doc/Zsh/mod_zle.yo, Src/Zle/zle_main.c: better
	retrieval of history in vared.

	* Sven: 9395: Src/exec.c, Src/parse.c, Src/text.c: problems with
	ksh-format autoload and core dump due to bad termination in
	function execution.
	
	* Sven: 9388, 9389: Completion/User/_domains: try to completion
	host domains better.

2000-01-20  Peter Stephenson  <pws@pwstephenson.fsnet.co.uk>

	* Alexandre: 9387: Doc/Zsh/compsys.yo: document brace problems
	with 9383.

	* Sven: 9386: Completion/Core/_multi_parts,
	Completion/Core/_sep_parts: both functions support -F option.

